<?php
    define("DS", "/");

    $workDir = dirname(__FILE__);
    $pkgDir = dirname($workDir ) . DS . "ave_rsa_pkg";

    $updatesDir = $workDir . DS . "updates" . DS . "*";
    $verFile = $pkgDir . DS . "updates" . DS . "last-update-version.txt";
    $logFile = $pkgDir . DS . "updates" . DS . "last-run-log.txt";

    shell_exec('echo " " > ' . $logFile);
    function writeLog($text, $file = false){
        $logStr = date("Y-m-d H:i:s") . " > " . $text;

        print $logStr . "\n";
        if($file != false) {
            shell_exec('echo "' . $logStr . '" >> ' . $file);
        }
    }
    
    function getExt($fileName) {
        $ext = end(explode(".", $fileName));
        return $ext;
    }
    
    $lastVer = "0000-1.0.0";
    
    if(file_exists($verFile) && is_file($verFile)) {
        $lastVer = file_get_contents($verFile);
    }

    /*
    if($lastVer == "NOT-FOUND")  {
        writeLog('VERSION FILE [' . $verFile . '] NOT FOUND! Aborting update procedure...', $logFile);
        die();
    }
    */
    
    writeLog('LAST RUN STARTING AT: ' . date("Y-m-d H:i:s"), $logFile);

    $availableUpdates = glob($updatesDir, GLOB_ONLYDIR);
    asort($availableUpdates);

    foreach($availableUpdates as $availableUpdate) {
        writeLog("Checking update files in [" . $availableUpdate . "] ...", $logFile);
        $updateId = basename($availableUpdate);

        if($updateId > $lastVer) {
            writeLog("Running update files in [" . $availableUpdate . "] ...", $logFile);
            $auLogFile = $availableUpdate . "-log.txt";

            writeLog('Logging in: ' . $auLogFile, $logFile);

            shell_exec('echo "### STARTING UPDATE AT: ' . date("Y-m-d H:i:s") . '" >> ' . $auLogFile);
    
            $innerFiles = glob($availableUpdate . DS . "*");
            asort($innerFiles);;

            foreach($innerFiles as $innerFile) {
                $ext = getExt($innerFile);
                writeLog("Extension is [" . $ext . "]", $logFile);

                if($ext == "sh") {
                    writeLog("  ...running as SHELL file...", $logFile);
                    shell_exec('echo "Running SHELL file [' . $innerFile . '] ..." >> ' . $auLogFile);
                    shell_exec('/bin/bash ' . $innerFile . ' >> ' . $auLogFile);
                } else if($ext == "php") {
                    writeLog("  ...running as PHP file...", $logFile);
                    shell_exec('echo "Running PHP file [' . $innerFile . '] ..." >> ' . $auLogFile);
                    shell_exec('php -f ' . $innerFile . ' >> ' . $auLogFile);
                } else if($ext == "sql") {
                    writeLog("  ...running SQL file...", $logFile);
                    shell_exec('echo "Running SQL file [' . $innerFile . '] ..." >> ' . $auLogFile);
                    shell_exec('mysql -u root -paveroot2u < ' . $innerFile);
                }
            }

            shell_exec('echo "### UPDATE COMPLETED AT: ' . date("Y-m-d H:i:s") . '" >> ' . $auLogFile);
            shell_exec('echo " " >> ' . $auLogFile);
    
            file_put_contents($verFile, $updateId);
        } else {
            writeLog("Update files in [" . $availableUpdate . "] are out of date, ignoring...", $logFile);
        }
    }

    writeLog('LAST RUN COMPLETED AT: ' . date("Y-m-d H:i:s"), $logFile);

    shell_exec('echo " " >> ' . $logFile);


