<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
	
$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_SUPERVISORI);
$oApp->esegui();

/*********************************************************************************************************/
function backend_informazioni_ajax_info(&$oApp) {
    
    $systemInfo = shell_exec(DIR_WEB.'runasroot '.DIR_WEB.'info.sh');
    $threadInfo = shell_exec(DIR_WEB.'runasroot ps H -C yass3client -o pcpu -o comm ');
    $netstatInfo = shell_exec(DIR_WEB.'runasroot netstat -nap | grep yass3client');
    $netstatInfo = explode("\n", $netstatInfo);

    $updCount = [];
    if(file_exists('/tmp/yass3status')) {
        foreach(explode("\n", file_get_contents('/tmp/yass3status')) as $elm) {
            $elm = explode("|", $elm);
            $elm[0] = trim($elm[0]);

            $updCount[$elm[0]] = $elm;
        }
        
    }

    $netstatByIp = [];

    foreach($netstatInfo as $idx => $item){
        $netstatInfo[$idx] = preg_replace('/\s+/', ' ', $item);
        $netstatInfo[$idx] = explode(" ", $netstatInfo[$idx]);
        $dest = explode(":", @$netstatInfo[$idx][4]);

        $netstatByIp[$dest[0]] = $netstatInfo[$idx];
    }

    $threadInfo = explode("\n", $threadInfo);
    
    $supervisorsInfo = [];
    $oDb = $oApp->get("oDb");

    $oElencoSupervisori = new elencosupervisore($oApp, TRUE, ' ORDER BY ordine');
    if (!$oElencoSupervisori->isEmpty()) {
        //foreach ($oElencoSupervisori->getElenco() as $oSupervisore) {
        $supervisori = $oDb->eseguiselect("select supervisore.*, count(dispositivo.id_dispositivo) as numero_dispositivi from supervisore left join dispositivo on supervisore.id_supervisore = dispositivo.id_supervisore where supervisore.id_status = 1 group by id_supervisore", FALSE);
        foreach($supervisori as $oSupervisore) {
            $ip = $oSupervisore['ip'];
            $name = $oSupervisore['descrizione'];

            $supervisorsInfo[$ip]['id'] = $oSupervisore['id_supervisore'];
            $supervisorsInfo[$ip]['nome'] = $name;
            $supervisorsInfo[$ip]['numero_dispositivi'] = 0;
            $supervisorsInfo[$ip]['numero_dispositivi'] = $oSupervisore['numero_dispositivi'];;

            foreach($threadInfo as $threadInfoItem) {
                $cpu = trim(substr($threadInfoItem, 0, 5));

                $threadInfoItem = substr($threadInfoItem, 5);

                $threadInfoItem = explode(".", $threadInfoItem);
                if(count($threadInfoItem > 2)) {
                    if(@$threadInfoItem[1] + 0 == $oSupervisore['id_supervisore']) {
                        $supervisorsInfo[$ip]['thread_' . $threadInfoItem[0]] = 1;
                        
                    }

                    if(@$threadInfoItem[0] == "R" && @$threadInfoItem[1] + 0 == $oSupervisore['id_supervisore']) {
                        $supervisorsInfo[$ip]['cpu'] = $cpu;
                    }
                }
            }

        }
    }
    $color = "8cacca";
    ?>
    <div class="row">
        <div class="col col-4">
            <h2><?=$oApp->getEtichetta('INFO_TABELLA_SISTEMA')?></h2>
            <table class="table table-bordered">
                <tr>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_SISTEMA_PARAMETRO')?></th>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_SISTEMA_VALORE')?></th>
                </tr>
                <?php
                foreach(explode("\n", $systemInfo) as $item) {
                    $item = explode("=", $item);
                    $style = "";
                    if(@$item[0] && @$item[1]) {
                        if(@strtoupper($item[0]) == 'SERVER VERSION') {
                            $style = "background-color: #" . $color . ";";
                        }
                        ?>
                            <tr>
                                <td style="<?=$style?>"><strong><?=strtoupper($item[0])?></strong></td>
                                <td style="<?=$style?>"><?=@trim($item[1])?></td>
                            </tr>
                        <?php

                    }
                }
                ?>
                <tr>
                    <td style="background-color: #<?=$color?>;"><strong>WEB VERSION</strong></td>
                    <td style="background-color: #<?=$color?>;"><?=APP_VERSION?></td>
                </tr>
                <tr>
                    <td style="background-color: #<?=$color?>;"><strong>DB VERSION</strong></td>
                    <td style="background-color: #<?=$color?>;"><?=PARAM_DB_VERSION?></td>
                </tr>

            </table>
        </div>
        <div class="col col-8">
            <h2><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO')?></h2>
            <table class="table table-bordered">
                <tr>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO_NOME')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO_NUMERO_DISPOSITIVO')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO_CONNESSIONE')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO_THREAD_RUNNING')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO_THREAD_PING')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_APPLICATIVO_THREAD_CONF')?></td>
                    <th>CPU %</td>
                    <th>Num UPD</td>
                </tr>
                <?php
                foreach($supervisorsInfo as $idx => $item) {
                    $name = strtoupper($item['nome']);
                    if(strlen($name) > 30) {
                        $name = substr($name, 0, 30) . "...";
                    }
                    ?>
                        <tr>
                            <td><b><?=$name?></b>&nbsp;[IP:<?=$idx?>]</td>
                            <td><?=strtoupper($item['numero_dispositivi'])?></td>
                            <td style="text-align: center;"><?=@$netstatByIp[$idx] ? '<i style="color: green;" class="fa fa-1x fa-check-circle"></i>' : '<i style="color: orangered;" class="fa fa-1x fa-times-circle"></i>'?></td>
                            <td style="text-align: center;"><?=@$item['thread_R'] ? '<i style="color: green;" class="fa fa-1x fa-check-circle"></i>' : '<i style="color: orangered;" class="fa fa-1x fa-times-circle"></i>'?></td>
                            <td style="text-align: center;"><?=@$item['thread_P'] ? '<i style="color: green;" class="fa fa-1x fa-check-circle"></i>' : '<i style="color: orangered;" class="fa fa-1x fa-times-circle"></i>'?></td>
                            <td style="text-align: center;"><?=@$item['thread_C'] ? '<i style="color: yellow;" class="fa fa-1x fa-check-circle"></i>' : '<i style="color: silver;" class="fa fa-1x fa-times-circle"></i>'?></td>
                            <td><?=@trim($item['cpu'])?>%</td>
                            <td><?=@$updCount[$item['id']][2]?></td>
                        </tr>
                    <?php
                }
                ?>
            </table>

            <h2><?=$oApp->getEtichetta('INFO_TABELLA_RETE')?></h2>
            <table class="table table-bordered">
                <tr>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_RETE_TIPO')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_RETE_SORGENTE')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_RETE_DESTINAZIONE')?></td>
                    <th><?=$oApp->getEtichetta('INFO_TABELLA_RETE_STATO')?></td>
                </tr>
                <?php
                foreach($netstatInfo as $idx => $item) {
                    
                    if(count($item) >= 6){
                        $dest = explode(":", $item[4]);
                        
                        ?>
                            <tr>
                                <td><?=$item[0]?></td>
                                <td><?=$item[3]?></td>
                                <td>
                                    <?php
                                        if($dest[1] + 0 == 3306) {
                                            ?>
                                                <?=$item[4]?> <span class="pull-right badge badge-warning"><?=$oApp->getEtichetta('INFO_TABELLA_RETE_DATABASE')?></span>
                                            <?php
                                        } if($dest[1] + 0 == 7001) {
                                            $name = $supervisorsInfo[$dest[0]]['nome'];
                                            if(strlen($name) > 30) {
                                                $name = substr($name, 0, 30) . "...";
                                            }
                                            
                                            ?>
                                                <b><?=$name?></b>
                                                <?=$item[4]?> <span class="pull-right badge badge-success"><?=$oApp->getEtichetta('INFO_TABELLA_RETE_SUPERVISORE')?></span>
                                            <?php
                                        }
                                    ?>
                                </td>
                                <td><?=$item[5]?></td>
                            </tr>
                        <?php

                    }
                }
                ?>
            </table>
        </div>
    </div>
    <?php
    
}
?>