<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
$oApp = new app(TRUE);




$oApp->sezione(SEZIONE_ANTINCENDIO);
$oApp->disegna(TEMPLATE_STANDARD);


/*********************************************************************************************************/
function backend_relay_antincendio(&$oApp) {

    $error = @$_GET['error'];
    $success = @$_GET['success'];

    $faRules = $oApp->oDb->eseguiSelect("
        select r.*, 
        so.descrizione as descrizione_supervisore_origine, 
        sd.descrizione as descrizione_supervisore_destinazione, 
        sd.id_tipo_visualizzazione as tipo_visualizzazione_destinazione
        
        from relay r 
        left join supervisore so on r.id_supervisore_origine = so.id_supervisore 
        left join supervisore sd on r.id_supervisore_destinazione = sd.id_supervisore 
        where r.codice_sotto_tipo_origine = 'FA';   
    ");

    if(!MONO_EXISTS){
        ?> 
        <div style="text-align: center; font-size: 30px; padding-top: 58px; color: black !important;">
            <b>Supervisore Antincendio non disponibile</b><br>
            Framework MONO non presente sulla macchina
        </div>
        <?php
        return;
    }


    ?>
  

    <div class="widget-page card mb-3" id="widget_nuovo_abbinamento_reparto">
        <div class="card-header"><i class="fa fa-table"></i> 
            <a href="/" class="btn btn-dark btn-sm pull-right">&nbsp;<b>X</b>&nbsp;</a> 
            <?=getTxt('Fire alarm rules')?> 
        </div>
        <div class="card-body">
            <?php
                if(count($faRules) == 0) {
                    ?>
                        <hr>
                        <p>
                            <center><?=getTxt('No fire alarm rules defined')?></center>
                        </p>
                        <hr>
                    <?php
                }
                foreach($faRules as $faRule) {
                    $loopData = $faRule["evento_origine"];
                    $loopData = explode("-", $loopData);

                    ?>
                    
                    <div class="row mb-2 box-abbinamento-reparti">
                        <div class="col-xl-12">
                            <div class="row">
                                <div class="col-xl-5">
                                    <div class=" text-white bg-primary text-center abbinamento-reparti-box">
                                    <div class="">
                                        <div class="row">
                                            <div clas="col">
                                                 
                                                <i class="fa fa-fw fa-fire icona-fire fa-2x"></i>
                                                <i class="fa fa-arrow-right"></i> 
                                            </div>
                                            <div class="col"><b><?=$faRule["descrizione_supervisore_origine"]?></b> [Central unit: <?=$loopData[0]?> Loop: <?=$loopData[1]?> Device: <?=$loopData[2]?>]</div>
                                        </div>
                                    </div>
                                    </div>
                                </div>
                                <div class="col-xl-5">
                                    <div class=" text-white bg-secondary text-center abbinamento-reparti-box">
                                    <div class="">
                                        <div class="row">
                                            <div clas="col">
                                                 <i class="fa fa-arrow-right"></i> 
                                                <img style="margin-top: -9px; margin-bottom: -9px;" src="/img/<?=(($faRule["tipo_visualizzazione_destinazione"] == 1)?'ws.png':'ts01.png')?>" height="50">
                                            </div>
                                            <div class="col">
                                                <?=$faRule["descrizione_supervisore_destinazione"]?> 
                                                
                                                <button type="button" data-toggle="popover" title="MAPS" data-content="<?=str_replace(",", "<br>", $faRule["comando_destinazione"])?>"><i data-toggle="popover" class="fa fa-info"></i></button>
                                            </div>
                                        </div>
                                    </div>
                                    </div>
                                </div>
                                <div class="col-xl-2">
                                    <div class=" text-white bg-danger text-center abbinamento-reparti-box">
                                    <div class="">
                                        <div class="row">
                                            <div class="col">
                                                <a class="btn btn-danger btn-sm chiedi-conferma bottone_relay_elimina" href="/v2/api/delete_relay.php?id=<?=$faRule["id_relay"]?>">
                                                    <i class="fa fa-fw fa-trash-o  icon-white"></i>
                                                </a>
                                            </div>
                                        </div>
                                    </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    
                    <?php
                }
            ?>
        </div>
        <div class="card-footer small text-muted"></div>
    </div>


    <div class="widget-page card mb-3" id="widget_nuovo_abbinamento_reparto">
        <div class="card-header"><i class="fa fa-table"></i> <a href="/" class="btn btn-dark btn-sm pull-right">&nbsp;<b>X</b>&nbsp;</a> <?=getTxt('Add new fire alarm rule')?> </div>
        <div class="card-body">
            <form class="obiettivo_futuro form-horizontal themed standard" rel="relay inserisci" name="formInserisciRelay" id="formInserisciRelay" method="post" action="/v2/api/save_relay.php" novalidate="novalidate">
                <div class="row">
                    <div class="form-group col-xl-6">
                        <b><label class="control-label" for="id_supervisore_origine"><?=getTxt('Fire alarm controller')?><span class="req">*</span></label></b>
                        <div class="controls">
                            <label class="control-label" for="id_supervisore_origine"><?=getTxt('Supervisor')?><span class="req">*</span></label>
                            <select name="id_supervisore_origine" id="id_supervisore_origine" class="form-control"></select>
                        </div>
                        <div class="controls">
                            <label class="control-label" for="id_origin_device_loop"><?=getTxt('Central unit / Loop')?><span class="req">*</span></label>
                            <select name="id_origin_device_loop" id="id_origin_device_loop" class="form-control"></select>
                        </div>
                        <div class="controls">
                            <label class="control-label" for="id_origin_item_number"><?=getTxt('Device')?><span class="req">*</span></label>
                            <select name="id_origin_item_number" id="id_origin_item_number" class="form-control"></select>
                        </div>
                    </div>
                    <div class="form-group col-xl-6">
                        <b><label class="control-label" for="id_supervisore_destinazione"><?=getTxt('Destination department')?><span class="req">*</span></label></b>
                        <div class="controls">
                            <label class="control-label" for="id_supervisore_destinazione"><?=getTxt('Supervisor')?><span class="req">*</span></label>
                            <select name="id_supervisore_destinazione" id="id_supervisore_destinazione" class="form-control"></select>
                        </div>
                        <div class="controls">
                            <label class="control-label" for="destination_message"><?=getTxt('Sensor description')?><span class="req">*</span></label>
                            <input name="destination_message" id="destination_message" class="form-control"/>
                        </div>
                    </div>
                </div>
                <fieldset class="hidden">
                    <div class="row">
                    <div class="controls hidden"><input class="hidden-input" name="data_creazione" id="data_creazione" value="2018-10-30 12:18:36" type="hidden"></div>
                    <div class="controls hidden"><input class="hidden-input" name="data_ultima_modifica" id="data_ultima_modifica" value="2018-10-30 12:18:36" type="hidden"></div>
                    </div>
                    <div class="row">
                    <div class="controls hidden"><input class="hidden-input" name="id_utente_creatore" id="id_utente_creatore" value="1" type="hidden"></div>
                    <div class="controls hidden"><input class="hidden-input" name="id_utente_ultima_modifica" id="id_utente_ultima_modifica" value="1" type="hidden"></div>
                    </div>
                    <div class="row">
                    <div class="controls hidden"><input class="hidden-input" name="id_utente_proprietario" id="id_utente_proprietario" value="1" type="hidden"></div>
                    <div class="controls hidden"><input class="hidden-input" name="nome_form" id="nome_form" value="RELAY_ABBINAMENTO" type="hidden"></div>
                    </div>
                </fieldset>
                <fieldset class="bottoni">

                    <div class="form-actions">
                        <?php
                        if($error) {
                            ?>
                                <div class="alert alert-danger">
                                    <? 
                                    if($error == 'select_supervisors') {
                                        echo getTxt('A value is required fo Fire alarm controller and a Destination department fields'); 
                                    } else if($error == 'has_conflicts') {
                                        echo getTxt('The rule you are trying to add is conflicting with an existing one. If you want to create this new rule please delete the conflicting one before'); 
                                    } else if($error == 'bad_supervisors') {
                                        echo getTxt('Bad supervisors selected (maybe misconfigured supervisors?)'); 
                                    } else if($error == 'general') {
                                        echo getTxt('General error'); 
                                    }
                                    ?>
                                </div>
                            <?php
                        }
                        if($success) {
                            ?>
                                <div class="alert alert-success">
                                    <? 
                                    if($success == 'save_ok') {
                                        echo getTxt('The fire alarm rule is correctly stored'); 
                                    }  
                                    ?>
                                </div>
                            <?php
                        }
                        ?>
                        
                        <button id="buttonInserisciRelayInserisci" class="btn medium btn-primary" type="submit"><i class="icon-ok"></i> Salva</button>
                    
                    </div>

                </fieldset>
            </form>
            <div id="supervisorSelectionError"></div>
        </div>
        <div class="card-footer small text-muted"></div>
    </div>



    <script>
        document.addEventListener("DOMContentLoaded", function() {
            jQuery.getJSON("/v2/api/supervisors.php", function( supervisorData ) {
                var emptyOption = '<option value="">--- <?=getTxt('select')?> ---</option>';

                jQuery("#id_supervisore_origine").html(emptyOption);
                jQuery("#id_supervisore_destinazione").html(emptyOption);

                for(i = 0; i < supervisorData.length; i++) {
                    newOption = '<option value="' + supervisorData[i].id_supervisore + '">' + supervisorData[i].descrizione + '</option>';
                    
                    if(supervisorData[i].id_tipo_dispositivo == -1) {
                        jQuery("#id_supervisore_origine").html(jQuery("#id_supervisore_origine").html() + newOption);
                    } else if(supervisorData[i].id_tipo_dispositivo > -1) {
                        jQuery("#id_supervisore_destinazione").html(jQuery("#id_supervisore_destinazione").html() + newOption);
                    }
                    
                }

                

                jQuery('#id_supervisore_origine').unbind();
                jQuery('#id_supervisore_origine').change(function(){
                    jQuery("#id_origin_device_loop").html("");
                    jQuery("#id_origin_item_number").html("");

                    newOption = '<option value="*-*"><?=getTxt('All central units and loops')?></option>';
                    jQuery("#id_origin_device_loop").html(jQuery("#id_origin_device_loop").html() + newOption);

                    for(i=1;i<=32;i++)  {
                        for(j=1;j<=4;j++)  {
                            newOption = '<option value="' + i + '-' + j + '"><?=getTxt('Central unit')?>: ' + i + ' <?=getTxt('Loop')?>: ' + j + '</option>';
                            jQuery("#id_origin_device_loop").html(jQuery("#id_origin_device_loop").html() + newOption);
                        }
                    }

                    newOption = '<option value="*"><?=getTxt('All Devices')?></option>';
                    jQuery("#id_origin_item_number").html(jQuery("#id_origin_item_number").html() + newOption);

                    for(i=1;i<=256;i++)  {
                        newOption = '<option value="' + i + '"><?=getTxt('Device')?>: ' + i + '</option>';
                        jQuery("#id_origin_item_number").html(jQuery("#id_origin_item_number").html() + newOption);
                    }
                    
                    

                });
            });

            jQuery(document).ready(function(){
                jQuery('[data-toggle="popover"]').popover({
                    html:true
                });   
            });
                
        });
    </script>


    <?php


}