<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_SISTEMA);
$oApp->disegna(TEMPLATE_STANDARD);

/*********************************************************************************************************/
function backend_sistema_elenco(&$oApp) {
    $oApp->apriWidget('configurazioni', $oApp->getEtichetta('TABELLA_CONFIGURAZIONI'), FALSE, FALSE, FALSE, FALSE);
    $today = getdate();
    ?>
    <div class="row text-center mt-4">
        <div class="col-xl-12">
            <h2 class="impostazioni-titolo"><?=$oApp->getEtichetta('AZIONI')?></h2>
        </div>
    </div>
    <div class="row justify-content-center">
        <div class="col-2 text-right mb-3">
            <?php
            $id = strtoupper('BOTTONE_RIAVVIA_SERVER');
            echo bottone($oApp, $id, $id);
            ?>
        </div>

        <div class="col-2 text-left mb-3">
            <?php
            $id = strtoupper('BOTTONE_RIAVVIA_CLIENT');
            echo bottone($oApp, $id, $id);
            ?>
        </div>
        <div class="col-2 text-left mb-3">
            <?php
            $id = strtoupper('BOTTONE_RESETTA_MODO');
            echo bottone($oApp, $id, $id, FALSE, FALSE, TRUE, NULL, "/");
            ?>
        </div>
        <div class="col-2 text-left mb-3">
            <a id="BOTTONE_RESETTA_ARCHIVIO" href="/backend/azioni/clear_database.php" class="btn btn-danger btn-xl col-12" onclick="return confirm('<?=utf8_encode($oApp->getEtichetta('RESETTA_DATABASE_ALERT'))?>')">
                <?=$oApp->getEtichetta('RESETTA_DATABASE')?>
            </a>
        </div>
    </div>
    <div class="row text-center mt-4">
        <div class="col-xl-12">
            <h2 class="impostazioni-titolo"><?=str_replace('##LINGUA_NAVIGAZIONE##',strtoupper($GLOBALS['LINGUE_NOMI'][$_SESSION['LINGUA_NAVIGAZIONE']]),$oApp->getEtichetta('LINGUA_NAVIGAZIONE_SELEZIONATA'))?></h2>
        </div>
    </div>
    <div class="row text-center">
        <?php
        $nLingue = count(unserialize(LINGUE_ATTIVE));
        foreach (unserialize(LINGUE_ATTIVE) as $lingua) {
            echo '<div class="col-xl-'.ceil(12/$nLingue).'">';
            echo '<a class="btn btn-outline-primary" href="'.URL_AZIONI.'lang.php?l='.$lingua.'"><img src="/img/' . $lingua . '.png" style="height: 24px;"><br>'.$GLOBALS['LINGUE_NOMI'][$lingua].'</a>';
            echo '</div>';
        }
        ?>
    </div>
    <div class="row text-center mt-4">
        <div class="col-xl-12">
            <h2 class="impostazioni-titolo"><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA')?></h2>
        </div>
    </div>
    <div class="row text-center" style="text-align: center;">
        <form method="post" action="<?=URL_AZIONI?>datetime.php" style="margin: auto;">
            <table class="table">
            
                <tr>
                    <th><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA_ANNO')?></th>
                    <th></th>
                    <th><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA_MESE')?></th>
                    <th></th>
                    <th><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA_GIORNO')?></th>
                    <th></th>
                    <th><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA_ORE')?></th>
                    <th></th>
                    <th><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA_MINUTI')?></th>
                    <th></th>
                    <th><?=$oApp->getEtichetta('IMPOSTAZIONE_DATA_ORA_SECONDI')?></th>
                </tr>
                <tr>
                    <td>
                        <select id="fieldSetYear"  name="setYear" class="form-control">
                            <?php for ($i = 2000; $i < 2100; $i++) { ?> <option <?=$today['year'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
                        </select>
                    </td>
                    <td class="date-sep-col">/</td>
                    <td>
                        <select id="fieldSetMonth" name="setMonth" class="form-control">
                            <?php for ($i = 1; $i <= 12; $i++) {   ?> <option <?=$today['mon'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
                        </select>
                    </td>
                    <td class="date-sep-col">/</td>
                    <td>
                        <select id="fieldSetDay" name="setDay" class="form-control">
                            <?php for ($i = 1; $i <= 31; $i++) { ?> <option <?=$today['mday'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
                        </select>
                    </td>
                    <td class="date-sep-col">&nbsp;&nbsp;&nbsp;&nbsp;</td>
                    <td>
                        <select id="fieldSetHours" name="setHours" class="form-control">
                            <?php for ($i = 0; $i <= 23; $i++) { ?> <option <?=$today['hours'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
                        </select>
                    </td>
                    <td class="date-sep-col">:</td>
                    <td>
                        <select id="fieldSetMinutes" name="setMinutes" class="form-control">
                            <?php for ($i = 0; $i <= 59; $i++) {   ?> <option <?=$today['minutes'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
                        </select>
                    </td>
                    <td class="date-sep-col">:</td>
                    <td>
                        <select id="fieldSetSeconds" name="setSeconds" class="form-control">
                            <?php for ($i = 0; $i <= 59; $i++) { ?> <option <?=$today['seconds'] == $i ? 'selected' : '' ?>><?=$i?></option> <?php } ?>
                        </select>
                    </td>
                </tr>
    
            </table>
            <button class="btn btn-success" type="submit"><?=$oApp->getEtichetta('INVIA_IMPORTAZIONE_DATA_ORA')?></button>
            <button class="btn btn-primary" id="btnReadDateTimeFromComputer" ><?=$oApp->getEtichetta('LEGGI_DATA_ORA_DA_PC')?></button>


            
            <?php
                
            ?>
        </form>
    </div>

    <div class="row text-center mt-4">
        <div class="col-xl-12">
            <h2 class="impostazioni-titolo"><?=$oApp->getEtichetta('IMPOSTA_INDIRIZZO_IP')?></h2>
        </div>
    </div>
    <div class="row text-center" style="text-align: center;">
        <div style="margin: auto;">
            <?php

                $raw = shell_exec("/sbin/ifconfig eth0 | grep \"inet addr:\"");
                $raw = str_replace("inet addr", "IpAddr", $raw);

                $raw = explode(" ", $raw);
                $ipData = [];

                foreach($raw as $idx => $item) {
                    $item = explode(":", $item);
                    if(@$item[0]) {
                        $ipData[trim(strtolower($item[0]))] = trim($item[1]);
                    }
                }

                $raw = shell_exec("ip route show | grep default");
                $raw = explode(" ", trim($raw));

                $ipData['gateway'] = $raw[2];
                $ipData['dns'] = shell_exec("cat /etc/resolv.conf |  awk {'print $2'}");
                $ipData['mode'] = (trim(shell_exec("cat /etc/network/interfaces | grep 'eth0 inet' | awk {'print $4'}")) == 'static' ? 'static' : 'dhcp');


            ?>
            <table>
                <tr>
                    <td style="text-align: right">Mode </td>
                    <td style="padding: 0px 24px 0px 24px; ">
                        <select class="form-control" id="setMode" name="setMode">
                            <option value="dhcp" <?=$ipData['mode'] == 'dhcp' ? 'selected' : ''?> >DHCP</option>
                            <option value="static" <?=$ipData['mode'] == 'static' ? 'selected' : ''?> >STATIC</option>
                        </select>
                    </td>
                </tr>
                <tr>
                    <td style="text-align: right">IP </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['ipaddr']?>" class="form-control" id="setIp" name="setIp"></td>
                </tr>
                <tr>
                    <td style="text-align: right">Network Mask </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['mask']?>" class="form-control" id="setMask" name="setMask"></td>
                </tr>
                <tr>
                    <td style="text-align: right">Gateway </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['gateway']?>" class="form-control" id="setGateway" name="setGateway"></td>
                </tr>
                <tr>
                    <td style="text-align: right">DNS </td>
                    <td style="padding: 0px 24px 0px 24px; "><input value="<?=$ipData['dns']?>" class="form-control" id="setDNS" name="setDNS"></td>
                </tr>
                <tr>
                <td style="text-align: right"> </td>
                <td style="text-align: right">
                    <center>
                        <button id="setIpButton" class="btn btn-warning">Set</button>
                        <div id="assignIpResult"></div>
                    </center>
                </td>
                </tr>

            </table>
        </div>
    </div>

    <div class="row text-center mt-4">
        <div class="col-xl-12">
            <h2 class="impostazioni-titolo"><?=$oApp->getEtichetta('CARICA_AGGIORNAMENTO_SOFTWARE')?></h2>
        </div>
    </div>
    <div class="row text-center" style="text-align: center;">
        <form id="fileUploadForm" action="<?=URL_AZIONI?>carica_software.php" method="post" enctype="multipart/form-data" style="margin: auto;">
            
            <table>
                <tr>
                    <td><?=$oApp->getEtichetta('CARICA_AGGIORNAMENTO_SOFTWARE_LABEL')?></td>
                    <td style="padding: 0px 24px 0px 24px; "><input class="form-control" type="file" id="softwareUploadField" name="softwareUploadField"></td>
                    <td><span id="fileUploadLoadingSpinner"></span> <button id="fileUploadButton" class="btn btn-warning" ><?=$oApp->getEtichetta('CARICA_AGGIORNAMENTO_SOFTWARE_BTN')?></button></td>
                </tr>
                <tr>
                    <td style="padding: 24px; font-weight: bold; " id="fileUploadErrorMessage" colspan="3" style="text-align: center; ">
                    
                    </td>
                </tr>
            </table>
        </form>
    </div>

    <script>
        document.addEventListener("DOMContentLoaded", function() {

            jQuery('#BOTTONE_RIAVVIA_SERVER').attr('title', '<?=$oApp->getEtichetta('TOOLTIP_BOTTONE_RIAVVIA_SERVER')?>');
            jQuery('#BOTTONE_RIAVVIA_SERVER').tooltip();

            jQuery('#BOTTONE_RIAVVIA_CLIENT').attr('title', '<?=$oApp->getEtichetta('TOOLTIP_BOTTONE_RIAVVIA_CLIENT')?>');
            jQuery('#BOTTONE_RIAVVIA_CLIENT').tooltip();

            jQuery('#BOTTONE_RESETTA_MODO').attr('title', '<?=$oApp->getEtichetta('TOOLTIP_BOTTONE_RESETTA_MODO')?>');
            jQuery('#BOTTONE_RESETTA_MODO').tooltip();

            jQuery('#BOTTONE_RESETTA_ARCHIVIO').attr('title', '<?=$oApp->getEtichetta('TOOLTIP_BOTTONE_RESETTA_ARCHIVIO')?>');
            jQuery('#BOTTONE_RESETTA_ARCHIVIO').tooltip();




            jQuery('#btnReadDateTimeFromComputer').click(function(ev){
                ev.preventDefault()
                var dt = new Date();
                jQuery('#fieldSetYear').val(dt.getFullYear());
                jQuery('#fieldSetMonth').val(dt.getMonth() + 1);
                jQuery('#fieldSetDay').val(dt.getDate());
                jQuery('#fieldSetHours').val(dt.getHours());
                jQuery('#fieldSetMinutes').val(dt.getMinutes());
                jQuery('#fieldSetSeconds').val(dt.getSeconds());
            });

            function resetFileUploadForm() {
                jQuery('#fileUploadLoadingSpinner').html('');
                jQuery('#fileUploadButton').show();
            }

            function fleUploadFormPleaseWait() {
                jQuery('#fileUploadLoadingSpinner').html('<i class="fa fa-spinner fa-pulse fa-2x"></i>');
                jQuery('#fileUploadButton').hide();
            }

            $('#setIpButton').click(function(ev) {

                ev.preventDefault();
                if(confirm("Sicuro di voler procedere?")) {
                    dhcpMode = jQuery("#setMode").val() == 'static' ? '0' : '1';
                    setIpUrl = "/azioni/setip.php?dhcp=" + dhcpMode + "&ip=" + jQuery("#setIp").val() + "&mask=" + jQuery("#setMask").val() + "&gw=" + jQuery("#setGateway").val() + "&dns=" + jQuery("#setDNS").val();

                    jQuery("#assignIpResult").html("Attendere <i class=\"fa fa-spinner fa-spin\"></i> ");
                    
                    $.ajax({
                        url: setIpUrl,
                        error: function(){
                            jQuery("#assignIpResult").html("Parametri di rete inviati corettamente, premi <a href=\"http://" + jQuery("#setIp").val() + "\">qui</a> per ricaricare la pagina. ");
                            jQuery("#assignIpResult").attr("class", "text-success font-weight-bold");
                        },
                        success: function(data){
                            if(data == 'OK') {
                                jQuery("#assignIpResult").html("Parametri di rete inviati corettamente, premi <a href=\"http://" + jQuery("#setIp").val() + "\">qui</a> per ricaricare la pagina. ");
                                jQuery("#assignIpResult").attr("class", "text-success font-weight-bold");
                            } 
                            if(data.substring(0, 2) == 'KO') {
                                jQuery("#assignIpResult").attr("class", "text-danger font-weight-bold");
                            }
                            
                            if(data == 'KO1') { jQuery("#assignIpResult").html("Errore: parametri non riconosciuti. "); }
                            if(data == 'KO2') { jQuery("#assignIpResult").html("Errore: parametri mancanti per l'indirizzo statico. "); }
                            if(data == 'KO3') { jQuery("#assignIpResult").html("Errore: parametro modo statico/dhcp non definito. "); }
                        },
                        timeout: 10000 //in milliseconds
                    });
                }

            });

            $("#fileUploadForm").fileUpload({
                //uploadData    : { 'extra_data' : 'blah' }, // Append POST data to the upload
                //submitData    : { 'moar_extra_data' : 'blah' }, // Append POST data to the form submit
                //uploadOptions : { dataType : 'json' }, // Customise the parameters passed to the $.ajax() call on uploads. You can use any of the normal $.ajax() params
                //submitOptions : { dataType : 'json' }, // Customise the parameters passed to the $.ajax() call on the form submit. You can use any of the normal $.ajax() params
                before	      : function(){
                    jQuery('#fileUploadErrorMessage').html('<p class="text-primary"><?=$oApp->getEtichetta('CARICA_AGGIORNAMENTO_SOFTWARE_ATTENDERE')?></p>');
                    fleUploadFormPleaseWait()
                },  
                beforeSubmit  : function(uploadData){ 
                    if(uploadData['status'] == 'file_upload_post' && uploadData['saved_files'] == 1 && uploadData['error_files'] == 0) {
                        jQuery('#fileUploadErrorMessage').html('<p class="text-success"><?=$oApp->getEtichetta('CARICA_AGGIORNAMENTO_SOFTWARE_RIUSCITO')?></p>');
                    } else {
                        jQuery('#fileUploadErrorMessage').html('<p class="text-danger"><?=$oApp->getEtichetta('CARICA_AGGIORNAMENTO_SOFTWARE_FALLITO')?></p>');
                    }

                    resetFileUploadForm();
                    return false; 
                }, 
                success       : function(data, textStatus, jqXHR){ 
                    resetFileUploadForm();
                }, 
                error 	      : function(jqXHR, textStatus, errorThrown){ 
                    resetFileUploadForm();
                }, 
                complete      : function(jqXHR, textStatus){ 
                    
                    resetFileUploadForm();
                } 
            });       
        });
    
    </script>
    
    <?php

    $oApp->chiudiWidget();
}
?>