<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->sezione(SEZIONE_STATISTICHE);
$oApp->esegui();

/*********************************************************************************************************/
function array_to_html_properties($arr, $prefix = "data-") {
    $res = [];
    foreach($arr as $k => $v) {
        $res[] = $prefix . $k . '="' . $v . '"';
    }
    return implode(" ", $res);
}

function backend_statistiche_alarms_table(&$oApp) {

    
    $result = [];
    $itemsPerPage = 20;

    
    $req = $_REQUEST;
    
    if(!@$req['t']) $req['t'] = 'all';
    if(!@$req['p']) $req['p'] = 1;

    if(!@$req['from']) $req['from'] = date('d-m-Y', strtotime('-90 day'));
    if(!@$req['to']) $req['to'] = date('d-m-Y');
    
    $result['params'] = $req;
    $result['paginator'] = [];
    
    $where = " where true ";

    $limit = "";

    $sql = '
        select log_allarmi.*, 
        supervisore.descrizione as supervisore_descrizione,
        supervisore.ip as supervisore_ip,
        dispositivo.descrizione as dispositivo_descrizione ,
        if(risolto = "0000-00-00 00:00:00", "attivo", "risolto") status,
        supervisore.id_tipo_dispositivo as tipo_supervisore
        from log_allarmi 
        left join supervisore on supervisore.id_supervisore = log_allarmi.id_supervisore
        left join dispositivo on dispositivo.id_dispositivo = log_allarmi.id_dispositivo
    ';

    $countSql = "select count(*) as row_count from log_allarmi";

    switch ($req['t']) {
        case 'active_alarms':
            $where .= " and log_allarmi.allarme_sistema = 0 ";
            $where .= " and log_allarmi.risolto = '0000-00-00 00:00:00' ";
        break;
        case 'calls_and_failures':
            $where .= " and log_allarmi.allarme_sistema = 0 ";
        break;
        case 'system_events':
            $where .= " and log_allarmi.allarme_sistema = 1 ";
        break;
        case 'all':

        break;
    }

    $d = new DateTime($req['from']);
    $where .= " and date(log_allarmi.data) >= ".date2db($d->format('Y-m-d')) . " ";
    $d = new DateTime($req['to']);
    $where .= " and date(log_allarmi.data) <= ".date2db($d->format('Y-m-d')) . " ";
    
    $limit .= " order by log_allarmi.data desc limit " . (($req['p'] - 1) * $itemsPerPage) . ", " . $itemsPerPage;

    $result['data'] = $oApp->oDb->eseguiselect($sql . $where . $limit);

    // $result['select'] = $sql . $where . $limit;

    foreach($result['data'] as $idx => $val) {
        $result['data'][$idx]['css'] = "";

        if(@$val['status']) {
            $result['data'][$idx]['css'] .= " status-allarme-" . strtolower($val['status']);
        }
        $result['data'][$idx]['css'] .= " allarme-" . strtolower(str_replace([":", "_"], "-", $val['tipo_allarme']));

        
        if($result['data'][$idx]['tipo_supervisore'] + 0 == -1){
            $alText = explode("-", $result['data'][$idx]['tipo_allarme']);
            foreach($alText as $atIdx => $atItem) {
                $alText[$atIdx] = trim($atItem);
            }
            
            if($alText[0] == "1") {
                $result['data'][$idx]['css'] = "allarme-fa-failure"; 
                $alText[0] = "Failure";
            }
            if($alText[0] == "2") {
                $result['data'][$idx]['css'] = "allarme-fa-alarm";
                $alText[0] = "Alarm";
            }


            $result['data'][$idx]['dispositivo_descrizione'] = trim(base64_decode($alText[1])) . "<br>" . trim(base64_decode($alText[2]));
            $result['data'][$idx]['text'] = $alText[0];
        
        } else {
            $result['data'][$idx]['text'] = @$oApp->getEtichetta('TIPO_ALLARME_'.strtoupper($val['tipo_allarme']));
        }

    }

    $result['page_count'] = ceil(($oApp->oDb->eseguiselect($countSql . $where)[0]['row_count']) / $itemsPerPage);

    $paginatorPars = $req;

    $paginatorPars['p'] = 1;
    $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => '&laquo;', 'params' => array_to_html_properties($paginatorPars) ];
    
    $paginatorPars['p'] = max(1, $req['p'] - 10);
    $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => '&lt;', 'params' => array_to_html_properties($paginatorPars)  ];
    
    if(max(1, $req['p'] - 5) > 1) {
        $paginatorPars['p'] = false;
        $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => '...', 'disabled' => "1", 'params' => array_to_html_properties($paginatorPars)  ];
    }

    for($i = max(1, $req['p'] - 5); $i <= min($result['page_count'], $req['p'] + 5); $i++) {
        $paginatorPars['p'] = $i;
        $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => $i, 'active' => ($i == $req['p'] ? 1 : 0), 'params' => array_to_html_properties($paginatorPars)  ];
    }

    if(min($result['page_count'], $req['p'] + 5) < $result['page_count']) {
        $paginatorPars['p'] = false;
        $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => '...', 'disabled' => "1", 'params' => array_to_html_properties($paginatorPars)  ];
    }
    
    $paginatorPars['p'] = min($result['page_count'], $req['p'] + 10);
    $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => '&gt;', 'params' => array_to_html_properties($paginatorPars)  ];

    $paginatorPars['p'] = $result['page_count'];
    $result['paginator'][] = [ 'page' => $paginatorPars['p'], 'name' => '&raquo;', 'params' => array_to_html_properties($paginatorPars)  ];


    header('Content-Type: application/json');
    echo json_encode($result);
    die;

}
?>