<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE);
$oApp->sezione(SEZIONE_STATISTICHE);
$oApp->disegna(TEMPLATE_STANDARD);

/*********************************************************************************************************/
function backend_statistiche_allarmi(&$oApp) {

    $oApp->apriWidget('statistiche', $oApp->getEtichetta('FILTRA_STATISTICHE_ALLARMI'), FALSE, FALSE, FALSE, FALSE);
    
    if (empty($_POST)) {
        $_POST['filtro_data_da'] = date('d-m-Y', strtotime('-3 day'));
        $_POST['filtro_data_a'] = date('d-m-Y');
    }
    
    $req = $_REQUEST;

    //print "<pre>" . print_r($req, true) . "</pre>";
    
    if(!@$req['type']) {
        $req['type'] = "all";
    }
    
    ?>
    
        <form   class="obiettivo_futuro form-horizontal themed standard" 
            rel="logallarme ricerca" 
            name="formricercaLogallarme" 
            id="formricercaLogallarme" 
            method="post" 
            action="" novalidate="">
            <div class="row">
                <div class="form-group col">
                    <label class="control-label" for="filtro_data_da"><?=$oApp->getEtichetta('FORM_DATA_DA')?></label>
                    <div class="controls">
                        <div class="input-group date datepicker-js" id="datetimepicker-filtro_data_da" data-target-input="nearest">
                            <input type="text" class="form-control datetimepicker-input" name="filtro_data_da" data-target="#datetimepicker-filtro_data_da" value="<?=@$req['filtro_data_da']?>" placeholder="<?=$oApp->getEtichetta('PLACEHOLDER_DATEPICKER')?>"> 
                            <div class="input-group-append" data-target="#datetimepicker-filtro_data_da" data-toggle="datetimepicker">
                                <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group col">
                    <label class="control-label" for="filtro_data_a"><?=$oApp->getEtichetta('FORM_DATA_A')?></label>
                    <div class="controls">
                        <div class="input-group date datepicker-js" id="datetimepicker-filtro_data_a" data-target-input="nearest">
                            <input type="text" class="form-control datetimepicker-input" name="filtro_data_a" data-target="#datetimepicker-filtro_data_a" value="<?=@$req['filtro_data_a']?>" placeholder="<?=$oApp->getEtichetta('PLACEHOLDER_DATEPICKER')?>">
                            <div class="input-group-append" data-target="#datetimepicker-filtro_data_a" data-toggle="datetimepicker">
                                <div class="input-group-text"><i class="fa fa-calendar"></i></div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="form-group col-md-1">
                    <label class="control-label" for="filtro_data_a">&nbsp;</label>
                    <div class="controls">
                        <button id="buttonRicercaLogallarmeRicerca" class="btn medium btn-primary" type="submit">
                            <i class="icon-search"></i> Cerca
                        </button>
                    </div>

                    
                </div>
            </div>
            
        </form>
    
    <?php


    /*
    $oLogAllarme = new logallarme($oApp);
    $oLogAllarme->initByRecord($req);
    $oLogAllarme->getFormFiltro();
    */

    $oApp->chiudiWidget();

    $oApp->apriWidget('statistiche', $oApp->getEtichetta('TABELLA_STATISTICHE_ALLARMI'), FALSE, FALSE, FALSE, FALSE);
    
    ?>
    <div id="tableContainer">
        <div class="row">
            <div class="col col-4">
                <div id="tableDownloaderContainer">
                    <a id="tableDownloaderContainerBtn" class="btn btn-sm btn-success" href=""><i class="fa fa-download"></i></a>
                </div>
            </div>
            <div class="col col-8">
                <div id="tablePaginatorContainer"></div>
            </div>
        </div>
        <table class="table table-striped">
            <thead>
                <tr>
                    <th>#</th>
                    <th><?=$oApp->getEtichettaTabella('DATA_ORDINABILE')?></th>
                    <th><?=$oApp->getEtichettaTabella('DENOMINAZIONE_SUPERVISORE')?></th>
                    <th><?=$oApp->getEtichettaTabella('DENOMINAZIONE_DISPOSITIVO')?></th>
                    <th><?=$oApp->getEtichettaTabella('TIPO_ALLARME_DECODED')?></th>
                    <th><?=$oApp->getEtichettaTabella('RISOLTO_DECODED')?></th>
                </tr>
            </thead>
            <tbody id="tableBodyContainer">
                
            </tbody>
        </table>
        
    </div>
    <?php


    
    $oApp->chiudiWidget();

    $htmlJs = $oApp->get('htmlJscript');
  
    ob_start();
    ?>
        <script>
            jQuery(function(){
                jQuery('#datetimepicker-filtro_data_da').datetimepicker({format: 'DD-MM-YYYY'});
                jQuery('#datetimepicker-filtro_data_a').datetimepicker({format: 'DD-MM-YYYY'});

                function drawTable(data) {
                    res = "";
                    i = 0;

                    for(i=0; i<data.data.length; i++) {
                        statoAllarme = '';

                        if(data.data[i].allarme_sistema == "0") {
                            if(data.data[i].status == 'attivo') {
                                statoAllarme = '<center><span class="badge badge-danger badge-logallarme">\
                                                    <i class="fa fa-fw fa-check-circle-o"></i>&nbsp;<?=$oApp->getEtichetta('ALLARME_ATTIVO')?>&nbsp;' + data.data[i].data + '\
                                                </span></center>';
                            } else {
                                statoAllarme = '<center><span class="badge badge-secondary badge-logallarme">\
                                                    <i class="fa fa-fw fa-check-circle-o"></i>&nbsp;<?=$oApp->getEtichetta('ALLARME_GENERATO_IL')?>&nbsp;' + data.data[i].data + '\
                                                </span><br>\
                                                <span class="badge badge-success badge-logallarme">\
                                                    <i class="fa fa-fw fa-check-circle-o"></i>&nbsp;<?=$oApp->getEtichetta('ALLARME_RISOLTO_IL')?>&nbsp;' + data.data[i].risolto + '\
                                                </span></center>';
                            }
                        } else {
                            statoAllarme = '<center><span class="badge badge-primary badge-logallarme" style="background-color: #8cacca; ">\
                                                <i class="fa fa-fw fa-check-circle-o"></i>&nbsp;<?=$oApp->getEtichetta('EVENTO_GENERATO_IL')?>&nbsp;' + data.data[i].data + '\
                                            </span>';
                        }


                        devDescr = data.data[i].dispositivo_descrizione;
                        if(devDescr == 'null' || devDescr == null || devDescr == undefined || devDescr == "") {
                            devDescr = 'N/A';
                        }

                        supDescr = data.data[i].supervisore_descrizione;
                        if(supDescr == 'null' || supDescr == null || supDescr == undefined || supDescr == "") {
                            supDescr = '---';
                        } else {
                            supDescr = data.data[i].supervisore_descrizione + '<br><small>(' + data.data[i].supervisore_ip + ')</small>';
                        }

                        res += '<tr class="' + data.data[i].css + '">\
                                    <td>' + data.data[i].id_log_allarme + '</td>\
                                    <td>' + data.data[i].data + '</td>\
                                    <td>' + supDescr + '</td>\
                                    <td>' + devDescr + '</td>\
                                    <td>' + data.data[i].text + '</td>\
                                    <td>' + statoAllarme + '</td>\
                                </tr>';
                    }

                    return res;
                }

                function drawPaginator(data) {
                    res = "";
                    for(i = 0; i < data.paginator.length; i ++) {
                        pag = data.paginator[i];
                        res += '<a class="' + (pag.disabled == 1? 'disabled' : '') + ' paginatorBtn btn btn-sm btn-' + (pag.active == 1? 'primary' : 'outline-primary') + '" href="javascript:void(0); " ' + (pag.params) + ' >' + pag.name + '</a> '
                    }
                    return res;
                }

                

                function updateTable(page, type, fromDate, toDate) {
                    jQuery.post( "/backend/statistiche/alarms_table.php", {
                        p: page, 
                        t: type,
                        from: fromDate,
                        to: toDate,
                    }).done(function( data ) {
                        jQuery("#tableBodyContainer").html(drawTable(data));
                        jQuery("#tablePaginatorContainer").html(drawPaginator(data));

                        jQuery('.paginatorBtn').click(function(ev){
                            updateTable(
                                jQuery(this).attr("data-p"),
                                jQuery(this).attr("data-t"),
                                jQuery(this).attr("data-from"),
                                jQuery(this).attr("data-to"),
                            );
                        });
                    });
                }

                var fromDateStr = jQuery("input[name='filtro_data_da']").val();
                var toDateStr = jQuery("input[name='filtro_data_a']").val();

                var fromStr = fromDateStr ? fromDateStr + " 00:00:00" : '';
                var toStr = toDateStr ? toDateStr + " 23:59:59" : '';

                updateTable(
                    1, 
                    "<?=$req['type']?>",
                    fromStr, 
                    toStr
                );

                var downloadLink = "/backend/statistiche/export_alarms.php?t=<?=$req['type']?>&from=" + fromDateStr + "&to=" + toDateStr;
         
                jQuery("#tableDownloaderContainerBtn").attr("href", downloadLink);

            });
        
        
        </script>
    <?php

    $htmlJs .= ob_get_clean();


    $oApp->set('htmlJscript', $htmlJs);
}
?>