<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->sezione(SEZIONE_STATISTICHE);
$oApp->esegui();

/*********************************************************************************************************/
function array_to_html_properties($arr, $prefix = "data-") {
    $res = [];
    foreach($arr as $k => $v) {
        $res[] = $prefix . $k . '="' . $v . '"';
    }
    return implode(" ", $res);
}

function backend_statistiche_export_alarms(&$oApp) {
    
    $result = [];
    $itemsPerPage = 20;
    
    $req = $_REQUEST;
    
    if(@$req['from']) $req['from'] .= " 00:00:00";
    if(@$req['to']) $req['to'] .= " 23:59:59";

    if(!@$req['t']) $req['t'] = 'all';
    if(!@$req['from']) $req['from'] = date('d-m-Y', strtotime('-3 day'));
    if(!@$req['to']) $req['to'] = date('d-m-Y');
    
    $where = " where true ";

    $limit = "";

    $sql = '
        select 
        log_allarmi.data, 
        log_allarmi.tipo_allarme as descrizione_allarme,
        if(allarme_sistema=1, "' . @$oApp->getEtichetta('CSV_ALARM_TEXT_SYSTEM_ALARM') . '", "' . @$oApp->getEtichetta('CSV_ALARM_TEXT_APPLICATION_ALARM') . '") as tipo_allarme,
        supervisore.descrizione as supervisore_descrizione,
        supervisore.ip as supervisore_ip,
        if(dispositivo.descrizione <> "", dispositivo.descrizione, "N/D") as dispositivo_descrizione ,
        if(risolto = "0000-00-00 00:00:00", "' . @$oApp->getEtichetta('CSV_ALARM_TEXT_ALARM_ACTIVE') . '", "' . @$oApp->getEtichetta('CSV_ALARM_TEXT_ALARM_FIXED') . '") as status
        from log_allarmi 
        left join supervisore on supervisore.id_supervisore = log_allarmi.id_supervisore
        left join dispositivo on dispositivo.id_dispositivo = log_allarmi.id_dispositivo
    ';

    $countSql = "select count(*) as row_count from log_allarmi";

    switch ($req['t']) {
        case 'active_alarms':
            $where .= " and log_allarmi.allarme_sistema = 0 ";
            $where .= " and log_allarmi.risolto = '0000-00-00 00:00:00' ";
        break;
        case 'calls_and_failures':
            $where .= " and log_allarmi.allarme_sistema = 0 ";
        break;
        case 'system_events':
            $where .= " and log_allarmi.allarme_sistema = 1 ";
        break;
        case 'all':

        break;
    }

    $d = new DateTime($req['from']);
    $where .= " and date(log_allarmi.data) >= ".date2db($d->format('Y-m-d')) . " ";
    $d = new DateTime($req['to']);
    $where .= " and date(log_allarmi.data) <= ".date2db($d->format('Y-m-d')) . " ";
    
    $limit .= " order by log_allarmi.data desc ";

    $result = $oApp->oDb->eseguiselect($sql . $where . $limit);
    $finalResult = [];

    $finalResult[] = [
        @$oApp->getEtichetta('CSV_ALARM_COL_EVENT_DATE'),
        @$oApp->getEtichetta('CSV_ALARM_COL_DESCRIPTION'),
        @$oApp->getEtichetta('CSV_ALARM_COL_TYPE'),
        @$oApp->getEtichetta('CSV_ALARM_COL_SUPERVISOR'),
        @$oApp->getEtichetta('CSV_ALARM_COL_SUPERVISOR_IP'),
        @$oApp->getEtichetta('CSV_ALARM_COL_DEVICE'),
        @$oApp->getEtichetta('CSV_ALARM_COL_ALARM_STATE'),
    ];

    foreach($result as $idx => $val) {
        $result[$idx]['descrizione_allarme'] =  @$oApp->getEtichetta('TIPO_ALLARME_'.strtoupper($val['descrizione_allarme']));
        $finalResult[] = $result[$idx];
    }

    //header('Content-Type: application/json');

    header("Content-Type: application/force-download");
    header("Content-Type: application/octet-stream");
    header("Content-Type: application/download");

    header("Content-Disposition: attachment;filename=alarms.csv");
    header("Content-Transfer-Encoding: binary");


    foreach($finalResult as $row) {
        echo implode(", ", $row);
        echo "\n";
    }

    die;
}
?>