<?php

require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
require_once(DIR_CLS . 'class.recordsobj.php');

$oApp = new app(TRUE);
    
$oApp->sezione(SEZIONE_FRONTEND);
$oApp->disegna(TEMPLATE_STANDARD);

function _debug($data) {
    print '<pre style="border: 1px solid silver; padding: 12px; margin: 12px; font-size: 13px; background-color: #f4f4f4; ">';
    print_r($data);
    print '</pre>';
}

/*********************************************************************************************************/
function dashboard(&$oApp) {
    
    $t = contatempo();

    // debug $aSotto = array();
    $strColonnaDx = '';
    $strColonnaSx = '';
    $strJavascript = '';

    
    $activeAlarmsClass = new recordsobj($oApp->oDb->eseguiselect("
        select * from log_allarmi 
        where id_supervisore in (select id_supervisore from supervisore where id_tipo_dispositivo = -1) 
        and risolto = 0
        ; 
    "));
    
    $activeRulesClass = new recordsobj($oApp->oDb->eseguiselect("
        select 
        so.descrizione as so_descrizione, 
        sd.descrizione as sd_descrizione, 
        rly.*
        from relay rly 
        left join supervisore so on rly.id_supervisore_origine = so.id_supervisore
        left join supervisore sd on rly.id_supervisore_destinazione = sd.id_supervisore
        where id_supervisore_origine in (select id_supervisore from supervisore where id_tipo_dispositivo = -1) 
        ;
    "));

    $activeFireAlarms = [];

    $activeAlarms = $activeAlarmsClass->getDataset();
    $activeRules = $activeRulesClass->getDataset();

    foreach($activeAlarms as $activeAlarm) {
        $activeAlarm['_fa_data'] = explode(" - ", $activeAlarm["tipo_allarme"]);
        if(strpos($activeAlarm["tipo_allarme"], "UDL:") &&  @$activeAlarm['_fa_data'][3]){

            $triplet = explode("-", str_replace("UDL:", "", @$activeAlarm['_fa_data'][3]));
            $matchingTrilets = [];
            $matchingTrilets[] = "".$triplet[0]."-".$triplet[1]."-".$triplet[2]."";
            $matchingTrilets[] = "".$triplet[0]."-".$triplet[1]."-*";
            $matchingTrilets[] = "".$triplet[0]."-*-".$triplet[2]."";
            $matchingTrilets[] = "".$triplet[0]."-*-*";
            $matchingTrilets[] = "*-".$triplet[1]."-".$triplet[2]."";
            $matchingTrilets[] = "*-".$triplet[1]."-*";
            $matchingTrilets[] = "*-*-".$triplet[2]."";
            $matchingTrilets[] = "*-*-*";

            foreach($activeRules as $activeRule) {
                if(
                    $activeRule['id_supervisore_origine'] == $activeAlarm['id_supervisore']
                    && in_array (trim($activeRule['evento_origine']), $matchingTrilets)
                ){
                    $activeFireAlarms[] = [
                        'ip' => $activeRule['ip_supervisore_destinazione'], 
                        'descrizione' => $activeRule['sd_descrizione'], 
                        'tipo_allarme' => $activeAlarm["tipo_allarme"], 
                        'comando_destinazione' => $activeRule['comando_destinazione'],
                        //'rule' => $activeRule,
                        //'alarm' => $activeAlarm,
                    ];
                }
            }
            
        }
    }
    
    // ip, descrizione, tipo_allarme, comando_destinazione

    /*
    $qry = "select sd.ip, sd.descrizione, a.tipo_allarme,r.comando_destinazione from log_allarmi a 
            left join supervisore s on s.id_supervisore = a.id_supervisore 
            left join relay r on r.id_supervisore_origine = a.id_supervisore 
            left join supervisore sd on r.id_supervisore_destinazione = sd.id_supervisore 
            where s.id_tipo_dispositivo = -1 and s.id_status = 1 and a.risolto = 0;
            ";
    $activeFireAlarms = new recordsobj($oApp->oDb->eseguiselect($qry));
    $activeFireAlarms = $activeFireAlarms->getDataset();
    */

    ?>
    <script>
        let activeFireAlarms = <?=json_encode($activeFireAlarms)?>;
    </script>
    <?php

    $qry = "
    SELECT a.*, b.descrizione AS status, c.".$_SESSION['LINGUA_NAVIGAZIONE']." AS tipo_dispositivo, d.".$_SESSION['LINGUA_NAVIGAZIONE']." AS tipo_visualizzazione 
    FROM supervisore AS a 
    INNER JOIN status AS b ON a.id_status = b.id_status 
    INNER JOIN supervisore_tipo_dispositivo AS c ON a.id_tipo_dispositivo = c.id 
    INNER JOIN supervisore_tipo_visualizzazione AS d ON a.id_tipo_visualizzazione = d.id 
    WHERE b.id_status != 2 
    ORDER BY a.ordine
    ";
    $supervisors = new recordsobj($oApp->oDb->eseguiselect($qry));

    if ($supervisors->rowcount() > 0) {
        
        $qry = "
        select ip_supervisore_origine as ip, 'origine' as tipo from relay where id_status = 1 group by ip_supervisore_origine
        union
        select ip_supervisore_destinazione as ip, 'destinazione' as tipo from relay where id_status = 1 group by ip_supervisore_destinazione
        ";
        $relaySummary = [];
        foreach($oApp->oDb->eseguiselect($qry) as $curSummary) {
            @$relaySummary[$curSummary['tipo']][$curSummary['ip']] = 1;
        }


        $qry = "
        SELECT a.*, b.descrizione AS status FROM mappa AS a 
        INNER JOIN status AS b ON a.id_status = b.id_status 
        WHERE b.id_status != 2 
        ORDER BY ordine ASC
        ";
        $maps = new recordsobj($oApp->oDb->eseguiselect($qry), ['id_supervisore']);

        $qry = "
        SELECT a.*, b.descrizione AS status, c.".$_SESSION['LINGUA_NAVIGAZIONE']." AS tipo_dispositivo, 
        c.codice_tipo_dispositivo AS codice_tipo_dispositivo, c.icona, c.mostra_in_dashboard, m.id_mappa
        FROM dispositivo AS a 
        INNER JOIN status AS b ON a.id_status = b.id_status 
        INNER JOIN dispositivo_tipo_dispositivo AS c ON a.id_tipo_dispositivo = c.id_tipo_dispositivo 
        LEFT JOIN mappa AS m on a.mappe like concat('%;', m.codice_mappa , ';%') and m.id_supervisore = a.id_supervisore
        WHERE b.id_status != 2 ORDER BY id_dispositivo DESC
        ";
        $devices = new recordsobj($oApp->oDb->eseguiselect($qry), ['id_supervisore', 'id_mappa']);

        
        $qry = "
        SELECT a.*, a.".$_SESSION['LINGUA_NAVIGAZIONE']." AS sotto_tipo_dispositivo 
        FROM dispositivo_sotto_tipo_dispositivo AS a 
        /* WHERE a.id_tipo_dispositivo = 3 */
        ORDER BY ordine DESC 
        ";
        $devicesSubTypes = new recordsobj($oApp->oDb->eseguiselect($qry), ['id_tipo_dispositivo']);
        
        $supervisors->first();

        while (true) {

            $ipForJs = str_replace(".", "-", $supervisors->get("ip"));
            
            ob_start();
            ?>
            <div id="supervisorBtnContainer<?=$supervisors->get('id_supervisore')?>" class="col-xl-12 col-sm-12 mb-1 text-center div-dashboard-bottone-supervisore rounded" tipo="supervisore" ip="<?=$ipForJs?>">
                <div class="btn-group" role="group">
                    <button type="button" class="btn btn-default supervisore <?=encodaStatusPerDashboard($supervisors)?> o-hidden h-100 dashboard-bottone-supervisore" id_oggetto="<?=writePostParam($supervisors->get('id_supervisore'))?>" ip="<?=$ipForJs?>">
                        <img style="width: 16px" src="<?=URL_IMG?>allarme-cs2.png" class="cs2-img">
                        <img style="width: 16px" src="<?=URL_IMG?>allarme-cs3.png" class="cs3-img">
                        <span class="badge faicon" ><i class="fa fa-fire"></i></span>
                        <?php
                        if(@$relaySummary['origine'][$supervisors->get('ip')]) {
                            ?><span class="badge badge-primary"><i class="fa fa-arrow-right"></i></span><?php 
                        }
                        if(@$relaySummary['destinazione'][$supervisors->get('ip')]) {
                            ?><span class="badge badge-secondary"><i class="fa fa-arrow-right"></i></span><?php
                        }

                        ?>
                        <?=$supervisors->get('descrizione')?>
                    </button>

                    <?php
                    $url = 'http://'.$supervisors->get('ip');
                    $tipo = 'ws';
                    if ($supervisors->get('id_tipo_visualizzazione') == TIPO_VISUALIZZAZIONE_ID_TS01) {
                        $url = $url.'/_TS01/';
                        $tipo = 'ts01';
                    }
                    ?>
                    <a type="button" data-ip="<?=$supervisors->get('ip')?>" class="btn btn-default dashboard-bottone-supervisore-info-<?=$tipo?> supervisore-info" href="javascript:;">
                        <i class="fa fa-fw fa-info-circle"></i>
                    </a>
                    <?php
                        $fbW = 533; $fbH = 375;
                        
                        if($tipo == 'ws') {
                            $fbW = 988; $fbH = 700;
                        }

                        $linkParamsForFB = " data-width=\"" . $fbW . "\" data-height=\"" . $fbH . "\" data-options=\" { iframe : { css : { width: '" . $fbW . "px', height : '" . $fbH . "px' } } } \" ";
                      
                        if($supervisors->get("id_tipo_dispositivo") + 0 == -1) {
                            ?>
                                <a id="fireAlarmLink<?=$supervisors->get("id_supervisore")?>" type="button" class="btn btn-default supervisore-frame <?=encodaStatusPerDashboard($supervisors)?>" data-type="iframe" data-src="<?=$url?>" href="javascript:;" data-title="##<?=$supervisors->get('descrizione')?>" data-caption="<?=$supervisors->get('descrizione')?>">
                                    <i class="fa fa-fw fa-eye"></i>
                                </a>
                            <?php
                        } else {
                            ?>
                                <!--<a id="fancyboxLink<?=$supervisors->get("id_supervisore")?>" rel="gallery" data-fancybox="gallery" <?=$linkParamsForFB?> type="button" class="btn btn-default dashboard-bottone-supervisore-iframe dashboard-bottone-supervisore-iframe-<?=$tipo?> supervisore-frame <?=encodaStatusPerDashboard($supervisors)?>" data-type="iframe" data-src="<?=$url?>" href="javascript:;" data-title="##<?=$supervisors->get('descrizione')?>" data-caption="<?=$supervisors->get('descrizione')?>">
                                    <i class="fa fa-fw fa-eye"></i>
                                </a>-->
                                <a id="fancyboxLink<?=$supervisors->get("id_supervisore")?>" rel="gallery" <?=$linkParamsForFB?> type="button" class="btn btn-default dashboard-bottone-supervisore-iframe-<?=$tipo?> supervisore-frame <?=encodaStatusPerDashboard($supervisors)?>" data-type="iframe" data-src="<?=$url?>" href="javascript:;" data-title="##<?=$supervisors->get('descrizione')?>" data-caption="<?=$supervisors->get('descrizione')?>" onclick="window.open('<?=$url?>', '<?=$supervisors->get("id_supervisore")?>', 'toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, copyhistory=no, width=' + <?=$fbW?> + ', height=' + <?=$fbH?> + ', top=' + ((screen.height - <?=$fbH?>) / 4)  + ', left=' + ((screen.width - <?=$fbW?>) / 2))">
                                    <i class="fa fa-fw fa-eye"></i>
                                </a>
                            <?php
                        }

                    ?>
                </div>
                <div id="supervisoreNotifiche<?=$supervisors->get('id_supervisore')?>" data-idsup="<?=$supervisors->get('id_supervisore')?>" class="supervisore-notifiche" style="display: none; ">
                    
                </div>
            </div>
            <?php
            $strColonnaDx .= ob_get_contents();
            ob_end_clean();
            

            $maps->first();
            $maps->setSub([$supervisors->get('id_supervisore')]);
            $mapsIdx = 0;
            if($maps->rowcount() > 0) {
                ob_start();
                echo '<div class="d-none div-supervisore" id="div-supervisore-'.$ipForJs.'">';
                echo '<br><br><div class="row mb-1">';
                
                while (true) {
    
                    if($maps->is([ ["id_supervisore", $supervisors->get('id_supervisore')] ])) {
    
                        $devices->first();
                        $devices->setSub([$supervisors->get('id_supervisore'), $maps->get('id_mappa')]);
    
                        if (STAMPA_MAPPE_VUOTE || $devices->has([
                            ["id_supervisore", $supervisors->get('id_supervisore')],
                            ["mostra_in_dashboard", "1"],
                            ["mappe", ";" . $maps->get('codice_mappa') . ";", "cnt"]
                        ])) {
    
                            $ipForMap = str_replace(".", "-", $supervisors->get('ip'));
                            $mapIdByName = "map_id_" . $ipForMap . "_" . strtolower(preg_replace("/[^A-Za-z0-9]/", '', $maps->get('descrizione')));
                            $mapClassByGroup = "map_id_" . $ipForMap;

                            ?>
                            <div class="col-xl-4 col-sm-6 text-center float-left div-mappa" tipo="mappa" ip_supervisore="<?=$ipForJs?>" codice_mappa="<?=$maps->get('codice_mappa')?>">
                                <div class="card mappa <?=encodaStatusPerDashboard($maps)?> border-3 o-hidden h-100">
                                    <div id="<?=$mapIdByName?>" class="card-title standard <?=$mapClassByGroup?>">
                                    
                                    <span class="badge famapicon" ><i class="fa fa-fire"></i></span>
                                    <?=$maps->get('descrizione')?>
                                    </div>
                                    <div class="card-body">
                            <?php

                            echo '<div class="row mb-1">';

                            $devicesIdx = 0;
    
                            if($devices->has([ 
                                ["mostra_in_dashboard", "1"],
                                ["id_supervisore", $supervisors->get('id_supervisore')],
                                ["mappe", ";" . $maps->get('codice_mappa') . ";", "cnt"]
                            ])) {
    
                                while (true) {
    
                                    if($devices->is([ 
                                        //["mostra_in_dashboard", "1"],
                                        ["id_supervisore", $supervisors->get('id_supervisore')],
                                        ["mappe", ";" . $maps->get('codice_mappa') . ";", "cnt"]
                                    ])) {
                                        
    
                                        ?>
                                                <div class="device-icon col-xl-4 col-md-6 <?=((!$devices->get('mostra_in_dashboard'))?' dispositivo-nascosto-default dispositivo-nascosto':'')?>" tipo="dispositivo" ip_supervisore="<?=$ipForJs?>" codice_mappa="<?=$maps->get('codice_mappa')?>" codice_dispositivo="<?=$devices->get('codice_dispositivo')?>"codice_tipo_dispositivo="<?=$devices->get('codice_tipo_dispositivo')?>">
                                                    <div class="card o-hidden h-100 dispositivo <?=encodaStatusPerDashboard($devices)?>">

                                                        <div class="device-icons-container">
                                        <?php

                                        $devicesSubTypes->first();
                                        $devicesSubTypes->setSub([$devices->get('id_tipo_dispositivo')]);
    
                                        if (
                                            //$devices->is([ ["mostra_in_dashboard", "1"], ]) && 
                                            $devicesSubTypes->has([ ["id_tipo_dispositivo", $devices->get('id_tipo_dispositivo')], ])
                                        ) {
    
                                            $subTypeIdx = 0;
                                            while (true) {
    
                                                if ($devicesSubTypes->is([
                                                    ["id_tipo_dispositivo", $devices->get('id_tipo_dispositivo')],
                                                ])) {
                                                    
                                                    $stdcmd = $devicesSubTypes->get('codice_sotto_tipo_dispositivo');
                                                    switch ($devicesSubTypes->get('codice_sotto_tipo_dispositivo')) {
                                                        case 'WS-1':
                                                            ?>
                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-warning"><?= $stdcmd ?></span>
                                                            <?php
                                                            break;
                                                        case 'A':
                                                            ?>
                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-warning"><?= $stdcmd ?></span>
                                                            <?php
                                                            break;
                                                        case 'CS1':
                                                            ?>
                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-danger"><img src="<?=URL_IMG?>allarme-cs1.png"></span>
                                                            <?php
                                                            break;
                                                        case 'CS2':
                                                            ?>
                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge">
                                                                <img class="cs-img img-alarm" src="<?=URL_IMG?>allarme-cs2.png">
                                                                <img class="cs-img img-reset" src="<?=URL_IMG?>allarme-cs2-ok.png">
                                                            </span>
                                                            <?php
                                                            break;
                                                        case 'CS3':
                                                            ?>
                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-light">
                                                                <img class="cs-img img-alarm" src="<?=URL_IMG?>allarme-cs3.png">
                                                                <img class="cs-img img-reset" src="<?=URL_IMG?>allarme-cs3-ok.png">
                                                            </span>
                                                            <?php
                                                            break;
                                                    }
                                                    
                                                    $subTypeIdx  ++;
                                                }
                                                if(!$devicesSubTypes->next()) { break; }
                                            }
                                        }
    
                                        ?>
                                                </div>
                                                <div class="device-icon-container card-body">
                                                    <div class="device-icon-container-img small">
                                                        <i style="font-size: 40px;" class="fa fa-fw <?=$devices->get('icona')?>"></i>
                                                    </div>
                                                    <div class="device-icon-container-text mr-3 small">
                                                        <?=$devices->get('descrizione')?>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <?php

                                        $devicesIdx++;
                                    }
                                    if(!$devices->next()) { break; }
                                }
                            } else {
                                ?>
                                <div class="col-12 mt-5">
                                    <div class="text-center"><?=$oApp->getEtichetta('MAPPA_SENZA_DISPOSITIVI')?></div>
                                </div>
                                <?php
                            }

                            ?>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <?php
                        }
                        $mapsIdx ++;
                    }
                    if(!$maps->next()) { break; }
                }
                
                echo '</div><br><br>';
                echo '</div>';
                $strColonnaSx .= ob_get_contents();
                ob_end_clean();

            }
            if(!$supervisors->next()) { break; }
        }
    }

    $strColonnaDxVuota = '
        <div class="no-supervisors-help">
            ' . utf8_encode($oApp->getEtichetta('MAPPA_SENZA_SUPERVISORI_HELP')) . '
        </div>
    '


    ?>
    <div class="row" id="dashboard">
        <div class="col " id="dashboard-details">
            <?=$strColonnaSx?>
        </div>
        <div class="col-md-3 bg-dark text-light " id="dashboard-map">
            <div class="align-bottom invisible" id="dashboard-map-block">
                <div id="dashboard-map-container">
                    <?=$strColonnaDx ? $strColonnaDx : $strColonnaDxVuota?>
                </div>
            </div>
        </div>
    </div>
    
    <?php
    
    stampaContatempo($t, 'dashboard solo dispositivi');

    $js = str_replace('##ATR_BUILDING_DATA##',$strJavascript, $oApp->get('htmlJscript'));
    $oApp->set('htmlJscript', $js);

}

/*********************************************************************************************************/
function encodaStatusPerDashboard($oObj) {
    $status = 'standard';
    switch ($oObj->get('id_status')) {
        case STATUS_IN_AGGIORNAMENTO:
            $status = 'update';
            break;
        case STATUS_OFFLINE:
            $status = 'offline';
            break;
    }
    return $status;
    //return $oObj->get('classe').'-'.$status;
}
?>