<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');
require_once(DIR_CLS . 'class.recordsobj.php');

$oApp = new app(TRUE, PERMESSO_NESSUNO);
    
$oApp->sezione(SEZIONE_FRONTEND);
$oApp->esegui();

function _debug($data) {
    print '<pre style="border: 1px solid silver; padding: 12px; margin: 12px; font-size: 13px; background-color: #f4f4f4; ">';
    print_r($data);
    print '</pre>';
}

/*********************************************************************************************************/
function dashboardbuildjson(&$oApp) {
    
    $t = contatempo();
    $checksum = $oApp->oDb->eseguiselect("CHECKSUM TABLE dispositivo, mappa, supervisore");
    $fname = 'yassBuilding_' . sha1(serialize($checksum)) .'.json';

    if(file_exists('/tmp/' . $fname) && is_file('/tmp/' . $fname)) {
        header('Content-Type: application/json');
        print file_get_contents('/tmp/' . $fname);
        die;
    } else {
        shell_exec("rm -Rf /tmp/yassBuilding_*");
    }

    $resultArray = '';

    $qry = "
    SELECT a.*, b.descrizione AS status, c.".$_SESSION['LINGUA_NAVIGAZIONE']." AS tipo_dispositivo, d.".$_SESSION['LINGUA_NAVIGAZIONE']." AS tipo_visualizzazione 
    FROM supervisore AS a 
    INNER JOIN status AS b ON a.id_status = b.id_status 
    INNER JOIN supervisore_tipo_dispositivo AS c ON a.id_tipo_dispositivo = c.id 
    INNER JOIN supervisore_tipo_visualizzazione AS d ON a.id_tipo_visualizzazione = d.id 
    WHERE b.id_status != 2 
    ORDER BY a.ordine
    ";
    $supervisors = new recordsobj($oApp->oDb->eseguiselect($qry));

    if ($supervisors->rowcount() > 0) {
        
        $qry = "
        SELECT a.*, b.descrizione AS status FROM mappa AS a 
        INNER JOIN status AS b ON a.id_status = b.id_status 
        WHERE b.id_status != 2 /* AND a.id_supervisore = 6 */
        ORDER BY ordine DESC
        ";
        $maps = new recordsobj($oApp->oDb->eseguiselect($qry), ['id_supervisore']);

        $qry = "
        SELECT a.*, b.descrizione AS status, c.".$_SESSION['LINGUA_NAVIGAZIONE']." AS tipo_dispositivo, 
        c.codice_tipo_dispositivo AS codice_tipo_dispositivo, c.icona, c.mostra_in_dashboard, m.id_mappa
        FROM dispositivo AS a 
        INNER JOIN status AS b ON a.id_status = b.id_status 
        INNER JOIN dispositivo_tipo_dispositivo AS c ON a.id_tipo_dispositivo = c.id_tipo_dispositivo 
        LEFT JOIN mappa AS m on a.mappe like concat('%;', m.codice_mappa , ';%') and m.id_supervisore = a.id_supervisore
        WHERE b.id_status != 2 /* AND a.id_supervisore=6 AND a.mappe LIKE '%;1;%' */ ORDER BY id_dispositivo DESC
        ";
        $devices = new recordsobj($oApp->oDb->eseguiselect($qry), ['id_supervisore', 'id_mappa']);

        
        $qry = "
        SELECT a.*, a.".$_SESSION['LINGUA_NAVIGAZIONE']." AS sotto_tipo_dispositivo 
        FROM dispositivo_sotto_tipo_dispositivo AS a 
        /* WHERE a.id_tipo_dispositivo = 3 */
        ORDER BY ordine DESC 
        ";
        $devicesSubTypes = new recordsobj($oApp->oDb->eseguiselect($qry), ['id_tipo_dispositivo']);
        
        $supervisors->first();

        while (true) {
            $resultArray["supervisorsToConnect"][] = [
                'description' => $supervisors->get('descrizione'),
                'ip_address' => $supervisors->get('ip'),
                'id_tipo_dispositivo' => $supervisors->get('id_tipo_dispositivo'),
            ];


            $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')] = [];
            $ipForJs = str_replace(".", "-", $supervisors->get("ip"));
            

            $maps->first();
            $maps->setSub([$supervisors->get('id_supervisore')]);
            $mapsIdx = 0;
            if($maps->rowcount() > 0) {
                
                while (true) {
    
                    if($maps->is([ ["id_supervisore", $supervisors->get('id_supervisore')] ])) {
    
                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx] = [];
                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["name"] = $maps->get('descrizione');
                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["sort"] = $maps->get('ordine');
                        
                        $devices->first();
                        $devices->setSub([$supervisors->get('id_supervisore'), $maps->get('id_mappa')]);
    
                        if (STAMPA_MAPPE_VUOTE || $devices->has([
                            ["id_supervisore", $supervisors->get('id_supervisore')],
                            ["mappe", ";" . $maps->get('codice_mappa') . ";", "cnt"]
                        ])) {
    

                            $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"] = [];

                            $devicesIdx = 0;
    
                            if($devices->has([ 
                                ["mostra_in_dashboard", "1"],
                                ["id_supervisore", $supervisors->get('id_supervisore')],
                                ["mappe", ";" . $maps->get('codice_mappa') . ";", "cnt"]
                            ])) {
    
                                while (true) {
    
                                    if($devices->is([ 
                                        //["mostra_in_dashboard", "1"],
                                        ["id_supervisore", $supervisors->get('id_supervisore')],
                                        ["mappe", ";" . $maps->get('codice_mappa') . ";", "cnt"]
                                    ])) {
                                        
    
                                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx] = [];
                                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["id"] = $devices->get('codice_dispositivo');
                                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["name"] = $devices->get('descrizione');
                                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["tipo"] = $devices->get('codice_tipo_dispositivo');
                                        $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["mappe"] = $devices->get('mappe');
                        
                                        $devicesSubTypes->first();
                                        $devicesSubTypes->setSub([$devices->get('id_tipo_dispositivo')]);
    
                                        if (
                                            //$devices->is([ ["mostra_in_dashboard", "1"], ]) && 
                                            $devicesSubTypes->has([ ["id_tipo_dispositivo", $devices->get('id_tipo_dispositivo')], ])
                                        ) {
    
                                            $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"] = [];
                                            
    
                                            $subTypeIdx = 0;
                                            while (true) {
    
                                                if ($devicesSubTypes->is([
                                                    ["id_tipo_dispositivo", $devices->get('id_tipo_dispositivo')],
                                                ])) {
                                                    $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"][$subTypeIdx] = [];
                                                    $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"][$subTypeIdx]["id"] = $devicesSubTypes->get('codice_sotto_tipo_dispositivo');
                                                    $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"][$subTypeIdx]["descrizione"] = $devicesSubTypes->get('sotto_tipo_dispositivo');
                                                    $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"][$subTypeIdx]["status"] = "";
                                                    $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"][$subTypeIdx]["is_allarme"] = $devicesSubTypes->get('is_allarme');
                                                    $resultArray["buildingData"]["supervisors"][$supervisors->get('ip')][$mapsIdx]["devices"][$devicesIdx]["sub"][$subTypeIdx]["allarme_attivo"] = "0";
                                                    
                                                    $subTypeIdx  ++;
                                                }
                                                if(!$devicesSubTypes->next()) { break; }
                                            }
                                        }

                                        $devicesIdx++;
                                    }
                                    if(!$devices->next()) { break; }
                                }
                            } else {
                            }
                        }
                        $mapsIdx ++;
                    }
                    if(!$maps->next()) { break; }
                }
            }
            if(!$supervisors->next()) { break; }
        }
    }
    header('Content-Type: application/json');
    $result = json_encode($resultArray);
    print $result;
    file_put_contents('/tmp/' . $fname, $result);
    die;
}

?>