<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

define("USE_DASHBOARD_CACHE", false);

if(!USE_DASHBOARD_CACHE){
    
    //NON USA CACHE SU FILE (MA USA CACHE IN SESSIONE)
    $oApp = new app(TRUE);
    
    if(@$_GET['rigenera'] == "1") {
        $_SESSION['strColonnaDx'] = '';
        $_SESSION['strColonnaSx'] = '';
        $_SESSION['strJavascript'] = '';
    }

    $oApp->sezione(SEZIONE_FRONTEND);
    $oApp->disegna(TEMPLATE_STANDARD);

} else {

    //USA CACHE SU FILE

    if (array_key_exists('rigenera', $_GET) && $_GET['rigenera']==CHIAVE_SEGRETA && array_key_exists('username', $_GET) && array_key_exists('password', $_GET) && array_key_exists('lang', $_GET)) {
        define('PASSEPARTOUT', file_get_contents('/tmp/ydp.bo'));
    
        $oApp = new app(TRUE, PERMESSO_NESSUNO, FALSE,  readGetParam('lang'));
        $oUtente = new utente($oApp);
        $messaggio  = $oUtente->loggati(readGetParam('username'), readGetParam('password'));
    
        $oApp = new app(TRUE, NULL, FALSE,  readGetParam('lang'));
    } else {
        $oApp = new app(TRUE);
    }
    
    $nomeFile = str_replace('##UTENTE_TIPO_ID##',$oApp->getIdTipoUtenteLoggato(), FILE_DASHBOARD_CACHE);
    $nomeFile = str_replace('##LINGUA##',strtolower($_SESSION['LINGUA_NAVIGAZIONE']), $nomeFile);
    
    if (array_key_exists('rigenera', $_GET) || !file_exists($nomeFile)) {
        $oApp->sezione(SEZIONE_FRONTEND);
    
        ob_start();
        $oApp->disegna(TEMPLATE_STANDARD);
        file_put_contents($nomeFile, ob_get_contents());
        ob_end_clean();
    
    }
    if (!array_key_exists('noOutput', $_GET))  {
        if (file_exists($nomeFile)) echo file_get_contents($nomeFile);
    }

}

/*********************************************************************************************************/
function dashboard(&$oApp) {
    
    $t = contatempo();
    $tTotaleSottoTipi = 0;
    // debug $aSotto = array();
    $strColonnaDx = '';
    $strColonnaSx = '';
    $strJavascript = '';

    $oElencoSupervisori = new elencosupervisore($oApp, TRUE, ' ORDER BY a.ordine');

    if (!$oElencoSupervisori->isEmpty()) {
        foreach ($oElencoSupervisori->getElenco() as $ordine_supervisore=>$oSupervisore) {
            //if ($oSupervisore->getId() != 1) continue;
            $strJavascript .= TAB.'atr.addServer("' . $oSupervisore->get('descrizione') . '", "' . $oSupervisore->get('ip') . '");' . NL;
            $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"] = [];' . NL;
            ob_start();
            ?>
            <div id="supervisorBtnContainer<?=$oSupervisore->get('id_supervisore')?>" class="col-xl-12 col-sm-12 mb-1 text-center div-dashboard-bottone-supervisore rounded" tipo="supervisore" ip="<?=$oSupervisore->get('ip_per_js')?>">
                <div class="btn-group" role="group">
                    <button type="button" class="btn btn-default supervisore <?=encodaStatusPerDashboard($oSupervisore)?> o-hidden h-100 dashboard-bottone-supervisore" id_oggetto="<?=writePostParam($oSupervisore->getId())?>" ip="<?=$oSupervisore->get('ip_per_js')?>">
                        <img style="width: 16px" src="<?=URL_IMG?>allarme-cs2.png" class="cs2-img">
                        <img style="width: 16px" src="<?=URL_IMG?>allarme-cs3.png" class="cs3-img">
                        <?=$oSupervisore->get('descrizione')?>
                    </button>

                    <?php
                    $url = 'http://'.$oSupervisore->get('ip');
                    $tipo = 'ws';
                    if ($oSupervisore->get('id_tipo_visualizzazione') == TIPO_VISUALIZZAZIONE_ID_TS01) {
                        $url = $url.'/_TS01/';
                        $tipo = 'ts01';
                    }
                    ?>
                    <a type="button" class="btn btn-default dashboard-bottone-supervisore-info-<?=$tipo?> supervisore-info" href="javascript:;">
                        <i class="fa fa-fw fa-info-circle"></i>
                    </a>
                    <a type="button" class="btn btn-default dashboard-bottone-supervisore-iframe-<?=$tipo?> supervisore-frame <?=encodaStatusPerDashboard($oSupervisore)?>" data-fancybox data-type="iframe" data-src="<?=$url?>" href="javascript:;" data-title="##<?=$oSupervisore->get('descrizione')?>" data-caption="<?=$oSupervisore->get('descrizione')?>">
                        <i class="fa fa-fw fa-eye"></i>
                    </a>
                </div>
                <div id="supervisoreNotifiche<?=$oSupervisore->get('id_supervisore')?>" class="supervisore-notifiche" style="display: none; ">
                    
                </div>
            </div>
            <?php
            $strColonnaDx .= ob_get_contents();
            ob_end_clean();
            if ($oSupervisore->haMappe()) {
                ob_start();
                echo '<div class="d-none div-supervisore" id="div-supervisore-'.$oSupervisore->get('ip_per_js').'">';
                    echo '<br><br><div class="row mb-1">';
                    $contMappe = 0;
                    foreach ($oSupervisore->getElencoMappe()->getElenco() as $i=>$oMappa) {
                        $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.'] = [];' . NL;
                        $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["name"] = "'.$oMappa->get('descrizione').'";' . NL;
                        $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["sort"] = "'.$oMappa->get('ordine').'";' . NL;
                        if ($oMappa->haDispositivi() || STAMPA_MAPPE_VUOTE) {
                            //if ($contMappe % 3 == 0) echo '</div><div class="row mb-1">';
                            ++$contMappe;
                            ?>
                            <div class="col-xl-4 col-sm-6 text-center float-left div-mappa" tipo="mappa" ip_supervisore="<?=$oSupervisore->get('ip_per_js')?>" codice_mappa="<?=$oMappa->get('codice_mappa')?>">
                                <div class="card mappa <?=encodaStatusPerDashboard($oMappa)?> border-3 o-hidden h-100">
                                    <div class="card-title standard">
                                    <?=$oMappa->get('descrizione')?>
                                    </div>
                                    <div class="card-body">
                                        <?php
                                        $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"] = [];' . NL;
                                        echo '<div class="row mb-1">';
                                        $contDispositivi = 0;
                                        if ($oMappa->haDispositiviVisibili()) {
                                            foreach ($oMappa->getElencoDispositivi()->getElenco() as $k => $oDispositivo) {
                                                $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.'] = [];' . NL;
                                                $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["id"] = "'.$oDispositivo->get('codice_dispositivo').'";' . NL;
                                                $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["name"] = "'.$oDispositivo->get('descrizione').'";' . NL;
                                                $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["tipo"] = "'.$oDispositivo->get('codice_tipo_dispositivo').'";' . NL;
                                                $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["mappe"] = "'.$oDispositivo->get('mappe').'";' . NL;

                                                //if ($contDispositivi % 2 == 0) echo '</div><div class="row mb-1">';
                                                if ($oDispositivo->get('mostra_in_dashboard')) ++$contDispositivi;
                                                ?>
                                                <div class="device-icon col-xl-4 col-md-6 <?=((!$oDispositivo->get('mostra_in_dashboard'))?' dispositivo-nascosto-default dispositivo-nascosto':'')?>" tipo="dispositivo" ip_supervisore="<?=$oSupervisore->get('ip_per_js')?>" codice_mappa="<?=$oMappa->get('codice_mappa')?>" codice_dispositivo="<?=$oDispositivo->get('codice_dispositivo')?>"codice_tipo_dispositivo="<?=$oDispositivo->get('codice_tipo_dispositivo')?>">
                                                    <div class="card o-hidden h-100 dispositivo <?=encodaStatusPerDashboard($oDispositivo)?>">

                                                        <div class="device-icons-container">
                                                            <?php
                                                            $tSottotipi = contatempo();
                                                            if ($oDispositivo->haSottoTipoDispositivo()) {
                                                                $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"] = [];' . NL;

                                                                foreach ($oDispositivo->getElencoSottoTipoDispositivo()->getElenco() as $stdid => $stdrec) {
                                                                    // debug $aSotto[] = array($oDispositivo->getId(), $stdrec->getId());
                                                                    $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"]['.$stdid.'] = [];' . NL;
                                                                    $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"]['.$stdid.']["id"] = "'.$stdrec->get('codice_sotto_tipo_dispositivo').'";' . NL;
                                                                    $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"]['.$stdid.']["descrizione"] = "'.$stdrec->get('sotto_tipo_dispositivo').'";' . NL;
                                                                    $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"]['.$stdid.']["status"] = "";' . NL;
                                                                    $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"]['.$stdid.']["is_allarme"] = "'.$stdrec->get('is_allarme').'";' . NL;
                                                                    $strJavascript .= TAB.'atr.buildingData["supervisors"]["' . $oSupervisore->get('ip') . '"]['.$i.']["devices"]['.$k.']["sub"]['.$stdid.']["allarme_attivo"] = "0";' . NL;

                                                                    $stdcmd = $stdrec->get('codice_sotto_tipo_dispositivo');
                                                                    switch ($stdrec->get('codice_sotto_tipo_dispositivo')) {
                                                                        case 'WS-1':
                                                                            ?>
                                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-warning"><?= $stdcmd ?></span>
                                                                            <?php
                                                                            break;
                                                                        case 'A':
                                                                            ?>
                                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-warning"><?= $stdcmd ?></span>
                                                                            <?php
                                                                            break;
                                                                        case 'CS1':
                                                                            ?>
                                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-danger"><img src="<?=URL_IMG?>allarme-cs1.png"></span>
                                                                            <?php
                                                                            break;
                                                                        case 'CS2':
                                                                            ?>
                                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge">
                                                                                <img class="cs-img img-alarm" src="<?=URL_IMG?>allarme-cs2.png">
                                                                                <img class="cs-img img-reset" src="<?=URL_IMG?>allarme-cs2-ok.png">
                                                                            </span>
                                                                            <?php
                                                                            break;
                                                                        case 'CS3':
                                                                            ?>
                                                                            <span class="badge-device-sub-type badge-device-sub-type-<?= $stdcmd ?> badge badge-light">
                                                                                <img class="cs-img img-alarm" src="<?=URL_IMG?>allarme-cs3.png">
                                                                                <img class="cs-img img-reset" src="<?=URL_IMG?>allarme-cs3-ok.png">
                                                                            </span>
                                                                            <?php
                                                                            break;
                                                                    }

                                                                }
                                                            }
                                                            $tTotaleSottoTipi += contatempo()-$tSottotipi;
                                                            ?>
                                                        </div>
                                                        <div class="device-icon-container card-body">
                                                            <div class="device-icon-container-img small">
                                                                <i class="fa fa-fw <?=$oDispositivo->get('icona')?>"></i>
                                                            </div>
                                                            <div class="device-icon-container-text mr-3 small">
                                                                <?=$oDispositivo->get('descrizione')?>
                                                            </div>
                                                        </div>
                                                    </div>
                                                </div>
                                                <?php
                                            }
                                        } else {
                                            ?>
                                            <div class="col-12 mt-5">
                                                <div class="text-center"><?=$oApp->getEtichetta('MAPPA_SENZA_DISPOSITIVI')?></div>
                                            </div>
                                            <?php
                                        }
                                        echo '</div>';
                                        ?>
                                    </div>
                                </div>
                            </div>
                            <?php
                        }
                    }
                    echo '</div><br><br>';
                echo '</div>';
                $strColonnaSx .= ob_get_contents();
                ob_end_clean();
            }
        }
        $strJavascript .= TAB.'console.log(atr.buildingData);' . NL;
    }

    ?>
    <div class="row" id="dashboard">
        <div class="col-md-9" id="dashboard-details">
            <?=$strColonnaSx?>
        </div>
        <div class="col-md-3 bg-dark text-light " id="dashboard-map">
            <div class="align-bottom invisible" id="dashboard-map-block">
                <div id="dashboard-map-container">
                    <?=$strColonnaDx?>
                </div>
            </div>
        </div>
    </div>
    <?php
    stampaContatempo($t, 'dashboard solo dispositivi');
    $js = str_replace('##ATR_BUILDING_DATA##',$strJavascript, $oApp->get('htmlJscript'));
    $oApp->set('htmlJscript', $js);

    // debug foreach($aSotto as $a) {
    // debug     echo $a[0].'-'.$a[1].BR;
    // debug }
}
/*********************************************************************************************************/
function encodaStatusPerDashboard($oObj) {
    $status = 'standard';
    switch ($oObj->get('id_status')) {
        case STATUS_IN_AGGIORNAMENTO:
            $status = 'update';
            break;
        case STATUS_OFFLINE:
            $status = 'offline';
            break;
    }
    return $status;
    //return $oObj->get('classe').'-'.$status;
}
?>