<?php

require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/ver.php');

/*********************************************************************************************************/
// funzione per l'autocaricamento delle classi
/*********************************************************************************************************/
 
function __autoload($nome_classe) {
	$nome_classe = strtolower($nome_classe);
	if (!in_array($nome_classe, unserialize(aCLASSI_DA_NON_AUTOLOAD)) && stripos(strtolower($nome_classe), 'phpexcel') === FALSE) require_once DIR_CLS . 'class.' . $nome_classe . '.php';
}
/*
spl_autoload_register(function ($nome_classe) {
	$nome_classe = strtolower($nome_classe);
	if (!in_array($nome_classe, unserialize(aCLASSI_DA_NON_AUTOLOAD))) require_once DIR_CLS . 'class.' . $nome_classe . '.php';
});
*/
/*********************************************************************************************************/
/*********************************************************************************************************/



Class app {
	private $nome;
	private $sezione;
	private $sezione_dettaglio;
	private $classe;
	private $callback;
	private $template = FALSE;
	private $titolo = FALSE;
	
	private $lang;
	private $permesso;
	private $logga;
	
	public $oDb = FALSE; // oggetto DATABASE
	private $oUtente = FALSE; // oggetto UTENTE
	private $oAnnualita = FALSE; // oggetto ANNUALITA
	private $oCooperativa = FALSE; // oggetto AGENZIA
	//private $oCliente = FALSE; // oggetto CLIENTE
	
	private $aMsg = array();
	private $aEtichette = array();	
	
	private $htmlHead;
	private $htmlBody;
	private $htmlJscript;
	
	private $frontend;
	private $backend;
	private $tabellaDizionario;
	
	private $eliminaDatiDoPostBack = TRUE;

	private $oElencoTipoDispositivoCompleto = FALSE;
	private $aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo = array();

    private $oElencoMappeCompleto = FALSE;
    private $aElencoTipoDispositivoCompletoByIdMappa = array();


    /*********************************************************************************************************/
public function __construct($logga = FALSE, $permesso = NULL, $frontend = FALSE, $lang = FALSE) {
	$script = str_replace($_SERVER['DOCUMENT_ROOT'].'/','', $_SERVER['SCRIPT_FILENAME']);
	$script = str_replace(realpath($_SERVER['DOCUMENT_ROOT']).'/','', $script);
	$script = str_replace('index.php','elenco', $script);
	$script = str_replace('.php','', $script);
	$script = str_replace('/','_', $script);
	$script = str_replace('-','_', $script);

	// SERVE PER LA DIFFERENTE GESTIONE DI STRUTTURA DI FRONTEND E BACKEND
	if (strpos($_SERVER['SCRIPT_FILENAME'],'/frontend') !== FALSE){
		$script = 'frontend_'.$script;
	}
	
	if ($frontend) {
		$this->frontend = TRUE;
		$this->backend = FALSE;   
		$this->tabellaDizionario = 'dizionario_frontend';	
	} else {
		$this->frontend = FALSE;
		$this->backend = TRUE;   
		$this->tabellaDizionario = 'dizionario_backend';	
	}
	
	if (is_null($permesso)) {
		$this->permesso = strtoupper($script);
	} else {
		verificaParametro(($permesso !== PERMESSO_NESSUNO), __METHOD__.': ATTENZIONE: hai messo un permesso errato');
		$this->permesso = PERMESSO_NESSUNO;
	}
	verificaParametro((empty($this->permesso)), __METHOD__.': SETTA IL LIVELLO DI PERMESSO DELLA PAGINA');
	
	/*
	$browser = new browser();
	if( $browser->getBrowser() == Browser::BROWSER_IE && $browser->getVersion() <= 8 ) {
		header("Location: ".REDIRECT_IE_OLD);
	}
	*/
	
	/*
	$mobile = new mobiledetect();
	if($mobile->isMobile()) {
		header("Location: ".BASE_URL.'nomobile.php');
	}
	*/
	@session_start();
	$this->oDb = new db();

	$this->settaCostantiDaDb();
	
	
	if($lang === FALSE) {
		if (!isset($_SESSION['LINGUA_NAVIGAZIONE'])) $_SESSION['LINGUA_NAVIGAZIONE'] = LINGUA_NAVIGAZIONE;
	} else {
		$_SESSION['LINGUA_NAVIGAZIONE'] = $lang;
	}
    $this->lang = $_SESSION['LINGUA_NAVIGAZIONE'];
	$this->includeFile();
	
	$this->nome = strtoupper($script);
	$this->classe = $this->nome;
    $this->callback = strtolower($script);
	//$this->permesso = strtoupper($permesso);
	$this->logga = (bool)$logga;
	
	$this->recuperaUtenteDaSessione();
	$this->_CHECK_LOGIN();
	
	if ($this->frontend && MANUTENZIONE_FRONTEND) {
		if (!in_array($_SERVER['REMOTE_ADDR'], unserialize(MANUTENZIONE_IP_CONSENTITI))) header("Location: ".DOMINIO_FRONTEND."manutenzione.php");
	}	
	if ($this->backend && MANUTENZIONE_BACKEND) {
		if (!in_array($_SERVER['REMOTE_ADDR'], unserialize(MANUTENZIONE_IP_CONSENTITI))) header("Location: ".DOMINIO_FRONTEND."manutenzione.php");
	}
	
	if (PAGE_NAME == 'dashboard') {
        $this->oElencoTipoDispositivoCompleto = new elencotipodispositivo($this, TRUE);
        if (!$this->oElencoTipoDispositivoCompleto->isEmpty()) {
			foreach ($this->oElencoTipoDispositivoCompleto->getElenco() as $oTipoDispositivo) {
				$oElencoSottoTipoDispositivo = new elencosottotipodispositivo($this);
                $oElencoSottoTipoDispositivo->caricaPerDispositivo($oTipoDispositivo);
                $this->aElencoSottoTipoDispositivoCompletoByIdTipoDispositivo[$oTipoDispositivo->get('id_tipo_dispositivo')] = $oElencoSottoTipoDispositivo;
            }
        }
	}
	
	$_SESSION['MODO_OPERATIVO'] = $this->loadMode();
	$_SESSION['MODO_OPERATIVO_LOGGATO'] = $this->loadModeLogin();

	$modo = $this->loadMode();
	$path = str_replace($_SERVER['DOCUMENT_ROOT'], "", $_SERVER['SCRIPT_FILENAME']);

	$notRedirectedPaths = [
		'/backend/dashboard/ajax/status.php',
		'/backend/azioni/check_new_alert.php',
		'/azioni/lang.php', 
		'/backend/sistema/modo.php', 
		'/azioni/login.php', 
		'/azioni/logout.php', 
		'/index.php', 
		'/', 
		'/azioni/selezione_modo.php'
	];

	if($modo == 'undefined' && !in_array($path, $notRedirectedPaths)) {
		header("Location:/backend/sistema/modo.php");
		die;
	}
	
	if($modo == 'legacy' && !in_array($path, $notRedirectedPaths)) {
		header("Location:/hotel/admin/main.php?incf=rooms-configurator.php");
		die;
	}
	
	//if ($this->logga) $this->log_attivita();
	
	$langFile = realpath($_SERVER['DOCUMENT_ROOT']).'/v2/multilang/'. $_SESSION['LINGUA_NAVIGAZIONE'] . ".php";
	if(file_exists($langFile)) {
		require_once($langFile);
	}

}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function settaCostantiDaDb() {
    $rows = $this->oDb->eseguiselect('SELECT * FROM parametri');
    foreach ($rows as $r) {
        if (!defined('PARAM_'.strtoupper($r['chiave']))) define('PARAM_'.strtoupper($r['chiave']), $r['valore']);
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*
public function __sleep() {
	$ret = array();
	foreach ($this as $attributo => $valore) {
		if (!in_array($attributo, unserialize(aATTRIBUTI_DA_NON_SERIALIZZARE))) {
			$ret[] = $attributo;
		}
	}
	return $ret;
} 
*/
/*********************************************************************************************************/
/*********************************************************************************************************/
public function postBack(){
	if (!empty($_POST)) {
		$_SESSION['$_POST'] = $_POST;
	} else {
		if (isset($_SESSION['$_POST'])) {
			unset($_SESSION['$_POST']);
		}
	}
}	
/*********************************************************************************************************/
public function getBack(){
	if (!empty($_GET)) {
		$_SESSION['$_GET'] = $_GET;
	} else {
		if (isset($_SESSION['$_GET'])) {
			unset($_SESSION['$_GET']);
		}
	}
}
/*********************************************************************************************************/
public function eliminaDatiDoPostBack() {
	$this->eliminaDatiDoPostBack = FALSE;
}	
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI PUBBLICI
/*********************************************************************************************************/
/*********************************************************************************************************/
public function disegna($template, $callback = null) {
	verificaParametro((!isset($this->logga)), __METHOD__.': DEVI IMPOSTARE IL LIVELLO DI LOG DELLA PAGINA TRUE/FALSE');
	verificaParametro((empty($template)), __METHOD__.': STAI PROVANDO A DISEGNARE UNA PAGINA SENZA UN TEMPLATE');
	verificaParametro((empty($this->sezione)), __METHOD__.': DEVI IMPOSTARE LA SEZIONE IN CUI LA PAGINA E\'. $oApp->sezione(\'SEZIONE_xxxx\'). Le sezioni sono definite dalle costanti SEZIONE_xxxx');
	//verificaParametro((empty($this->titolo)), __METHOD__.': DEVI IMPOSTARE IL TITOLO DELLA PAGINA. $oApp->titolo(\'abc def ghi\'). Il titolo deve corrispondere all\'etichetta del dizionario');
	
	$this->template = $template;
	$this->pagina(TRUE, $callback);
}
/*********************************************************************************************************/
public function esegui($callback = null) {
	$this->pagina(FALSE, $callback);
}
/*********************************************************************************************************/
public function redirect($page, $messaggio = null, $tipo = null, $extraParams = null) {
	verificaParametro((empty($messaggio) && !empty($tipo)), __METHOD__.' errore: versione vecchia del metodo. AGGIORNARLA.');
	
	$redStr = DOMINIO . $page;
	$redStr = $page;
	if (!empty($messaggio)) {
		verificaParametro((empty($tipo)), __METHOD__.' deve essere inserito il tipo di messaggio');
		$_SESSION['messaggio'][$tipo] = trim($messaggio);
	}
	if (!empty($extraParams)) {
		if (strpos($redStr,'?') !== FALSE) {
			$redStr .= '&';
		} else {
			$redStr .= '?';
		}
		$redStr .= $extraParams;
	}
	
	if ($tipo == MESSAGGIO_SUCCESSO && isset($_POST)) unset($_POST);
	if ($tipo == MESSAGGIO_SUCCESSO && isset($_GET)) unset($_GET);
	
	header("Location:" . $redStr);
}
/*********************************************************************************************************/
public function setClass($classe) {
	$this->classe = (string)$classe;
}
/*********************************************************************************************************/
public function setTitoloPagina($titolo) {
	$this->titolo = (string)$titolo;
}
/*********************************************************************************************************/
public function setSottoMenu($sottomenu) {
	$this->sottomenu = (string)$sottomenu;
}
/*********************************************************************************************************/
public function setSottoSottoMenu($sottomenu) {
	$this->sottosottomenu = (string)$sottomenu;
}
/*********************************************************************************************************/
/*
public function getMsg_OLD($msg, $msgDefault = '') {
	if (array_key_exists($msg, $this->aMsg)) return $this->aMsg[$msg];
	if (array_key_exists($msgDefault, $this->aMsg)) return $this->aMsg[$msgDefault];
	if (APP_SVILUPPO) {
		$sql = 'SELECT count(*) FROM dizionario WHERE '.$this->lang.' = '.stripcslashesandquote(strtoupper($msg));
		$esiste = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
		if (!$esiste) { 
			$strCampi = '';
			$strValori = '';
			foreach (unserialize(LINGUE_ATTIVE) as $lang) {
				$strCampi  .= ','.$lang;
				$strValori .= ','.stripcslashesandquote(strtolower($lang.' - '.$msg));
			}
			$sql = 'INSERT INTO dizionario (etichetta'.$strCampi.') VALUES ('.stripcslashesandquote(strtoupper($msg)).$strValori.')';
			$this->oDb->eseguiinsert($sql);
			$this->caricaMessaggi();
			$this->getMsg($msg,$msgDefault);
		}
	}
	return '';
}
*/
/*********************************************************************************************************/
private function getEtichettaBasic($msg, $tipo, $msgDefault) {
	//verificaParametro((stripos($msg, ' ')!== FALSE), __METHOD__ .' etichetta non valida - '.$msg);
	
	$sezione = strtoupper($this->sezione);
	$aA = $this->aEtichette[$tipo];
	$debug = isset($_GET['dizionario']);
	
	$msg = strtoupper($msg);
	if (isset($aA[$sezione][$msg])) {
		return(($debug)?'['.$aA[$sezione][$msg]['id'].'] ':'').$aA[$sezione][$msg]['valore'];
	}
	
	if (isset($aA['DEFAULT'][$msg])) {
		return (($debug)?'['.$aA['DEFAULT'][$msg]['id'].'] ':'').$aA['DEFAULT'][$msg]['valore'];
	}
	
	if (isset($aA[$sezione][$msgDefault])) {
		return (($debug)?'['.$aA[$sezione][$msgDefault]['id'].'] ':'').$aA[$sezione][$msgDefault]['valore'];
	}
	
	if (isset($aA['DEFAULT'][$msgDefault])) {
		return (($debug)?'['.$aA['DEFAULT'][$msgDefault]['id'].'] ':'').$aA['DEFAULT'][$msgDefault]['valore'];
	}
	
	if (APP_SVILUPPO) $this->inserisciNuovaEtichetta($msg, $tipo);
	return 'etichetta non trovata  - TIPO:'.$tipo.' - SEZIONE: '.$sezione.' - ETICHETTA: '.$msg;
}
/*********************************************************************************************************/
private function inserisciNuovaEtichetta($msg, $tipo) {
	if ($tipo == 'SEO') return;
	$sql = 'SELECT count(*) 
	          FROM '.$this->tabellaDizionario.' 
			 WHERE tipo='.stripcslashesandquote(strtoupper($tipo)).' 
			   AND sezione='.stripcslashesandquote(strtoupper($this->sezione)).'
			   AND etichetta='.stripcslashesandquote(strtoupper($msg));
	$esiste = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	if ($esiste == 0) { 
		$sql = 'SELECT count(*) 
				  FROM '.$this->tabellaDizionario.' 
				 WHERE tipo='.stripcslashesandquote(strtoupper($tipo)).' 
				   AND sezione="DEFAULT"
				   AND etichetta='.stripcslashesandquote(strtoupper($msg));
		$esiste = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	}
	
	if ($esiste == 0) { 
		$strCampi = '';
		$strValori = '';
		foreach (unserialize(LINGUE_ATTIVE) as $lang) {
			$strCampi  .= ','.$lang;
			$strValori .= ','.stripcslashesandquote(strtolower('TRADURRE - '. $lang.' - '.$msg));
		}
		$sql = 'INSERT INTO '.$this->tabellaDizionario.' (tipo, sezione, etichetta'.$strCampi.') 
					 VALUES ('.stripcslashesandquote(strtoupper($tipo)).',
							 "DEFAULT",
							 '.stripcslashesandquote(strtoupper($msg)).
							 $strValori.')';
		$this->oDb->eseguiinsert($sql);
	}
}
/*********************************************************************************************************/
public function getEtichettaMenu($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'MENU', $msgDefault);
}
/*********************************************************************************************************/
public function getEtichettaTabella($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'TABELLA', $msgDefault);
}
/*********************************************************************************************************/
public function getEtichettaBottone($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'BOTTONE', $msgDefault);
}
/*********************************************************************************************************/
public function getEtichetta($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'ETICHETTA', $msgDefault);
}
/*********************************************************************************************************/
public function getMsgInfo($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'MSG_INFO', $msgDefault);
}
/*********************************************************************************************************/
public function getMsgErrore($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'MSG_ERRORE', $msgDefault);
}
/*********************************************************************************************************/
public function getMsgConferma($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'MSG_CONFERMA', $msgDefault);
}
/*********************************************************************************************************/
public function getMsgSuccesso($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'MSG_SUCCESSO', $msgDefault);
}
/*********************************************************************************************************/
public function getSeo($msg, $msgDefault = '') {
	//return $this->getEtichettaBasic($msg, 'SEO', $msgDefault);
	return TAG_TITLE_DEFAULT;
}
/*********************************************************************************************************/
public function getEtichettaTitolo($msg, $msgDefault = '') {
	return $this->getEtichettaBasic($msg, 'TITOLO', $msgDefault);
}
/*********************************************************************************************************/
public function getOAnnualita() {
	if ($this->oAnnualita === FALSE) {
		$id = getIdAnnualitaAttiva($this->oDb);
		if ($id !== FALSE) $this->oAnnualita = new annualita($this, $id);
	}
	return $this->oAnnualita;
}
/*********************************************************************************************************/
public function getOCooperativa() {
	if ($this->oCooperativa === FALSE) {
		$id = getIdCooperativaAttiva($this->oDb);
		if ($id !== FALSE) $this->oCooperativa = new agenzia($this, $id);
	}
	return $this->oCooperativa;
}
/*********************************************************************************************************/
public function getUtente() {
	return $this->oUtente;
}
/*********************************************************************************************************/
public function setUtente($oUtente) {
	instance_of($oUtente, 'utente');
	$this->oUtente = $oUtente;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getLinkChangeLang($lang) {
	/*
	$lingue = array_keys(unserialize(LINGUE_ATTIVE));
	if (!in_array($lang, $lingue)) {
		$lang = DEFAULT_LANG;		
	}

	$qstring = '';
	if (!empty($_GET)) {	
		foreach ($_GET as $k => $v) {
			if (!empty($qstring)) $qstring .= '&amp;';
			if (empty($qstring)) $qstring .= '?';
			$qstring .= $k.'='.$v; 
		}
	}
	
	$url = $_SERVER['PHP_SELF'].$qstring;
	foreach ($lingue as $l) {
		if (stripos($url, '/'.$l.'/') !== FALSE) {
			return str_replace('/'.$l.'/', '/'.$lang.'/', $url);	
		}
	}*/
}
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI PRIVATI
/*********************************************************************************************************/
private function pagina($html, $callback) {
	if (!is_null($callback)) {
		$this->callback = $callback;
	}
	
  	// TODO gzip del contenuto ob_start("ob_gzhandler");
  	//ob_start();
	if ($html) {
		echo $this->html();
	} else {
	  	$callback = $this->callback; 
		echo $callback($this);
	}
	//$stringa = ob_get_contents();
  	//ob_end_clean();

  	//echo str_replace("><", ">\r\n<", $stringa);
  	//echo $stringa;
	
	if ($this->eliminaDatiDoPostBack) {
		$this->postBack();
		$this->getBack();
	}
}
/*********************************************************************************************************/
private function includeFile() {
	
	//INCLUDO LE LIBRERIE GENERALI
	// require_once(DIR_LIB . 'lib.debug.php');
	// require_once(DIR_LIB . 'lib.generali.php');
	// require_once(DIR_LIB . 'lib.output.php');
	// require_once(DIR_LIB . 'lib.html.php');

	//CARICO IL FILE DEI MESSAGGI
	// require_once(DIR_MSG . $this->lang . '/msg.php.inc');
	// $this->aMsg = $aMsg;
	$this->caricaMessaggi();

}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function html() {
	if (empty($this->htmlBody)) {
		
		$this->head($this, $this->oUtente, $this->template);
		$this->javascript($this, $this->oUtente, $this->template);

		// deve essere dopo a head e javascript
		$this->body($this, $this->oUtente, $this->template);
	}

	return '<!DOCTYPE html>
			<html lang="en">
				<head>'.$this->htmlHead.'</head>
				<body id="'.strtolower($this->nome).'" class="fixed-nav sticky-footer bg-dark'.((PAGE_NAME == 'dashboard')?' sidenav-toggled':'').'">
				<div id="veil">
					<i class="fa fa-spinner fa-spin"></i>
					<p id="veilMessage"></p>
				</div>
				'.$this->htmlBody.$this->htmlJscript.'</body>
			</html>';
	
	//<body class="html not-front not-logged-in no-sidebars page-node page-node- page-node-1006122 node-type-news section-60-market" >
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function head($oApp, $oUtente, $area) {
	ob_start();
	require_once DIR_HTM.$area.'/head.php';
	$this->htmlHead .= ob_get_contents();
	ob_end_clean();
		
	$this->settaCostantiJs();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function body($oApp, $oUtente, $area) {
	ob_start();
	require_once DIR_HTM.$area.'/body.php';
	$this->htmlBody .= ob_get_contents();
	ob_end_clean();
}
/*********************************************************************************************************/
private function javascript($oApp, $oUtente, $area) {
	ob_start();
	if (PAGE_NAME == 'dashboard') {
	    require_once DIR_HTM.$area.'/javascript_dashboard.php';
    } else {
	    require_once DIR_HTM.$area.'/javascript.php';
    }
	$this->htmlJscript .= ob_get_contents();
	ob_end_clean();
}










/*********************************************************************************************************/
/*********************************************************************************************************/
private function callback() {
	ob_start();
	$callback = $this->callback; 
	echo $callback($this);
	$html = ob_get_contents();
  	ob_end_clean();
  	return $html;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function settaCostantiJs() {


	$this->htmlHead .= NL.'<script type="text/javascript">'.NL;
	$this->htmlHead .= 'var PAGINA_CORRENTE = "' . $this->nome . '";'.NL;
	$this->htmlHead .= 'var URL_BACKEND = "' . URL_BACKEND . '";'.NL;
    $this->htmlHead .= 'var URL_FRONTEND = "' . URL_FRONTEND . '";'.NL;
	$this->htmlHead .= 'var URL_AZIONI = "' . URL_AZIONI . '";'.NL;
	$this->htmlHead .= 'var URL_AZIONI_BACKEND = "' . URL_AZIONI_BACKEND . '";'.NL;
	$this->htmlHead .= 'var MAX_SIZE_FILE_UPLOAD = "' . MAX_SIZE_FILE_UPLOAD . '";'.NL;
	$this->htmlHead .= 'var MAX_SIZE_FILE_UPLOAD_PER_JS = "' . MAX_SIZE_FILE_UPLOAD_PER_JS . '";'.NL;
	$this->htmlHead .= 'var ELENCO_ALLARMI_MENU_MAX_ALLARMI = "' . ELENCO_ALLARMI_MENU_MAX_ALLARMI . '";'.NL;

	if ($this->oUtente !== FALSE) {
		if(isset($_SESSION['PERSONALIZZAZIONI']['VISTA_AGENDA'])){
			//$this->htmlHead .= 'var PERSONALIZZAZIONI_VISTA_AGENDA = "' . $_SESSION['PERSONALIZZAZIONI']['VISTA_AGENDA']  . '";'.NL;
		}
	}
	
	//$this->htmlHead .= 'var STR_IMMAGINI_ESTENSIONI_AMMESSE = "' . getStrImmaginiEstensioniAmmesse(unserialize(IMMAGINI_ESTENSIONI_AMMESSE)) . '";'.NL;
	
	/*
	if ($this->oUtente !== FALSE) {
		$this->htmlHead .= 'var ID_UTENTE_LOGGATO = "' . $this->oUtente->getId() . '";'.NL;
	}
	$this->htmlHead .= 'var DIR_MSG = "' . DIR_MSG . '";'.NL;
	$this->htmlHead .= 'var URL_IMG = "' . URL_IMG . '";'.NL;
	$this->htmlHead .= 'var URL_ADMIN = "' . URL_BACKEND . '";'.NL;
	$this->htmlHead .= 'var URL_AZIONI = "' . URL_AZIONI . '";'.NL;
	$this->htmlHead .= 'var URL_AZIONI_ADMIN = "' . URL_AZIONI_ADMIN . '";'.NL;
	*/
	foreach ($this->caricaMessaggiPerJs() as $etichetta=>$messaggio) {
		$this->htmlHead .= 'var '.strtoupper(str_replace('-','',str_replace(' ','_',$etichetta))).' = "' . str_replace('"','\"',$messaggio) . '";'.NL;
	}
	
	$this->htmlHead .= '</script>'.NL;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function menuBackend($nome_menu, $id = 'menu'){
	$vociStampa = $this->getMenu($nome_menu);

	$menuStr = '';
	if (!empty($vociStampa) && is_array($vociStampa)) {
		$menuStr .= '<ul style="margin-top: 68px;" class="navbar-nav navbar-sidenav" id="'.strtolower($id).'">';
		
		$sql = 'select * from supervisore where id_tipo_dispositivo = -1 and id_status = 1;';
		$rows = $this->oDb->eseguiselect($sql);

		$hideFireAlarm = (count($rows) == 0 || !MONO_EXISTS);

		foreach ($vociStampa as $voce) {
			$liClasse = 'nav-item item-label-' . strtolower($voce['etichetta']) . ' item-id-' . strtolower($voce['id_menu']);
			
			if($hideFireAlarm && strtolower($voce['etichetta']) == 'fire_alarm') {
				$liClasse .= ' disabled ';
			}
			
            $aClasse = 'nav-link';
			$secondoLivello = '';
			$classeSottoMenu = '';
			$iconOff = '';
			$badge = '';
			$clickJs = '';
			$url = URL_BACKEND.$voce['pagina'];
			$etichetta = $this->getEtichettaMenu($voce['etichetta']);
			$vociStampa2 = '';
			
			if ($this->sezione == $voce['sezione']) {
				$liClasse .= ' current ';
				if(!defined('CURRENT_PAGE_TITLE')) {
					define('CURRENT_PAGE_TITLE', $etichetta);
				}
				$classeSottoMenu = 'expanded';
			}
			if (!empty($voce['classe_icona'])) {
				$iconOff = '<i class="'.$voce['classe_icona'].'"></i> ';
			}
			if (!empty($voce['sottomenu'])) {
				$vociStampa2 = $this->getMenu($voce['sottomenu']);
			}
			if (!empty($vociStampa2)) {
				$url = '#'.strtolower($voce['sottomenu']);
				//$badge = '<span class="badge">'.count($vociStampa2).'</span>';
				$badge = '';
				$aClasse .= ' nav-link-collapse collapsed ';
                $secondoLivello = ' data-toggle="collapse" data-parent="'.strtolower($id).'" ';
			}
			if ($voce['sezione'] == 'logout') {
                $liClasse .= ' logout-js ';
				$clickJs = ' data-rel="'.$url.'" ';
			}
			
			$menuStr .= '<li class="'.$liClasse.'" data-toggle="tooltip" data-placement="right" title="'.$etichetta.'">';
            $menuStr .= '<a class="'.$aClasse.' '.((!empty($voce['style']))?$voce['style']:'').'" href="'.$url.'"'.$clickJs.$secondoLivello.'>';
            $menuStr .= $iconOff;
			$menuStr .= '<span class="nav-link-text">';
			$menuStr .= $etichetta;
			$menuStr .= $badge;
            $menuStr .= '</span>';
            $menuStr .= '</a>';

			if (!empty($vociStampa2)) {
				$menuStr .= '<ul class="sidenav-second-level collapse" id="'.strtolower($voce['sottomenu']).'">';
				foreach ($vociStampa2 as $voce2) {
					$url2 = URL_BACKEND.$voce2['pagina'];
					//$clickJs2 = 'class="logout-js" data-rel="'.$url2.'"';
					$etichetta2 = $this->getEtichettaMenu($voce2['etichetta']);
					if ($voce2['etichetta'] == 'UTENTI_PROFILO_ELIMINA') $url2 = $url2.'?oggetto=utente&id_oggetto='.writeGetParam($this->getIdUtenteLoggato());
					$menuStr .= '<li><a href="'.$url2.'" class="'.((!empty($voce2['style']))?' '.$voce2['style'].' ':'').$classeSottoMenu.'">'.$etichetta2.'</a></li>';
				}
				$menuStr .= '</ul>';
			}
			$menuStr .= '</li>';
		}
		$menuStr .= '</ul>';
		unset($vociStampa);
	}
	unset($menu);
	return $menuStr;

}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function getMenu($menu) {
        
    $menu = $this->oDb->eseguiselect('SELECT * FROM menu WHERE menu = '.stripcslashesandquote($menu).' ORDER BY ordine');
	$vociStampa = array();
	foreach ($menu as $voce) {
		/*
		$c1 = ($voce['permesso'] === pNESSUNO);
		$c2 = FALSE;
		
		if (stripos($voce['permesso'], ',') !== FALSE) {
			$aP = explode(',', $voce['permesso']);
            $permessi = array();
			foreach ($aP as $p) {
				if ($this->oUtente !== FALSE && $this->oUtente->haPermesso(constant($p))) {
					$c2 = TRUE;
					break;
				}
			}
		} else {
			$c2 = ($this->oUtente !== FALSE && $this->oUtente->haPermesso(constant($voce['permesso'])));
		}
        
		if ( $c1 || $c2 ) {
			if (!isset($vociStampa) || !is_array($vociStampa)) {
				$vociStampa = array();
			}
			$vociStampa[] = $voce;
		}
		*/
		
		$c1 = ($this->oUtente !== FALSE);
		$c2 = ($this->oUtente->haPermesso('MENU_'.$voce['etichetta']));


		if ($c1 && $c2) {
			if (!isset($vociStampa) || !is_array($vociStampa)) {
				$vociStampa = array();
			}
			$vociStampa[] = $voce;
		}
	}
	
	return $vociStampa;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function displayMessages() {
	foreach(unserialize(aTIPI_MESSAGGI_ERRORE) as $tipo) {
		if (array_key_exists('messaggio', $_SESSION) && array_key_exists($tipo, $_SESSION['messaggio'])) {
			if($tipo == MESSAGGIO_ERRORE || $tipo == MESSAGGIO_WARNING)
			{
				switch ($tipo) {
					case MESSAGGIO_ERRORE:
						$icona = 'cus-cross-octagon';
					break;
					case MESSAGGIO_INFO:
						$icona = 'cus-exclamation';
					break;
					case MESSAGGIO_WARNING:
						$icona = 'cus-exclamation-octagon-fram';
					break;
					case MESSAGGIO_SUCCESSO:
						$icona = 'cus-accept';
					break;
				}
				
				echo '<div class="alert adjusted '.$tipo.' messaggio_feedback">
										<button class="close" data-dismiss="alert">×</button>
										<i class="'.$icona.'"></i>
										'.$_SESSION['messaggio'][$tipo].'
									</div>';
			}
			unset($_SESSION['messaggio'][$tipo]);
		}
	}
}
/*********************************************************************************************************/
private function daIncludere($sezioni) {
	$retVal = TRUE;
	if (count($sezioni) > 0) {
		$retVal = FALSE;
		foreach ($sezioni as $p) {
			if (strpos($this->nome, $p) !== FALSE) {
				$retVal = TRUE;
			}
		}
	}
	return $retVal;
}
/*********************************************************************************************************/
private function includeJs($nomeFile, $sezioni = array()) {
  	if ($this->daIncludere($sezioni)) {
  		//echo '<script type="text/javascript" src="'.URL_AZIONI.'js.php?f='.$nomeFile.'"></script>'.NL;
  		return '<script type="text/javascript" src="'.URL_JSC.$nomeFile.'"></script>'.NL;
  	}
}
/*********************************************************************************************************/
private function includeRemoteJquery() {
	$this->htmlHead .= '<script type="text/javascript" src="'.JQUERY_GOOGLE_URL.'"></script>'.NL;
   	$this->htmlHead .= '<script type="text/javascript" src="'.JQUERY_UI_GOOGLE_URL.'"></script>'.NL;
}
/*********************************************************************************************************/
private function includeCss($nomeFile, $pagine = array(), $media = 'screen') {
	if ($this->daIncludere($pagine)) {
		$this->htmlHead .= '<link type="text/css" rel="stylesheet" href="'.URL_CSS.$nomeFile.'" media="'.$media.'" charset="'.CHARSET.'" />'.NL;
  	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function _CHECK_LOGIN() {
	if ($this->permesso != PERMESSO_NESSUNO) {
		if ($this->oUtente === FALSE || !$this->oUtente->haPermesso('PAGINA_'.$this->permesso)) {
			header("location: ".DOMINIO);	
			die;	
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function utentePuo($permesso) {
	return ($this->oUtente !== FALSE && $this->oUtente->haPermesso($permesso));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setPagination__OLD($val, $totaleElementi, $numeroElementiPerPagina, $paginationTarget, $pagina = 1) {
	$this->pagination = (bool)$val;	
	$this->pagina = $pagina;
	$this->numeroPagine = ceil($totaleElementi / $numeroElementiPerPagina);
	$this->paginationTarget = $paginationTarget;
	
	$min = ($pagina - 1) * $numeroElementiPerPagina;
	$max = ($pagina - 1) * $numeroElementiPerPagina + $numeroElementiPerPagina;
	$max = min($max, $totaleElementi);
	
	return array($min, $max); 
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPagination__OLD($pagina) {
	if ($this->numeroPagine !== 1) {
		echo '<ul>';
		$concatenatore = '&amp;';
		if (strpos($this->get('paginationTarget'), '?') === FALSE) {
			$concatenatore = '?';
		}
		$url = $this->get('paginationTarget') . $concatenatore . 'pagina=';
		
		if ($this->get('pagina') != 1) {
			echo '<li><a href="' . $url . ($this->pagina - 1) . '">&gt;&gt;</a></li>';
		} else {
			echo '<li><span class="disattivato">&gt;&gt;</span></li>';
		}
	
		for ($i = 1; $i <= $this->get('numeroPagine'); ++$i) {
			if ($i == $this->get('pagina')) {
				echo '<li><span>'.$i.'</span></li>';
			} else {
				echo '<li><a href="' . $url . $i . '">'.$i.'</a></li>';
			}
		}
		
		if ($this->get('pagina') != $this->get('numeroPagine')) {
			echo '<li><a href="' . $url . ($this->get('pagina') + 1) . '">&lt;&lt;</a></li>';
		} else {
			echo '<li><span class="disattivato">&lt;&lt;</span></li>';
		}
		echo '</ul>';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPagination2__OLD($pagina) {
	if ($this->numeroPagine !== 1) {
		echo '<ul>';
		$concatenatore = '&amp;';
		if (strpos($this->get('paginationTarget'), '?') === FALSE) {
			$concatenatore = '?';
		}
		$url = $this->get('paginationTarget') . $concatenatore . 'pagina=';
		
		if ($this->get('pagina') != $this->get('numeroPagine')) {
			echo '<li><a href="' . $url . ($this->get('pagina') + 1) . '">&gt;&gt;</a></li>';
		} else {
			echo '<li><span class="disattivato">&gt;&gt;</span></li>';
		}

		for ($i = 1; $i <= $this->get('numeroPagine'); ++$i) {
			$pg = ($this->get('numeroPagine') - $i) + 1;
			if ($pg == $this->get('pagina')) {
				echo '<li><span>'.$pg.'</span></li>';
			} else {
				echo '<li><a href="' . $url . $pg . '">'.$pg.'</a></li>';
			}
		}

		if ($this->get('pagina') != 1) {
			echo '<li><a href="' . $url . ($this->pagina - 1) . '">&lt;&lt;</a></li>';
		} else {
			echo '<li><span class="disattivato">&lt;&lt;</span></li>';
		}
		
		echo '</ul>';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPaginationLTR__OLD($pagina) {
	if ($this->numeroPagine !== 1) {
		echo '<ul>';
		$concatenatore = '&amp;';
		if (strpos($this->get('paginationTarget'), '?') === FALSE) {
			$concatenatore = '?';
		}
		$url = $this->get('paginationTarget') . $concatenatore . 'pagina=';
		
		if ($this->get('pagina') != 1) {
			echo '<li><a href="' . $url . ($this->get('pagina') - 1) . '">&lt;&lt;</a></li>';
		} else {
			echo '<li><span class="disattivato">&lt;&lt;</span></li>';
		}

		for ($i = 1; $i <= $this->get('numeroPagine'); ++$i) {
			//$pg = ($this->get('numeroPagine') - $i) + 1;
			$pg = $i;
			if ($pg == $this->get('pagina')) {
				echo '<li><span>'.$pg.'</span></li>';
			} else {
				echo '<li><a href="' . $url . $pg . '">'.$pg.'</a></li>';
			}
		}

		if ($this->get('pagina') != $this->get('numeroPagine')) {
			echo '<li><a href="' . $url . ($this->pagina + 1) . '">&gt;&gt;</a></li>';
		} else {
			echo '<li><span class="disattivato">&gt;&gt;</span></li>';
		}
		
		echo '</ul>';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function get($propertyName){
	$metodo = 'get' . str_replace('_', '', $propertyName);
	if (method_exists($this, $metodo)) {
		return $this->$metodo();
	} else {
		return $this->$propertyName;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function set($propertyName, $valore){
	$metodo = 'set' . str_replace('_', '', $propertyName);
	if (method_exists($this, $metodo)) {
		$this->$metodo($valore);
	} else {
		$this->$propertyName = $valore;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getNominativoUtenteLoggato() {
	return $this->oUtente->get('nome') . ' ' . $this->oUtente->get('cognome');	
}	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIdUtenteTipoLoggato() {
	if ($this->oUtente !== FALSE) {
		return $this->oUtente->get('id_utente_tipo');
	} else {
		return FALSE;	
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIdUtenteLoggato() {
	if ($this->oUtente !== FALSE) {
		return $this->oUtente->get('id_utente');
	} else {
		return FALSE;	
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIdAgenziaUtenteLoggato() {
	if ($this->oUtente !== FALSE) {
		return $this->oUtente->get('id_agenzia');
	} else {
		return FALSE;	
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIdTipoUtenteLoggato() {
	if ($this->oUtente !== FALSE) {
		return $this->oUtente->get('id_utente_tipo');
	} else {
		return FALSE;	
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getCodicePermessoUtenteLoggato() {
	if ($this->oUtente !== FALSE) {
		return $this->oUtente->get('codice_permesso');
	} else {
		return FALSE;	
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function log_attivita() {
	$id_utente = 0;
	if ($this->oUtente !== FALSE) {
		$id_utente = $this->oUtente->getId();
	}
	
	$ip = $_SERVER['REMOTE_ADDR'];
	$pagina = $_SERVER['REQUEST_URI'];
	$query = '';
	if (isset($_SERVER['QUERY_STRING'])) {
		$query = $_SERVER['QUERY_STRING'];
	}
	if (strlen($query) > 255) {
		$url = substr($query, 0, 255);
	}
	$url = '';
	if (isset($_SERVER['HTTP_REFERER'])) {
		$url = $_SERVER['HTTP_REFERER'];
	}
	if (strlen($url) > 255) {
		$url = substr($url, 0, 255);
	}
	$useragent = '';
	if (isset($_SERVER['HTTP_USER_AGENT'])) {
		$useragent = $_SERVER['HTTP_USER_AGENT'];
	}
	
	$nazione = '##';
	/*
	$tags = get_meta_tags('http://www.geobytes.com/IpLocator.htm?GetLocation&template=php3.txt&IpAddress='.$_SERVER['REMOTE_ADDR']);
	if (is_array($tags) && array_key_exists('iso2', $tags)) {
		$nazione = strtoupper($tags['iso2']);
	}
	*/
	
	$sql = 'INSERT INTO log_attivita (id_utente, 
									  sessione,
									  area,
									  ip, 
									  nazione,
									  pagina,
									  querystring,
									  url_provenienza,
									  user_agent
									 ) VALUES (
									  '.stripcslashesandquote($id_utente).',
									  '.stripcslashesandquote(session_id()).',
									  '.stripcslashesandquote(((stripos($pagina, 'backend') !== FALSE)?'BACKEND':((stripos($pagina, 'frontend') !== FALSE)?'FRONTEND':'ALTRO'))).',
									  INET_ATON('.stripcslashesandquote($ip).'),
									  '.stripcslashesandquote($nazione).',
									  '.stripcslashesandquote($pagina).',
									  '.stripcslashesandquote($query).',
									  '.stripcslashesandquote($url).',
									  '.stripcslashesandquote($useragent).'
								     )';
	$this->oDb->eseguiinsert($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function caricaMessaggi() {
	$sql = 'SELECT CONCAT(sezione, "-", tipo, "-", etichetta) AS id_etichetta, sezione, tipo, etichetta, '.$this->lang.' AS valore FROM '.$this->tabellaDizionario.'';
	$rows = $this->oDb->eseguiselect($sql);
	foreach ($rows as $r) {
		$this->aMsg[$r['etichetta']] = $r['valore'];
		$this->aEtichette[$r['tipo']][$r['sezione']][$r['etichetta']] = array('id' => $r['id_etichetta'], 'valore'=> $r['valore']);
	}
	
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function caricaMessaggiPerJs() {
	$msg = array();
	//$sql = 'SELECT CONCAT(sezione, "-", tipo, "-", etichetta) AS etichetta, '.$this->lang.' AS valore FROM '.$this->tabellaDizionario.' WHERE usaPerJs = 1';
	$sql = 'SELECT etichetta, '.$this->lang.' AS valore FROM '.$this->tabellaDizionario.' WHERE usaPerJs = 1';
	$rows = $this->oDb->eseguiselect($sql);
	foreach ($rows as $r) {
		$msg[$r['etichetta']] = $r['valore'];
	}
	return $msg;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function recuperaUtenteDaSessione() {
	if (!empty($_SESSION['UTENTE_LOGGATO'])) {	
		$this->oUtente = unserialize($_SESSION['UTENTE_LOGGATO']);
		$this->oUtente->set('oDb', $this->oDb);
		$this->oUtente->set('oApp', $this);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function distruggisessione($soloUtente = false) {
	if($soloUtente) {
		unset($_SESSION['UTENTE_LOGGATO']);
	} else {
		unset($_SESSION);
		session_destroy();
		setcookie(session_name(), '', time() - 3600);
		$_SESSION = array();
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function sezione($sezione) {
	$this->set('sezione', $sezione);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function sezione_dettaglio($sezione_dettaglio) {
	$this->set('sezione_dettaglio', $sezione_dettaglio);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function titolo($titolo) {
	$this->set('titolo', $this->getEtichettaTitolo($titolo));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTitoloPagina() {
	return $this->titolo;
}

/*********************************************************************************************************/
/*********************************************************************************************************/
public function apriWidget($id, $titolo = FALSE, $chiuso = FALSE, $ajax = FALSE, $style = FALSE, $padding = TRUE) {
    echo '<div class="widget-page card mb-3" id="widget_'.$id.'">';
    echo '<div class="card-header">';
    echo '<i class="fa fa-table"></i> <a href="/" class="btn btn-dark btn-sm pull-right">&nbsp;<b>X</b>&nbsp;</a> '.$titolo.' </div>';
    echo '<div class="card-body">';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function chiudiWidget($txt='', $ajax = FALSE) {
    echo '</div>';
    echo '<div class="card-footer small text-muted">'.$txt.'</div>';
    echo '</div>';
    //echo '</div>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getComuniByProvincia($id_provincia) {
	$sql = 'SELECT id_comune, desc_comune FROM comuni WHERE id_provincia='.num2str($id_provincia).' ORDER BY ordine, desc_comune';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getComuniAttiviByProvincia($id_provincia) {
	$sql = 'SELECT id_comune, desc_comune FROM comuni WHERE id_status='.STATUS_ATTIVO.' AND id_provincia='.num2str($id_provincia).' ORDER BY ordine, desc_comune';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getComuniInattiviByProvincia($id_provincia) {
	$sql = 'SELECT id_comune, desc_comune FROM comuni WHERE id_status='.STATUS_INATTIVO.' AND id_provincia='.num2str($id_provincia).' ORDER BY ordine, desc_comune';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getZoneByComune($id_comune, $esclusiva,$soloZoneAgenziaCollegata=TRUE) {
	
	if ($soloZoneAgenziaCollegata=== TRUE){
		//RECUPERO LE ZONE DEL COMUNE CHE APPARTENGONO ALL'AGENZIA COLLEGATA
		//$sql = 'SELECT a.id_zona, desc_zona FROM zone AS a INNER JOIN agenzie_zone AS b ON a.id_zona = b.id_zona WHERE esclusiva = 0 AND id_comune='.num2str($id_comune);
		$sql = 'SELECT a.id_zona, desc_zona FROM zone AS a INNER JOIN agenzie_zone AS b ON a.id_zona = b.id_zona WHERE id_comune='.num2str($id_comune);
		if ($esclusiva) $sql .= ' AND (esclusiva = 0 OR id_agenzia = '.$this->oUtente->get('id_agenzia').')';
		$sql .= ' ORDER BY desc_zona';
	}else{
		//RECUPERO TUTTE LE ZONE DEL COMUNE		
		$sql = 'SELECT a.id_zona, desc_zona FROM zone AS a WHERE id_comune='.num2str($id_comune).' ORDER BY desc_zona';
	}
	
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function aggiungiJs($script) {
	$this->htmlJscript .= '<script type="text/javascript">'.$script.'</script>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isBackend() {
	return $this->backend;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isFrontend() {
	return $this->frontend;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTipologieImmobili($id_categoria=OFFERTE_CATEGORIA_RESIDENZIALE,$lingua='') {
    if (empty($lingua)) $lingua = $_SESSION['LINGUA_NAVIGAZIONE'];
  	$sql = 'SELECT id, '.$lingua.' AS descrizione FROM immobili_tipologie WHERE id_categoria='.num2str($id_categoria).' ORDER BY '.$lingua;
  	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoComuniAgenzie($id_provincia='') {
  	$sql = 'SELECT id_comune, comune, sigla FROM vw_agenzie_comuni_attivi WHERE id_comune > 0 ';
  	if(is_numeric($id_provincia)){
  		$sql .= ' AND id_provincia = '.$id_provincia;
  	}
  	$sql .= ' ORDER BY comune';
  	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoProvinceAgenzie() {
  	$sql = 'SELECT id_provincia, provincia FROM vw_agenzie_province_attive';
  	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function cambiaTitle($stringa) {
	$oDom = new DOMDocument();
	$oDom->loadHTML($this->htmlHead);
	$nodeList = $oDom->getElementsByTagName('title');
	foreach ($nodeList as $node) {
		$node->nodeValue = xmlencode($stringa);
	}
	$this->htmlHead = preg_replace('~<(?:!DOCTYPE|/?(?:html|head|body))[^>]*>\s*~i', '', $oDom->saveHTML());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function cambiaDescription($stringa) {
	$oDom = new DOMDocument();
	$oDom->loadHTML($this->htmlHead);
	$nodeList = $oDom->getElementsByTagName('meta');
	foreach ($nodeList as $node) {
		if (strtolower($node->getAttribute('name')) == 'description') {
			$node->setAttribute('content', $stringa);
			$this->htmlHead = preg_replace('~<(?:!DOCTYPE|/?(?:html|head|body))[^>]*>\s*~i', '', $oDom->saveHTML());
			return;
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function addMeta($name, $value) {
	$this->htmlHead .= NL.'<meta property="'.$name.'" content="'.$value.'" />';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function cambiaKeywords($stringa) {
	$oDom = new DOMDocument();
	$oDom->loadHTML($this->htmlHead);
	$nodeList = $oDom->getElementsByTagName('meta');
	foreach ($nodeList as $node) {
		if (strtolower($node->getAttribute('name')) == 'keywords') {
			$node->setAttribute('content', $stringa);
			$this->htmlHead = preg_replace('~<(?:!DOCTYPE|/?(?:html|head|body))[^>]*>\s*~i', '', $oDom->saveHTML());
			return;
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function is($id_tipo) {
	if (!is_int($id_tipo)) die(__METHOD__); 
	return $this->getIdTipoUtenteLoggato() == $id_tipo;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isMeseBloccato($mese, $anno) {
	$sql = 'SELECT count(*) FROM annualita_mesi_bloccati AS a INNER JOIN annualita AS b ON a.id_annualita=b.id_annualita WHERE mese='.num2Str($mese).' AND anno='.num2Str($anno);
	$c1 = (bool)$this->oDb->eseguiselect($sql,CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	$c2 = ($anno.$mese < 201407);
	return ($c1 || $c2);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getUltimoMeseBloccato() {
	$sql = 'SELECT MAX(CONCAT(anno,"-",RIGHT(CONCAT("0",mese),2))) as mese FROM annualita_mesi_bloccati AS a INNER JOIN annualita AS b ON a.id_annualita=b.id_annualita';
	$mese = $this->oDb->eseguiselect($sql,CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	if (empty($mese)) $mese = '2014-07';
	return $mese;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function loadMode() {
	$res = $this->oDb->eseguiselect("select * from parametri where chiave = 'SERVER_MODE'");
	return @$res[0]['valore'];
}

public function loadModeLogin() {
	$res = $this->oDb->eseguiselect("select * from parametri where chiave = 'LOGGED_SERVER_MODE'");
	return @$res[0]['valore'];
}

/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>