<?php
abstract class classebase  {
	protected $oApp; // oggetto APP che istanzia l'oggetto
  	protected $oDb;  // oggetto DB
  	protected $oUtente;  // oggetto UTENTE


/*********************************************************************************************************/
/*********************************************************************************************************/
final public function get($propertyName, $param = NULL){
	if (stripos($propertyName, '@getoggetto') !== FALSE) {
		$propertyName = str_replace('@getoggetto+', '', $propertyName);
		$objName= substr($propertyName, 0, stripos($propertyName,'@'));
		$propertyName= substr($propertyName, stripos($propertyName,'@')+1);
		$funzione = 'getO'.$objName;
		$obj = $this->$funzione();

		if (method_exists($obj, 'get')) 
			return $obj->get($propertyName);
		return '';
	}
	$boolean = FALSE;
	$select = FALSE;
	if (stripos($propertyName, 'attributo_boolean_') !== FALSE) {
		$propertyName = str_replace('attributo_boolean_','',$propertyName);
		$boolean = TRUE;
	}
	if (stripos($propertyName, 'select_db_valore_') !== FALSE) {
		$propertyName = str_replace('select_db_valore_','',$propertyName);
		$select = TRUE;
	}
	
	$metodo = 'get' . str_replace('_', '', str_replace(' ', '', $propertyName));
	
	if (method_exists($this, $metodo)) {
		if (!is_null($param)) {
			$retVal = $this->$metodo($param);
		} else {
			$retVal = $this->$metodo();
		}
	} elseif($select) {
		$funzione = substr($metodo, stripos($metodo,'#')+1);
		$funzione = substr($funzione,0, stripos($funzione,'#'));
		$funzione = $funzione.'ById';
		$propertyName = substr($propertyName, strrpos($propertyName,'#')+1);
		$retVal = $this->$funzione($this->$propertyName);
	} else {
		$retVal = $this->$propertyName;
	}
	if ($boolean) $retVal = (((bool)$retVal)?'si':'no'); 
	return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function get_OLD($propertyName, $param = NULL){
	$metodo = 'get' . str_replace('_', '', str_replace(' ', '', $propertyName));
	if (method_exists($this, $metodo)) {
		if (!is_null($param)) {
			return $this->$metodo($param);
		} else {
			return $this->$metodo();
		}
	} else {
		return $this->$propertyName;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function ugualeA($oggetto_sorgente) {
	if ($this->classe === get_class($oggetto_sorgente)) {
		$aCampiDaIgnorare = array('oObj',
		                          'nome_attributo_id',
								  'id_oggetto_tipo',
								  'id_status',
								  'id_utente_creatore',
								  'id_utente_ultima_modifica',
								  'id_utente_proprietario',
								  'data_ultima_modifica',
								  'data_creazione',
								  'oDb',
								  'oApp',
								  'oUtente',
								  'form_method',
								  'colonneForm',
								  'haStatus',
								  'form_bottoni',
								  'oSeStessoPrecedente');
		$retVal = TRUE;
		foreach($this as $name => $value){
			if (in_array($name, $aCampiDaIgnorare)) continue;
			if (is_object($this->$name)) {
				$ret = $this->$name->ugualeA($oggetto_sorgente->get($name));
				/*
				if (!$ret) {
					echo '<h3>OGGETTO</h3>';
				}
				*/
				$retVal &= $ret;
			} elseif (is_array($this->$name)) {
				$ret = (serialize($this->$name) == serialize($oggetto_sorgente->get($name)));
				/*
				if (!$ret) {
					echo '<h3>ARRAY</h3>';
					dump($this->$name);
					dump($oggetto_sorgente->get($name));
					dump($ret);
				}
				*/
				$retVal &= $ret;
			} else {
				$ret = ($this->$name == $oggetto_sorgente->get($name));
				/*
				if (!$ret) {
					echo '<h3>VALORE</h3>';
					echo ':'.$this->classe.': - :'.$name.': - :'.gettype($this->$name).': - :'.$value.':<br>';
					echo ':'.$oggetto_sorgente->get('classe').': - :'.$name.': - :'.gettype($oggetto_sorgente->get($name)).': - :'.$oggetto_sorgente->get($name).':';
					dump($ret);			
				}
				*/
				$retVal &= $ret;
			}
			//echo '<hr>';
		}
		return $retVal;
	} else {
		return FALSE;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function toXml(&$stringaXml, $profonditaAttuale, $profonditaMassima) {
	++$profonditaAttuale;
	if (empty($stringaXml)) $stringaXml = '<?xml version="1.0" encoding="UTF-8"?>';
	
	$stringaXml .= '<'.get_class($this).'>';
	
	$aCampiDaIgnorare = array('oDb',
						      'oObj',
							  'oApp',
							  'oUtente',
							  'oSeStessoPrecedente',
							  'oElencoPermesso',
							  'aPermessi',
							  'form_method',
							  'haStatus',
							  'colonneForm',
							  'form_bottoni',
							  'tab_selezionato',
							  'class_action_url',
							  'class_url',
							  'nome_tabella',
							  'classe',
							  'campiInteresse',
							  'style',
							  'impostazioniPDF',
							  'ordinamento',
							  'nomeElenco',
							  'descrizioneElenco',
							  'paginato',
							  'numeroPaginaScelta',
							  'numeroElementiPerPagina',
							  'separatorePerPaginazione');
	
	foreach($this as $name => $value){
		if (in_array($name, $aCampiDaIgnorare)) continue;
		if (substr($name,0,7) == 'filtro_') continue; 
		if ($name == 'tab_selezionato') continue; 

		$stringaXml .= '<'.$name.'>';
		if (is_object($this->$name) || stripos($name, 'oElenco') !== FALSE) { 
			if ($profonditaAttuale <= $profonditaMassima) {
				$att = $name;
				if (stripos($name, 'oElenco') !== FALSE) {
					$att = substr($name,1);
				}
				$oO = $this->get($att);
				$oO->toXml($stringaXml, $profonditaAttuale, $profonditaMassima);
			} else {
				$stringaXml .= xmlEntities($name);
			}
		} elseif ($name == 'elencoOggetti' && stripos($this->classe, 'elenco') !== FALSE) {
			if (!$this->isEmpty()) {
				foreach ($this->getElenco() as $i=>$oO) {
					$oO->toXml($stringaXml, $profonditaAttuale, $profonditaMassima);
				}
			}			
		} elseif (is_array($this->$name)) {
			foreach ($this->$name as $i=>$v) {
				$stringaXml .= '<elemento id="'.$i.'">'.xmlEntities($v).'</elemento>';
			}
		} else {
			$stringaXml .= xmlEntities($this->$name);
		}
		$stringaXml .= '</'.$name.'>';
		if ($profonditaAttuale == 1 && $this->classe !== 'utente' && $name == 'id_utente_creatore') {
			$stringaXml .= '<utente_creatore>';
			$oUtente = new utente($this->oApp, $this->$name);
			$oUtente->toXml($stringaXml, $profonditaAttuale, 1);
			$stringaXml .= '</utente_creatore>';
		}
		if ($profonditaAttuale == 1 && $this->classe !== 'utente' && $name == 'id_utente_ultima_modifica') {
			$stringaXml .= '<utente_ultima_modifica>';
			$oUtente = new utente($this->oApp, $this->$name);
			$oUtente->toXml($stringaXml, $profonditaAttuale, 1);
			$stringaXml .= '</utente_ultima_modifica>';
		}
		if ($profonditaAttuale == 1 && $this->classe !== 'utente' && $name == 'id_utente_proprietario') {
			$stringaXml .= '<utente_proprietario>';
			$oUtente = new utente($this->oApp, $this->$name);
			$oUtente->toXml($stringaXml, $profonditaAttuale, 1);
			$stringaXml .= '</utente_proprietario>';
		}		
	}
	$stringaXml .= '</'.get_class($this).'>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>