<?php
/*********************************************************************************************************/

Class db {
	private $connessione;
  	private $righerestituite;
  
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI MAGICI
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __construct() {
  	$this->apriconnessione();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __destruct() {
  	$this->chiudiconnessione();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __wakeup() {
  	$this->apriconnessione();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI PUBBLICI
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eseguiselect($sql, $mode = CLASS_DB_SELECT_MODE_STANDARD, $multiquery = FALSE){
	if ($multiquery) {
		return $this->eseguimultisql($sql, $mode);
	} else {
		return $this->eseguiselectbasic($sql, $mode);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eseguiinsert($sql){
  	return $this->eseguiinsertupdatedelete($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eseguiupdate($sql){
  	return $this->eseguiinsertupdatedelete($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eseguidelete($sql){
  	return $this->eseguiinsertupdatedelete($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function dammiultimoidinserito() {
	return mysqli_insert_id($this->connessione);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function verificaEsistenzaValore($valore, $campo, $tabella) {
	return (bool) $this->eseguiselect('SELECT count(*) FROM '.$tabella.' WHERE '.$campo.' = '.stripcslashesandquote($valore), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haRisultati() {
	if ($this->righerestituite > 0) {
		return true;	
	} else {
		return false;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getNumeroRisultati() {
	return $this->righerestituite;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI PRIVATI
/*********************************************************************************************************/
/*********************************************************************************************************/
private function eseguiselectbasic($sql, $mode){

    //echo $sql.'<br><br>';
	$rows = array();
	$cursore = $this->eseguisql($sql);
	if ($cursore !== FALSE) {
		if ($cursore === TRUE) return TRUE;
		 
		$this->righerestituite = mysqli_num_rows($cursore);
		while ($row = mysqli_fetch_assoc($cursore)) {
			$rows[] = $row;
		}
		
		if (count($rows) == 1 && $mode == CLASS_DB_SELECT_MODE_SINGLE_ROW) {
			// restiruisco un solo record
			$retVal = $rows[0];

		} elseif (count($rows) == 1 && $mode == CLASS_DB_SELECT_MODE_SINGLE_VALUE) {
			// restiruisco un solo valore
			$retVal = $rows[0];
			if (count($retVal) == 1) {
				$retVal = $retVal[key($retVal)];
			} elseif (empty($retVal)) {
				mysqli_free_result($cursore);
				return '';
			} else {
				mysqli_free_result($cursore);
				return FALSE;
			}
			
		} elseif ($mode == CLASS_DB_SELECT_MODE_SINGLE_COLUMN) {
			// restiruisco una sola colonna
			$retVal = array();
			$key = '';
			foreach ($rows as $r) {
				if (count($r) == 1) {
					if (empty($key)) {
						$key = key($r);
					}
					$retVal[] = $r[$key];
				} else {
					mysqli_free_result($cursore);
					return FALSE;
				}
			}
		} else {
			$retVal = $rows;
		}
		
	} else {
  		$this->righerestituite = 0;
		mysqli_free_result($cursore);
	  	return FALSE;
	}
	mysqli_free_result($cursore);
	return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function apriconnessione() {
	$this->connessione = mysqli_connect(DB_HOST,DB_USER,DB_PSWD,DB_NAME);
	if (mysqli_connect_errno($this->connessione)) {
	    die('Errore nella connessione al database: '. mysqli_connect_error());
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function chiudiconnessione(){
	/*
	if (is_resource($this->connessione)) {
		mysqli_close($this->connessione);
	}
	*/
	if (mysqli_ping($this->connessione)) {
		mysqli_close($this->connessione);
	} 
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function eseguisql($sql){
	/*
	if (!is_resource($this->connessione)) {
		$this->apriconnessione();
  	}
  	*/
  	if (!mysqli_ping($this->connessione)) {
		$this->apriconnessione();
	} 
	
  	//logsql($sql);
	if (isset($_GET['sql']) && (bool)$_GET['sql']) echo '<h4>'.$sql.'</h4>';
	$ret =  mysqli_query($this->connessione, $sql) or die (mysqli_error($this->connessione).'<br>'.$sql);
  	//dump($ret);
  	return $ret;              
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function eseguimultisql($sql, $mode){
	$retVal = array();
	
	/*
	if (!is_resource($this->connessione)) {
		$this->apriconnessione();
  	}
  	*/
  	
  	if (!mysqli_ping($this->connessione)) {
		$this->apriconnessione();
	} 
  	
  	//logsql($sql);
	//echo '<h4>'.$sql.'</h4>';
  	$ret =  mysqli_multi_query($this->connessione, $sql);
  	
    do {
        if ($result = mysqli_store_result($this->connessione)) {
            while ($row = mysqli_fetch_row($result)) {
            	//DUMP($row);
                $retVal[] = $row;
            }
            mysqli_free_result($result);
        }
        if (!mysqli_more_results($this->connessione)) {
        	break;
        }
    } while (mysqli_next_result($this->connessione));
  	
    if ($ret) {
    	return $retVal;
    } else {
	  	return $ret;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function eseguiinsertupdatedelete($sql){
	$cursore = $this->eseguisql($sql);
	if ($cursore !== FALSE) {
		$this->righerestituite = mysqli_affected_rows($this->connessione);
		return TRUE;
	} else {
  		$this->righerestituite = 0;
	  	return FALSE;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function iniziaTransazione() {
	$this->eseguisql('START TRANSACTION;');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function confermaTransazione() {
	$this->eseguisql('COMMIT;');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function annullaTransazione() {
	$this->eseguisql('ROLLBACK;');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
//Se disattivate l’autocommit con SET AUTOCOMMIT = 0, le modifiche diverranno operative solo quando eseguite l’istruzione COMMIT. Se al suo posto eseguite ROLLBACK, verranno annullate tutte le modifiche fino alla COMMIT precedente. 
//Potete utilizzare le transazioni senza disattivare l’autocommit, iniziandole con START TRANSACTION o BEGIN e terminandole con COMMIT o ROLLBACK. 
public function disattivaAutocommit() {
	$this->eseguisql('SET AUTOCOMMIT=0;');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function attivaAutocommit() {
	$this->eseguisql('SET AUTOCOMMIT=1;');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>