<?php
abstract class elenco extends classebase {
	protected $classe;
	protected $elencoOggetti;
	protected $numeroOggetti;
	
	protected $style;
	
	protected $oggetto;
	
	protected $campiInteresse = array();
	protected $impostazioniPDF = array();
	protected $nomeElenco;
	protected $descrizioneElenco;
	protected $ordinamento; 
	
  	// attributi per gestire la paginazione dei risultati
	protected $limit;
	protected $paginato;
	protected $numeroPaginaScelta;
	protected $numeroElementiPerPagina;
	protected $separatorePerPaginazione;
	public $rawData;
	/*
	protected $oApp; // oggetto APP che istanzia l'oggetto
  	protected $oDb;  // oggetto DATABASE
  	protected $oUtente;  // oggetto UTENTE
	*/
		
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __construct($oApp, $elencoId = FALSE, $ordinamento = FALSE, $numeroPagina = 1, $limit = FALSE) {
	instance_of($oApp, 'app');
	verificaParametro(($ordinamento !== FALSE && !is_string($ordinamento)), __METHOD__.' il parametro $ordinamento &egrave; sbagliato');
	verificaParametro(($ordinamento !== FALSE && substr(trim($ordinamento), 0, 8) !== 'ORDER BY'), __METHOD__.' il parametro $ordinamento deve contenere ORDER BY');
	
	$this->classe =  get_class($this);
	$this->oApp = $oApp;
	$this->oDb = $this->oApp->get('oDb');
	$this->oUtente = $this->oApp->get('oUtente');	
	
	$this->oggetto = strtolower(str_replace('elenco', '', $this->classe));
	$this->ordinamento = $ordinamento;
	$this->numeroOggetti = 0;

	// TODO: paginazione
	$this->limit = $limit;
	$this->paginato = FALSE;
    $this->numeroPaginaScelta = $numeroPagina;
    $this->numeroElementiPerPagina = 25;
    $this->separatorePerPaginazione = '-';

  	if ($elencoId !== FALSE) $this->carica($elencoId);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*
public function __sleep() {
	$ret = array();
	foreach ($this as $attributo => $valore) {
		if (!in_array($attributo, unserialize(aATTRIBUTI_DA_NON_SERIALIZZARE))) {
			$ret[] = $attributo;
		}
	}
	return $ret;
} 
*/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*
public function __wakeup() {
	if (array_key_exists('OAPP', $_SESSION)) $this->oApp = unserialize($_SESSION['OAPP']);
	//if ($this->oggetto != 'utente' && array_key_exists('UTENTE_LOGGATO', $_SESSION)) $this->oUtente = unserialize($_SESSION['UTENTE_LOGGATO']);
	if (array_key_exists('ODB', $_SESSION)) $this->oDb = unserialize($_SESSION['ODB']);
}
*/
/*********************************************************************************************************/
/*********************************************************************************************************/
abstract public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE);
/*********************************************************************************************************/
/*********************************************************************************************************/
public function carica($parametro, $isWhereClauses = FALSE) {
	//$t = contatempo();
	if ($parametro === TRUE) { //devo caricare l'elenco completo
		$sql = $this->getSqlToLoad();
	} elseif (is_array($parametro)) {
		$sql = $this->getSqlToLoad(FALSE, $parametro); //devo caricare solo alcuni id
	} elseif (is_int($parametro)) {
		$sql = $this->getSqlToLoad(FALSE, FALSE, $parametro); //devo caricare un solo elemento
	} elseif (is_string($parametro) && $isWhereClauses) {
		$sql = $this->getSqlToLoad(FALSE, FALSE, FALSE, $parametro); //devo caricare in base a clausole where esterne
	}
	//stampaContatempo($t, 'TEMPO CARICAMENTO $sql = $this->getSqlToLoad(); =&gt; ');
	
	if ($this->ordinamento !== FALSE) {
		if (stripos($sql, 'ORDER BY') !== FALSE) $this->ordinamento = str_replace('ORDER BY',' ',$this->ordinamento);
	  	$sql .= ' '.$this->ordinamento.' ';
	}
	
	if ($parametro !== FALSE) {    
		//$this->contaElementi($sql);
		if ($this->paginato) {
			// TODO: paginazione
		  	$sql .= " LIMIT ".(($this->numeroPaginaScelta - 1)*$this->numeroElementiPerPagina).", ".$this->numeroElementiPerPagina;
		}
		
		
		if ($this->limit !== FALSE && is_numeric($this->limit)) {
			$sql .= ' LIMIT '.(int)$this->limit;
		}

		//echo '<h3>'.$sql.'</h3>';
		
		//$t = contatempo();   
		$this->caricaBasic($sql);
		//stampaContatempo($t, 'TEMPO CARICAMENTO $this->caricaBasic($sql); =&gt; ');
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerRicercaLibera($whereClauses) {
	verificaParametro((!is_string($whereClauses)), __METHOD__.' il parametro deve essere una stringa sql di condizioni where');
	//verificaParametro((stripos(strtolower($whereClauses), 'where') !== FALSE), __METHOD__.' il parametro NON deve contenere la parola WHERE');
	$this->carica($whereClauses, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function caricaBasic($sql) {
	$rows = $this->oDb->eseguiselect($sql, FALSE);
	$this->rawData = $rows;
	foreach ($rows as $r) {
		$this->initObjByRecord($r);
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function initByRecord($rec) {
	foreach ($this as $attributo => $valore) {
		if (!is_object($attributo)) {
			if (array_key_exists($attributo, $rec)) {
				$this->$attributo = $rec[$attributo];
		  	}
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function initElencoByRecord($rec) {
	foreach ($rec as $r) {
		$this->initObjByRecord($r);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function initObjByRecord($rec) {
   	$o = new $this->oggetto($this->oApp);
   	$o->initByRecord($rec);
    $this->addOggetto($o);	
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setPerOggetti($propertyName, $valore){
	if (!$this->isEmpty()) {
		foreach ($this->elencoOggetti as $i => $oO ) {
			$this->elencoOggetti[$i]->set($propertyName,$valore);
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function inserisci() {
    foreach ($this->elencoOggetti as $o) {
    	$o->inserisci();
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eseguiMetodo($callback, $parametro = NULL) {
	$ret = TRUE;
	if (!$this->isEmpty()){
		foreach ($this->elencoOggetti as $o) {
			if (method_exists($o,$callback)) {
				if (is_null($parametro)) {
					$r = $o->$callback();	
				} else {
					$r = $o->$callback($parametro);
				}
				if ($r === TRUE || $r === FALSE) {
					$ret = ($r && $ret);
				} else {
					$ret = TRUE;
				}
			} else {
				if (APP_SVILUPPO) die(__METHOD__.' controlla');
			}
		}
	}else{
		$ret = TRUE;
	}
	
	return $ret;  
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setCampiInteresse($array) {
    $this->campiInteresse = $array;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setImpostazioniPDF($array) {
	$array['template'] = strtolower($this->oggetto.'_'.$array['template']);
    $this->impostazioniPDF = $array;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setNomeElenco($nome) {
	$this->nomeElenco = $nome;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setDescrizioneElenco($nome) {
	$this->descrizioneElenco = $nome;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getCampiInteresse() {
    return $this->campiInteresse;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getImpostazioniPDF() {
    return $this->impostazioniPDF;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getNomeElenco() {
    return $this->nomeElenco;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDescrizioneElenco() {
    return $this->descrizioneElenco;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElenco() {
    return $this->elencoOggetti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTotaleElenco() {
    return count($this->elencoOggetti);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isEmpty() {
    if (count($this->elencoOggetti) > 0) {
    	return FALSE;    	
    } else {
    	return TRUE;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function contaElementi($sql) {
    //$sql = preg_replace(array('/SELECT.*?FROM /iAs', '/ORDER BY .*/i'), array('SELECT COUNT(*) FROM ', ''), $sql);
    //if (stripos($sql, 'ORDER BY')) {
    //	$sql = substr($sql, 0, stripos($sql, 'ORDER BY'));
    //}
    //$this->numeroOggetti = (int)$this->oDb->estraicampo($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function contaElementiSeAttributoUgualeA($attributo, $valore) {
	$cont = 0;
	if ($this->numeroOggetti > 0) {
		foreach ($this->elencoOggetti as $oObj) {
			$propertyExists = property_exists($oObj, $attributo);
			$methodExits = method_exists($oObj, str_replace('_', '', 'get_'.$attributo));
			if (($propertyExists || $methodExits) && $oObj->get($attributo) == $valore) ++$cont; 
		}
	}
	return $cont;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function contaElementiSeAttributoDiversoDa($attributo, $valore) {
	$cont = 0;
	foreach ($this->elencoOggetti as $oObj) {
		if (property_exists($oObj, $attributo) && $oObj->get($attributo) != $valore) ++$cont; 
	}
	return $cont;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSommaAttributi($attributo) {
	$somma = 0;
	foreach ($this->elencoOggetti as $oObj) {
		if (property_exists($oObj, $attributo)) {
			$somma += $oObj->get($attributo);
		} else {
			$metodo = 'get' . str_replace('_', '', str_replace(' ', '', $attributo));
			if (method_exists($oObj, $metodo)) {
				$somma += $oObj->$metodo(); 
			}
		} 
	}
	return $somma;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function stampa($tipo, $style, $array_confronto = FALSE) {
	verificaParametro((!is_string($style)), __METHOD__.' il parametro STYLE &egrave; sbagliato');
	verificaParametro(($array_confronto !== FALSE && !is_array($array_confronto)), __METHOD__.' Attenzione: per poter stampare con i dati preselezionati devi passare l\'array con il metodo $elenco->getelenco()');
	
	$sE = new stampaelenco($this->oApp, $tipo, $this);
	$sE->setStyle($style);
	$sE->stampa($array_confronto);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function stampaPDF() {
	$sE = new stampaelenco($this->oApp, 'PDF', $this);
	$sE->stampaPDF();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setPaginazione($numElPerPagina, $separatore) {
    $this->paginato = TRUE;
    $this->numeroElementiPerPagina  = $numElPerPagina;
    $this->separatorePerPaginazione = $separatore;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPaginazione() {
	// TODO: paginazione
	
	$this->numeroPagine = ceil($this->numeroOggetti / $this->numeroElementiPerPagina);
    
	echo "<div class=\"paginazione\">";
	echo $this->numeroPagine." pagine. ";
	if ($this->numeroPagine && $this->numeroPaginaScelta > 10) {
	  	echo "<a href=\"?pagina=".($this->numeroPaginaScelta  - 20)."\" title=\"Vai alla pagina " . ($this->numeroPaginaScelta  - 20) . "\">&lt;&lt;</a> ";
	}
	
	$primoGiro = TRUE;
	for ($i = 0 ; $i < $this->numeroPagine; ++$i) {
	  if ($i >= $this->numeroPaginaScelta - 11 && $i < $this->numeroPaginaScelta + 10) {
		  if ($i+1 !== $this->numeroPaginaScelta) {
		    if (!$primoGiro) {
		      echo " ".$this->separatorePerPaginazione." ";
		    }
		    echo "<a href=\"?pagina=".($i+1)."\" title=\"Vai alla pagina " . ($i+1) . "\">" . ($i+1) . "</a>";
		  } else {
		    if (!$primoGiro) {
		      echo " ".$this->separatorePerPaginazione." ";
		    }
		    echo "<span class=\"paginaAttuale\">" . ($i+1) . "</span>";
		  }
		  $primoGiro = FALSE;
	  }
	}

	if ($this->numeroPagine && $this->numeroPaginaScelta < $this->numeroPagine - 10) {
	  echo " <a href=\"?pagina=".($this->numeroPaginaScelta  + 20)."\" title=\"Vai alla pagina " . ($this->numeroPaginaScelta  + 20) . "\">&gt;&gt;</a>";
	}

	echo "</div>";

}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function toCsv($output = TRUE) {
	
	if ($output) {
		header("pragma: cache");
	    header("pragma: public");
	    header("Cache-Control: max-age=0");
	    header("Cache-Control: private" , false); // required for certain browsers 
	    header("Content-Type: text/csv");
	    header("Expires: 0");
	    header("Content-Disposition: attachment; filename=\"".basename($this->nomeElenco.'_'.date("Y-m-d-H-i-s").trim(substr(microtime(), 2, 9)).".csv")."\"");
	}

	$fp = fopen('php://output', 'w');
	
	function ripulisci($n) {
		$n = str_replace('attributo_boolean_','',$n);
		$n = str_replace('select_db_valore_','',$n);
		$n = str_replace('_',' ',$n);
		if (stripos($n, '@') !== FALSE) {
			$n = str_replace('@getoggetto+', '', $n);
			$n= substr($n, stripos($n,'@')+1);
		}
		if (stripos($n, '#') !== FALSE) {
			$n= substr($n, strrpos($n,'#')+1);
		}
		$n = str_replace('id ','',$n);
    	return $n;
	}

	$intestazioni = array_map("ripulisci", $this->campiInteresse);
	
    fputcsv($fp, $intestazioni, ';','"');

	foreach ($this->elencoOggetti as $i => $oOggetto) {
		$riga = array();
		foreach ($this->campiInteresse as $campo) {
		
			$metodo = 'get'.$campo;

			if (method_exists($oOggetto, $metodo)) {
				$valore = $oOggetto->$metodo($campo);
				if ($valore=='') {
					$valore = '---';
				}
				if (is_array($valore)) {
					if (empty($valore)) {
						$valore = '---';
					} else {
						$valore = '***valore ARRAY***<br />$'.get_class($oOggetto).'->$metodo()--'.$campo.'<br />****************';
					}
				}
			} else {
				$metodo = 'get';
				if (method_exists($oOggetto, $metodo)) {
					$valore = $oOggetto->$metodo($campo);
					if ($valore=='') {
						$valore = '---';
					}
					if (is_array($valore)) {
						if (empty($valore)) {
							$valore = '---';
						} else {
							$valore = '***valore ARRAY***<br />$'.get_class($oOggetto).'->$metodo()--'.$campo.'<br />****************';
						}
					}
				} else {
				  	$valore = '***non esiste il metodo***<br />$'.get_class($oOggetto).'->$metodo()<br />****************';
				}
			}
			
			if (strpos($metodo, 'Data') !== FALSE) {
			  	$valore = $this->formattaDate($valore);
			}
			
			$valore = html_entity_decode($valore);
			$valore = utf8_encode($valore);
			$valore = str_replace('&euro;','€',$valore);
			$riga[] = $valore;
		}

	   	fputcsv($fp, $riga, ';','"');
	}
	
    fclose($fp);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function toXls($output = TRUE) {
	
	require_once(DIR_LIB.'PHPExcel/PHPExcel.php');

	if ($output) {
		header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet');
		header("Content-Disposition: attachment; filename=\"".basename($this->nomeElenco.'_'.date("Y-m-d-H-i-s").trim(substr(microtime(), 2, 9)).".xls")."\"");
		header('Cache-Control: max-age=0');
	}
	
	$righe = array();
	$righe[] = $this->campiInteresse;

	foreach ($this->elencoOggetti as $i => $oOggetto) {
		$riga = array();
		foreach ($this->campiInteresse as $campo) {
		
			$metodo = 'get'.$campo;
			if (method_exists($oOggetto, $metodo)) {
				$valore = $oOggetto->$metodo($campo);
				if ($valore=='') {
					$valore = '---';
				}
			} else {
				$metodo = 'get';
				if (method_exists($oOggetto, $metodo)) {
					$valore = $oOggetto->$metodo($campo);
					if ($valore=='') {
						$valore = '---';
					}
				} else {
				  	$valore = '***non esiste il metodo***<br />$'.get_class($oOggetto).'->$metodo()<br />****************';
				}
			}
			
			if (strpos($metodo, 'Data') !== FALSE) {
			  	$valore = $this->formattaDate($valore);
			}
			
			$riga[] = $valore;
		}

	   	$righe[] = $riga;
	}
	
	$doc = new PHPExcel();
	$doc->setActiveSheetIndex(0);
	$doc->getActiveSheet()->fromArray($righe, null, 'A1');
	$writer = PHPExcel_IOFactory::createWriter($doc, 'Excel5');
	$writer->save('php://output');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function addOggetto($oggetto) {
	instance_of($oggetto, $this->oggetto);
	$this->elencoOggetti[] = $oggetto;
	++$this->numeroOggetti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*
public function get($propertyName, $param = NULL){
	$metodo = 'get' . str_replace('_', '', $propertyName);
	if (method_exists($this, $metodo)) {
		if (!is_null($param)) {
			return $this->$metodo($param);
		} else {
			return $this->$metodo();
		}
	} else {
		return $this->$propertyName;
	}
}
*/
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoId(){
	$array = array();
	if (!$this->isEmpty()) {
		foreach ($this->elencoOggetti as $oggetto) {
			$array[] = $oggetto->getId();
		}
	}
	return $array;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function set($propertyName, $valore){
	$metodo = 'set' . str_replace('_', '', $propertyName);
	if (method_exists($this, $metodo)) {
		$this->$metodo($valore);
	} else {
		$this->$propertyName = $valore;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElementoEnnesimo($n) {
	if ($this->numeroOggetti >= $n) {
		return $this->elencoOggetti[$n];
	} else {
		return FALSE;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPrimoElemento() {
	return $this->getElementoEnnesimo(0);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function toArray() {
	$array = array();
	foreach ($this->elencoOggetti as $oggetto) {
		$array[] = $oggetto->toArray();
	}
	return $array;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function completaConDatiFissi($oOggetto) {
	foreach ($this->elencoOggetti as $oggetto) {
		$oggetto->completaConDatiFissi($oOggetto);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>