<?php
class elencologallarme extends elenco {
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {
	$sql = 'SELECT a.*
	          FROM log_allarmi AS a';
	
	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_log_allarme IN (' . implode(',', $elencoId).')';
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_log_allarme = ' . num2Str($id);
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;

	return $sql;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaTutti($rec) {
    $a = array();
    if (array_key_exists('filtro_data_da', $rec)) {
        $d = new DateTime($rec['filtro_data_da']);
        $a[] = 'DATE(a.data) >= '.date2db($d->format('Y-m-d'));
    }
    if (array_key_exists('filtro_data_a', $rec)) {
        $d = new DateTime($rec['filtro_data_a']);
        $a[] = 'DATE(a.data) <= '.date2db($d->format('Y-m-d'));
    }
    parent::carica(implode(' AND ', $a), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloAllarmiTecnici($rec, $soloAttivi = FALSE) {
    $a = array();
    $a[] = 'a.allarme_sistema = 0';
    if (array_key_exists('filtro_data_da', $rec)) {
        $d = new DateTime($rec['filtro_data_da']);
        $a[] = 'DATE(a.data) >= '.date2db($d->format('Y-m-d'));
    }
    if (array_key_exists('filtro_data_a', $rec)) {
        $d = new DateTime($rec['filtro_data_a']);
        $a[] = 'DATE(a.data) <= '.date2db($d->format('Y-m-d'));
    }
    if ($soloAttivi) {
        $a[] = 'a.risolto = "0000-00-00"';
    }
    parent::carica(implode(' AND ', $a), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloAllarmiTecniciAttivi() {
    $a = array();
    $a[] = 'a.allarme_sistema = 0';
    $a[] = 'a.id_supervisore not in (select id_supervisore from supervisore where id_tipo_dispositivo = -1) ';
    $a[] = 'a.risolto = "0000-00-00 00:00:00"';
    parent::carica(implode(' AND ', $a), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloAllarmiTecniciAttiviDaUltimoControllo($ultimoControllo) {
    $a = array();
    $a[] = 'a.allarme_sistema = 0';
    $a[] = 'a.risolto = "0000-00-00 00:00:00"';
    $a[] = 'a.data >= '.datetime2db($ultimoControllo);
    parent::carica(implode(' AND ', $a), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloEventiSistema($rec) {
    $a = array();
    $a[] = 'a.allarme_sistema = 1';
    if (array_key_exists('filtro_data_da', $rec)) {
        $d = new DateTime($rec['filtro_data_da']);
        $a[] = 'DATE(a.data) >= '.date2db($d->format('Y-m-d'));
    }
    if (array_key_exists('filtro_data_a', $rec)) {
        $d = new DateTime($rec['filtro_data_a']);
        $a[] = 'DATE(a.data) <= '.date2db($d->format('Y-m-d'));
    }
    parent::carica(implode(' AND ', $a), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>