<?php
class elencopermesso extends elenco {   
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {
	$sql = 'SELECT * FROM permessi';

	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ').' id_permesso IN (' . implode(',', $elencoId).')'; 
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ').' id_permesso = ' . num2Str($id); 
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;
	
	//return $sql.' ORDER BY permesso'; 
	//echo $sql;

    if (empty($this->ordinamento)) return $sql.' ORDER BY id_permesso';
	return $sql;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerUtente($id_utente) {
	parent::carica('id_permesso IN (SELECT id_permesso FROM utenti_permessi WHERE id_utente = ' . num2Str($id_utente).')', TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerRuolo($id_utente_tipo) {
	parent::carica('id_permesso IN (SELECT id_permesso FROM utenti_tipi_permessi WHERE id_utente_tipo = ' . num2Str($id_utente_tipo).')', TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaGestibili() {
	parent::carica('gestibile = 1', TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function assegnaAdUtente($id_utente) {
	$ret = TRUE;
	foreach ($this->elencoOggetti as $oPermesso) {
		$ret = $ret && $oPermesso->assegnaAdUtente($id_utente);
	}  
	return $ret;    
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function assegnaARuoloEUtenti($id_utente_tipo) {
	$ret = TRUE;
	foreach ($this->elencoOggetti as $oPermesso) {
		$ret = $ret && $oPermesso->assegnaARuoloEUtenti($id_utente_tipo);
	}
	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function togliDaUtente($id_utente) {
	$sql = 'DELETE FROM utenti_permessi WHERE id_utente = ' . num2Str($id_utente);
	return $this->oDb->eseguidelete($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function togliDaRuoloEUtenti($id_utente_tipo) {
	$ret = TRUE;
	// Elimino i precedenti permessi agli utenti che hanno lo stesso id_utente_tipo. 
	// Lascio però eventuali altri permessi assegnati manualmente.
	$sql = 'DELETE FROM utenti_permessi 
	              WHERE id_utente IN (SELECT id_utente 
	                                    FROM utenti 
	                                   WHERE id_utente_tipo = '.num2Str($id_utente_tipo).') 
	                AND id_permesso IN (SELECT id_permesso 
	                                      FROM utenti_tipi_permessi 
	                                     WHERE id_utente_tipo = '.num2Str($id_utente_tipo).')';
	$ret = $ret && $this->oDb->eseguidelete($sql);
	
	// Elimino i permessi associati al tipo di utente.
	$sql = 'DELETE FROM utenti_tipi_permessi WHERE id_utente_tipo = ' . num2Str($id_utente_tipo);
	$ret = $ret && $this->oDb->eseguidelete($sql);
	return $ret; 
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaArrayPerUtente($id_utente) {
	$sql = 'SELECT permesso FROM permessi WHERE id_permesso IN (SELECT id_permesso FROM utenti_permessi WHERE id_utente = ' . num2Str($id_utente).')';
	return $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_COLUMN);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaArrayPerRuolo($id_utente_tipo) {
	$sql = 'SELECT permesso FROM permessi WHERE id_permesso IN (SELECT id_permesso FROM utenti_tipi_permessi WHERE id_utente_tipo = ' . num2Str($id_utente_tipo).')';
	return $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_COLUMN);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaArrayPerElencoId($idList) {
	$sql = 'SELECT permesso FROM permessi WHERE id_permesso IN ('.implode(',',$idList).')';
	return $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_COLUMN);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function aggiungiPermessiAggiuntivi($array) {
	foreach ($array as $id) {
		$oP = new permesso($this->oApp, $id);
		$this->addOggetto($oP);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>