<?php
class elencoutente extends elenco {
	
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSqlToLoad($completo = TRUE, $elencoId = FALSE, $id = FALSE, $whereClauses = FALSE) {
	$sql = 'SELECT a.*, b.ruolo AS utente_tipo, c.descrizione AS status
	           FROM utenti AS a
	     INNER JOIN utenti_tipi AS b ON a.id_utente_tipo = b.id_utente_tipo
	     INNER JOIN status AS c ON a.id_status = c.id_status
	          WHERE c.id_status != ' . STATUS_ELIMINATO;
	
	if ($elencoId !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_utente IN (' . implode(',', $elencoId).')'; 
	if ($id !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . 'id_utente = ' . num2Str($id); 
	if ($whereClauses !== FALSE) $sql .= ((stripos($sql, 'WHERE') !== FALSE)?' AND ':' WHERE ') . $whereClauses;
	//echo $sql;
	return $sql;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloVisibili() {
	$id_utente_loggato = $this->oApp->getIdUtenteTipoLoggato();
	$id_tipo_utente_loggato = $this->oApp->getIdTipoUtenteLoggato();
	if ($id_utente_loggato !== FALSE) {
		$sql = ' b.id_utente_tipo >= ' . num2Str($id_utente_loggato); 
	}
	parent::carica($sql, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaSoloVisibiliDiSistema() {
	$id_utente_loggato = $this->oApp->getIdUtenteTipoLoggato();
	$id_tipo_utente_loggato = $this->oApp->getIdTipoUtenteLoggato();
	if ($id_utente_loggato !== FALSE) {
		$sql = ' b.id_utente_tipo >= ' . num2Str($id_utente_loggato); 
	}
	$sql .= ' AND b.id_utente_tipo NOT IN ('.UTENTE_TIPO_ID_UTENTE.')';
	parent::carica($sql, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaCandidati() {
	$sql = ' b.id_utente_tipo = '.UTENTE_TIPO_ID_UTENTE;
	parent::carica($sql, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerAppuntamento($id_appuntamento) {
	parent::carica('id_utente IN (SELECT id_utente FROM appuntamenti_anagrafiche WHERE id_appuntamento ='.num2str($id_appuntamento).' AND id_status = '.STATUS_ATTIVO.')', TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function inserisciAppuntamento($id_appuntamento) {
	$a = array();
	foreach ($this->elencoOggetti as $oO) {
	
		$sql = 'SELECT * FROM appuntamenti_utenti WHERE id_appuntamento='.num2str($id_appuntamento).' AND id_utente = '.num2str($oO->get('id_utente'));
  		$this->oDb->eseguiselect($sql);
  		if ($this->oDb->haRisultati()) {
  			$sql = $sql = 'UPDATE appuntamenti_utenti SET id_status = '.STATUS_ATTIVO.' WHERE id_appuntamento='.num2str($id_appuntamento).' AND id_utente = '.num2str($oO->get('id_utente'));
  			$ret = $this->oDb->eseguiupdate($sql);
		}
		else{
			$sql = 'INSERT IGNORE appuntamenti_utenti (id_appuntamento, id_utente) VALUES ('.num2str($id_appuntamento).','.num2str($oO->get('id_utente')).')';
			$ret = $this->oDb->eseguiinsert($sql);
		}
	
	}

	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function annullaAppuntamento($id_appuntamento) {
	$a = array();
	$elenco_utenti_sql = '';
	foreach ($this->elencoOggetti as $oO) {
		$elenco_utenti_sql .= ','.num2str($oO->get('id_utente'));	
	}
	$sql = 'UPDATE appuntamenti_utenti SET id_status = '.STATUS_ELIMINATO.' WHERE id_appuntamento='.num2str($id_appuntamento).' AND id_utente NOT IN (0 '.$elenco_utenti_sql.')';

	return $this->oDb->eseguidelete($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerAgenzia($id_agenzia) {
	parent::carica('id_agenzia='.num2str($id_agenzia), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaTipoPerAgenzia($id_agenzia,$id_utente_tipo) {
	parent::carica('id_agenzia='.num2str($id_agenzia).' AND a.id_utente_tipo='.$id_utente_tipo, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerAppuntamentoSegreteria($lista_id_agenzia) {
	parent::carica('id_agenzia IN ('.$lista_id_agenzia.') AND a.id_utente_tipo = 4', TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function caricaPerMezze($id_agenzia,$id_utente_tipo='') {

	$sql = 'SELECT a.*, (SELECT id_mezze_soggetto_abilitato FROM mezze_soggetti_abilitati b WHERE a.id_utente = b.id_utente AND ( datatime_fine_mandato IS NULL OR datatime_fine_mandato = "" ) ) as abilitato_mezze FROM utenti a 
	          WHERE a.id_status != ' . STATUS_ELIMINATO.' AND a.id_agenzia='.num2str($id_agenzia);
	
	if(is_numeric($id_utente_tipo)){
		$sql .= ' AND a.id_utente_tipo='.$id_utente_tipo;
	}
	          
	parent::caricaBasic($sql);
}  
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>