<?php
class logallarme extends oggetto {

	protected $id_log_allarme;
    protected $data;
	protected $allarme_sistema;
	protected $id_supervisore;
	protected $id_dispositivo;
    protected $tipo_allarme;
    protected $risolto;
    protected $tacitato;

    protected $oSupervisore = FALSE;
    protected $oDispositivo = FALSE;

    protected $class_action_url = '---';
	protected $class_url = 'statistiche';
	protected $nome_tabella = 'log_allarmi';
	protected $classe = 'logallarme';

    // per filtro ricerca
    protected $filtro_data_da;
    protected $filtro_data_a;

    protected $colonneForm = array('FILTRO_ELENCO_LOG_ALLARMI'=>2);

/*********************************************************************************************************/
public function inserisci() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function initByRecord($rec) {
    parent::initByRecord($rec);

    if (!empty($this->id_supervisore) && $this->id_supervisore != '-1') $this->oSupervisore = new supervisore($this->oApp, $this->id_supervisore);
    if (!empty($this->id_dispositivo) && $this->id_dispositivo != '-1') $this->oDispositivo = new dispositivo($this->oApp, $this->id_dispositivo);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOSupervisore() {
    return $this->oSupervisore;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getODispositivo() {
    return $this->oDispositivo;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTipoAllarmeDecoded() {
    if ($this->allarme_sistema) return $this->getTipoEventoDecoded();
    return $this->oApp->getEtichetta('TIPO_ALLARME_'.strtoupper($this->tipo_allarme));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTipoAllarmeCss() {
    $s = strtolower($this->tipo_allarme);
    $s = str_replace(':','-', $s);
    $s = str_replace('_','-', $s);
    return $s;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTipoEventoDecoded() {
    $s = '';
    switch ($this->tipo_allarme) {
        case 'SYSTEM:SUPERVISOR_CONNECTED':
            $s = $this->oApp->getEtichetta('ALLARME_SISTEMA_SYSTEM_SUPERVISOR_CONNECTED');
            break;
        case 'SYSTEM:SUPERVISOR_DISCONNECTED':
            $s = $this->oApp->getEtichetta('ALLARME_SISTEMA_SYSTEM_SUPERVISOR_DISCONNECTED');
            break;
        case 'SYSTEM:SERVER_STARTED':
            $s = $this->oApp->getEtichetta('ALLARME_SISTEMA_SYSTEM_SERVER_STARTED');
            break;
        case 'SYSTEM:RELAY_RELOAD_SIGNAL':
            $s = $this->oApp->getEtichetta('ALLARME_SISTEMA_SYSTEM_RELAY_RELOAD_SIGNAL');
            break;
        case 'SYSTEM:SERVER_MAIN_LOOP_STARTED':
            $s = $this->oApp->getEtichetta('ALLARME_SISTEMA_SYSTEM_SERVER_MAIN_LOOP_STARTED');
            break;
        default:
            $s = $this->tipo_allarme;
    }

    return $s;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDataOrdinabile() {
    $d = new DateTime($this->data);
    return '<span class="d-none">'.$d->format('Y-m-d-H:i-s').'</span>'.$d->format('d-m-Y H:i');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getRisoltoDecoded() {
    if ($this->allarme_sistema) {
        $g = new DateTime($this->data);
        return '<h5>
                    <span class="badge badge-secondary badge-logallarme">
                        <i class="fa fa-fw fa-check-circle-o"></i>'.SP.
                        $this->oApp->getEtichetta('EVENTO_GENERATO_IL').SP.
                        $g->format('d/m/Y H:i').
                    '</span>
                </h5>';
    } elseif ($this->risolto != '0000-00-00 00:00:00') {
        $d = new DateTime($this->risolto);
        $g = new DateTime($this->data);
        return '<h5>
                    <span class="badge badge-secondary badge-logallarme">
                        <i class="fa fa-fw fa-check-circle-o"></i>'.SP.
                        $this->oApp->getEtichetta('ALLARME_GENERATO_IL').SP.
                        $g->format('d/m/Y H:i').
                    '</span>
                    <span class="badge badge-success badge-logallarme">
                        <i class="fa fa-fw fa-check-circle-o"></i> '.SP.
                        $this->oApp->getEtichetta('ALLARME_RISOLTO_IL').SP.
                        $d->format('d/m/Y H:i').
                    '</span>
                </h5>';
    } else {
        return '<h5>
                    <span class="badge badge-logallarme">
                        <i class="fa fa-fw fa-exclamation-triangle "></i> '.SP.
                        $this->oApp->getEtichetta('ALLARME_ATTIVO').'
                        <i class="fa fa-fw fa-exclamation-triangle "></i>
                    </span>
                </h5>';
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getStatus() {
    return (($this->risolto == '0000-00-00 00:00:00')?'allarme-attivo':'allarme-risolto');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIdStatus() {
    return (($this->risolto == '0000-00-00 00:00:00')?STATUS_ALLARME_ATTIVO:STATUS_ALLARME_RISOLTO);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDenominazioneSupervisore() {
    if ($this->id_supervisore !== -1 &&  $this->oSupervisore !== FALSE) return $this->oSupervisore->get('denominazioneTabella');
    return 'n.d.';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDenominazioneDispositivo() {
    if ($this->id_dispositivo !== -1 &&  $this->oDispositivo !== FALSE) return $this->oDispositivo->get('denominazioneTabella');
    return 'n.d.';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormFiltro() {
    $this->getForm('FILTRO_ELENCO_LOG_ALLARMI', 'ricerca', '', 'standard', TRUE, FALSE, FALSE, TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>