<?php
abstract class oggetto extends classebase {
	protected $id_oggetto_tipo;
	protected $nome_attributo_id = FALSE;

	protected $id_status;
	protected $status;
	protected $data_creazione;
	protected $data_ultima_modifica;
	protected $id_utente_creatore;
	protected $id_utente_ultima_modifica;
	protected $id_utente_proprietario;

	/*
	protected $oApp; // oggetto APP che istanzia l'oggetto
  	protected $oDb;  // oggetto DB
  	protected $oUtente;  // oggetto UTENTE
  	*/

  	// proprieta che servono per vari reindirizzamenti ecc...
  	protected $form_method = 'post';

  	protected $class_action_url;
   	protected $class_url;
   	protected $nome_tabella;
   	protected $classe;
   	protected $haStatus = TRUE;
   	protected $risorseOrganizzatePerMesi = FALSE;

	protected $form_bottoni = array('inserisci' => array('mode' => 'inserisci', 'classe' => 'btn-primary', 'type' => 'submit', 'etichetta' => 'SALVA', 'icona' => 'icon-ok'),
									'modifica' => array('mode' => 'modifica', 'classe' => 'btn-primary', 'type' => 'submit', 'etichetta' => 'SALVA', 'icona' => 'icon-ok'),
									'annulla' => array('mode' => 'tutti', 'classe' => 'btn bottone_annulla_modifiche', 'type' => 'button', 'etichetta' => 'ANNULLA', 'icona' => 'icon-remove'),
									'ricerca' => array('mode' => 'ricerca', 'classe' => 'btn-primary', 'type' => 'submit', 'etichetta' => 'CERCA', 'icona' => 'icon-search'),
									'invia' => array('mode' => 'invia', 'classe' => 'btn-primary', 'type' => 'submit', 'etichetta' => 'INVIA', 'icona' => 'icon-pencil'),
									'upload' => array('mode' => 'upload', 'classe' => 'btn-primary', 'type' => 'submit', 'etichetta' => 'UPLOAD', 'icona' => 'icon-upload'),
									'verifica' => array('mode' => 'verifica', 'classe' => 'btn-primary', 'type' => 'submit', 'etichetta' => 'VERIFICA', 'icona' => 'icon-search')
									);

	protected $oSeStessoPrecedente = FALSE; // oggetto che porta i dati di sè stesso prima di ogni initByRecord

	protected $oElencoNote = FALSE; // oggetto di tipo ELENCONOTA
	protected $oElencoDocumenti = FALSE; // oggetto di tipo ELENCODOCUMENTO
	protected $oElencoAppuntamenti = FALSE; // oggetto di tipo ELENCOAPPUNTAMENTO
	protected $oElencoEsperienzeLavorative = FALSE; // oggetto di tipo ELENCOESPERIENZALAVORATIVA
    protected $oElencoImmagini = FALSE; // oggetto di tipo ELENCOIMMAGINI
    protected $oElencoPianificazione; // oggetto di tipo ELENCOPIANIFICAZIONE
    protected $oElencoFeedback; // oggetto di tipo ELENCOFEEDBACK

	protected $divComplessivoForm = TRUE;

	protected $path_risorse_private;
	protected $path_risorse_private_immagini;
	protected $path_risorse_private_xml;
	protected $path_risorse_private_documenti;
	protected $path_risorse_private_immagini_originali;
	protected $path_risorse_private_immagini_upload;
	protected $path_risorse_pubbliche;
	protected $path_risorse_pubbliche_immagini;

/*********************************************************************************************************/
/*********************************************************************************************************/
abstract public function inserisci();
abstract public function modifica();

/*********************************************************************************************************/
/*********************************************************************************************************/
/*
public function __sleep() {
	$ret = array();
	foreach ($this as $attributo => $valore) {
		if (!in_array($attributo, unserialize(aATTRIBUTI_DA_NON_SERIALIZZARE))) {
			$ret[] = $attributo;
		}
	}
	return $ret;
}
*/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*
public function __wakeup() {
	if (array_key_exists('OAPP', $_SESSION)) $this->oApp = unserialize($_SESSION['OAPP']);
	if ($this->classe != 'utente' && array_key_exists('UTENTE_LOGGATO', $_SESSION)) $this->oUtente = unserialize($_SESSION['UTENTE_LOGGATO']);
	if (array_key_exists('ODB', $_SESSION)) $this->oDb = unserialize($_SESSION['ODB']);
}
*/
/*********************************************************************************************************/
/*********************************************************************************************************/
public function elimina() {
	// eliminazione logica in una singola tabella
	$sql = 'UPDATE '.$this->nome_tabella.' SET id_status = '.STATUS_ELIMINATO.' , '.$this->getUpdateCampiBase(TRUE).' WHERE '.$this->getNomeAttributoId().' = '.num2Str($this->getId());
	$ret = $this->oDb->eseguiupdate($sql);
	if ($ret) {
	    if ($this->classe == 'supervisore' || $this->classe == 'relay') $this->sendSignal(__METHOD__);
    }
	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __construct($oApp, $id = 0) {
	instance_of($oApp, 'app');

	$this->classe = get_class($this);
	$this->oApp = $oApp;
	$this->oDb = $this->oApp->get('oDb');
	$this->oUtente = $this->oApp->get('oUtente');

	$attributo = $this->getNomeAttributoId();

	$this->$attributo = $id;


	if (!empty($id)) {
		$this->load();
	}

	// controlli per le proprieta' che servono essere valorizzati nelle singole classi
	if (empty($this->form_method)) die(__METHOD__ . ' = $this->form_method');
	if (empty($this->form_bottoni)) die(__METHOD__ . ' = $this->form_bottoni');
	if (empty($this->class_action_url)) die(__METHOD__ . ' = $this->class_action_url');
	if (empty($this->class_url)) die(__METHOD__ . ' = $this->class_url');
	if (empty($this->nome_tabella)) die(__METHOD__ . ' = $this->nome_tabella');
	if (empty($this->classe)) die(__METHOD__ . ' = $this->classe');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function salvaStatoPrecedente() {
	/*
	$o = $this->classe;
	$this->oSeStessoPrecedente = new $o($this->oApp);
	$this->oSeStessoPrecedente->clona($this);
	*/
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function load() {
	$nome_classe_elenco = 'elenco' . $this->classe;
	$oElenco = new $nome_classe_elenco($this->oApp);

	if ($this->classe == 'traduzione') {
		$sql = $oElenco->getSqlToLoad(FALSE, FALSE, $this->getId());
	} else {
		$sql = $oElenco->getSqlToLoad(FALSE, FALSE, $this->getId());
	}

	$sql .= ' LIMIT 1';
	$rec = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_ROW);
	$this->initByRecord($rec);

	//dump(__FUNCTION__.' - '.$nome_classe_elenco);
	//$this->clona($oElenco->getPrimoElemento());
	//$this->salvaStatoPrecedente();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function initByRecord($rec) {
	$this->salvaStatoPrecedente();

	foreach ($this as $attributo => $valore) {
		if (!is_object($attributo)) {
			if (array_key_exists($attributo, $rec)) {
				if (is_string($attributo) && stripos($attributo, 'datatime_') !== FALSE && $attributo != 'data_creazione' && $attributo != 'data_ultima_modifica') {
					$x = explode(' ', trim($rec[$attributo]));
					$a = explode('-', $x[0]);
					if (strlen($a[0]) == 2 && strlen($a[1]) == 2 && strlen($a[2]) == 4)  $this->$attributo = $rec[$attributo];
					if (strlen($a[0]) == 4 && strlen($a[1]) == 2 && strlen($a[2]) == 2)  $this->$attributo = $a[2].'-'.$a[1].'-'.$a[0].' '.substr($x[1],0,5);
					if (empty($rec[$attributo])) $this->$attributo = '';
				} elseif (is_string($attributo) && (stripos($attributo, 'data_') !== FALSE || stripos($attributo, '_data') !== FALSE) && $attributo != 'data_creazione' && $attributo != 'data_ultima_modifica') {
					$a = explode('-', $rec[$attributo]);
					if (strlen($a[0]) == 2 && strlen($a[1]) == 2 && strlen($a[2]) == 4)  $this->$attributo = $rec[$attributo];
					if (strlen($a[0]) == 4 && strlen($a[1]) == 2 && strlen($a[2]) == 2)  $this->$attributo = $a[2].'-'.$a[1].'-'.$a[0];
					if (empty($rec[$attributo])) $this->$attributo = '';
				} else {
					$this->$attributo = $rec[$attributo];
				}
		  	}
		}
	}

    $id = $this->getId();
    if (!empty($id)) $this->elaboraPathRisorse();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function elaboraPathRisorse() {

	$this->path_risorse_private = DIR_DATA.$this->classe.'/'.$this->getCartellaRisorse().'/';
	$this->path_risorse_private_xml = $this->path_risorse_private.'xml/';
	$this->path_risorse_private_immagini = $this->path_risorse_private.'immagini/';
	$this->path_risorse_private_documenti = $this->path_risorse_private.'documenti/';
	$this->path_risorse_private_immagini_originali = $this->path_risorse_private_immagini.'_originali/';
	$this->path_risorse_private_immagini_upload = $this->path_risorse_private_immagini.'_upload/';
	$this->path_risorse_pubbliche = DIR_IMMAGINI.$this->classe.'/'.$this->getCartellaRisorse().'/';
	$this->path_risorse_pubbliche_immagini = $this->path_risorse_pubbliche.'immagini/';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function getCartellaRisorse() {
	$ret = aggiungizeri($this->getId(), 10);
	if ($this->risorseOrganizzatePerMesi) {
		$dataCreazione = new datetime($this->data_creazione);
		$ret = $dataCreazione->format('Y-m').'/'.$ret;
	}
	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function completaConDatiFissi($oOggetto) {
	$this->data_creazione = $oOggetto->get('data_creazione');
	$this->data_ultima_modifica = $oOggetto->get('data_ultima_modifica');
	$this->id_utente_creatore = $oOggetto->get('id_utente_creatore');
	$this->id_utente_ultima_modifica = $oOggetto->get('id_utente_ultima_modifica');
	$this->id_utente_proprietario = $oOggetto->get('id_utente_proprietario');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isEmpty($propertyName){
	$metodo = 'get' . str_replace('_', '', str_replace(' ', '', $propertyName));
	if (method_exists($this, $metodo)) {
		$v = $this->$metodo();
	} else {
		$v = $this->$propertyName;
	}
	return empty($v);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function set($propertyName, $valore){
	$metodo = 'set' . str_replace('_', '', $propertyName);
	if (method_exists($this, $metodo)) {
		$this->$metodo($valore);
	} else {
		$this->$propertyName = $valore;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getId(){
	$nome = $this->getNomeAttributoId();
	return $this->$nome;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getIdPostEncoded() {
	return writePostParam($this->getId());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getIdGetEncoded() {
	return writeGetParam($this->getId());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function toArray() {
	$array = array();
	foreach ($this->elencoCampiDb as $campo) {
		$array[$campo] = $this->$campo;
	}
	return $array;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function cambiaIdUtenteProprietario($nuovo_id_utente_proprietario) {
	$sql = 'UPDATE '.$this->nome_tabella.' 
	           SET id_utente_proprietario='.num2str($nuovo_id_utente_proprietario).' 
			 WHERE '.$this->nome_attributo_id.' = '.num2str($this->getId());
	//echo $sql.'<br>';
	return $this->oDb->eseguiupdate($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getInserisci() {
	$id = 'BOTTONE_'.$this->classe.'_CREA';
	return bottone($this->oApp, strtoupper($id), strtolower($id), $this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getModifica() {
	$id = 'BOTTONE_'.$this->classe.'_MODIFICA';
	return bottone($this->oApp, strtoupper($id), strtolower($id), $this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElimina($visualizza_etichetta=TRUE) {
	$id = 'BOTTONE_'.$this->classe.'_ELIMINA';
	return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, $visualizza_etichetta);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getEliminaNoEtichetta() {
    return $this->getElimina(FALSE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAzioni($esploso = FALSE) {
    return menu_dropdown($this->oApp, $this->getABottoniAzioniDropdown(), 'BOTTONE_AZIONI_DROPDOWN_'.strtoupper($this->classe), $this, FALSE, $esploso);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getABottoniAzioniDropdown() {
    $a = array();
    $a[] = 'BOTTONE_'.strtoupper($this->classe).'_MODIFICA';
    $a[] = 'BOTTONE_'.strtoupper($this->classe).'_ELIMINA';
    $this->getABottoniAzioniDropdownExtra($a);
    return $a;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getABottoniAzioniDropdownExtra(&$a) {
    // per aggiungere altri bottoni oltre a modifica/elimina
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getBottoneAzione($azione, $mode = 'link', $azioneDiretta = FALSE) {
	$permesso = strtoupper($this->get('classe').' - '.$azione);
	if ($this->oUtente->haPermesso($permesso)) {
		switch ($mode) {
			case 'link':
				return __linkAzione($azione, $this, $azioneDiretta);
			break;
			case 'bottone':
				return __bottone($azione, $this);
			break;
			case 'url':
				return __URLAzione($azione, $this);
			break;
			default:
				return __linkAzione($azione, $this, $azioneDiretta);
			break;
		}
	} else {
		if (APP_SVILUPPO) return 'manca permesso ' . $permesso;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormInserisci($aCampiHiddenExtra = FALSE, $action = NULL) {
	$this->getForm($this->classe, 'Inserisci', $action, 'standard', TRUE, TRUE, $aCampiHiddenExtra);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormInserisciNoBottoni($aCampiHiddenExtra = FALSE, $accodaValidazione = TRUE, $html = TRUE) {
	$this->getForm($this->classe, 'Inserisci', NULL, 'standard', FALSE, TRUE, $aCampiHiddenExtra, $accodaValidazione, NULL, $html);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormModifica($aCampiHiddenExtra = FALSE) {
	$this->getForm($this->classe, 'Modifica', NULL, 'standard', TRUE, TRUE, $aCampiHiddenExtra);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormModificaNoBottoni($aCampiHiddenExtra = FALSE, $accodaValidazione = TRUE, $html = TRUE) {
	$this->getForm($this->classe, 'Modifica', NULL, 'standard', FALSE, TRUE, $aCampiHiddenExtra, $accodaValidazione, NULL, $html);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isFormValido(&$post, $tipo, $form = FALSE, $campiComuni = TRUE, $singoloCampo = FALSE) {
	if ($form == FALSE) $form = $this->classe;
	$ret = TRUE;
	$messaggio = '';
	$error = array();
	if (ATTIVA_CONTROLLI_FORM_PHP) {
		$aCampi = $this->getBaseFormConfiguration($tipo, $form, $campiComuni);
		foreach ($aCampi as $campo => $elencoValori) {
			if ($singoloCampo !== FALSE && $elencoValori['nome_campo'] != $singoloCampo) continue;
			if ((bool)$elencoValori['stampa'] && $elencoValori['tipo_campo'] != 'upload') {
				$aRegole = array();
				if ($elencoValori['tipo_campo'] !== 'hidden') {
					$etichetta = $elencoValori['etichetta'];
					if (!isset($etichetta) || is_null($etichetta) ||  $etichetta == -1) {
						$etichetta = strtoupper('FORM - '.$elencoValori['nome_form'].' - '.$elencoValori['nome_campo']);
					}
					$etichetta = $this->oApp->getEtichetta($etichetta);
				}else {
					if ($campo == 'ha_proprietari') {
						$etichetta = $this->oApp->getEtichetta('FORM_PROPRIETARI_MSG');
					} else {
						$etichetta = ' '.strtoupper($campo).'si è verificato un errore grave. Contattare l\'amministratore del sistema';
					}
				}
				foreach ($elencoValori as $k=>$v) {
					if (stripos($k, 'val_') !== FALSE && (bool)$v) {
						$aRegole[str_replace('val_', '', $k)] = $v;
					}
				}

				if (in_array($elencoValori['tipo_campo'], unserialize(aTIPI_DIZIONARIO))) {
					$lingue = unserialize(LINGUE_ATTIVE);
					$primoGiro = TRUE;
					foreach($lingue as $l) {
						if ($l == LINGUA_NAVIGAZIONE || !VALIDAZIONE_CAMPI_DIZIONARIO_OBBLIGATORIA_SOLO_LINGUA_DEFAULT) {
							$nome = encodaNomeCampoDizionario($elencoValori['tipo_campo'], $elencoValori['nome_campo'], $l);
							controllaCampo($ret, $error, $post, $aRegole, $nome, $etichetta, $this, $aCampi, $post);
						}
					}
				} else {
					controllaCampo($ret, $error, $post, $aRegole, $campo, $etichetta, $this, $aCampi, $post);
				}

				//****************************************
				// applico eventuali funzioni di formattazione del campo
				if ((bool)$elencoValori['stampa'] && !empty($elencoValori['funzioni_formattazione'])) {
					$aFunzioni = explode(',', $elencoValori['funzioni_formattazione']);
					foreach ($aFunzioni as $f) {
						$_POST[$campo] = $f($_POST[$campo]);
					}
				}

				// nel caso il campo sia di tipo boolean (checkbox si/no) e il valore sia zero allora lo imposto perchè non c'è nell'array $_POST
				if ($elencoValori['tipo_campo'] == 'boolean' && !array_key_exists($campo, $_POST)) {
					$_POST[$campo] = 0;
				}
			}
		}

		if ($ret === TRUE) {
			return TRUE;
		} else {
			// il form non e valido => reindirizzo alla pagina di provenienza
			$str = '';
			foreach ($error as $c => $errore) {
				$str .= 'il campo ' . $c . ' ' . $errore . '<br />';
			}
			return $str;
		}
	}
	return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getValidazioneJquery($idForm, $tipo, $aCampi) {
	$strValidazione = '';

	foreach ($aCampi as $campo => $elencoValori) {
		if ((bool)$elencoValori['stampa']) {
			$strRegole = '';
			foreach ($elencoValori as $k=>$v) {
				if (stripos($k, 'val_') !== FALSE && (bool)$v) {
					if (!empty($strRegole)) $strRegole .= ', ';
					/*
					aggiungo alcune regole così come sono scritte togliendo il prefisso val_:
					- val_required / val_email / val_codiceFiscale / val_partitaIva / val_partitaIvaOrCodiceFiscale / val_dateTimeISO / val_integer

					altre vanno "riscritte" in modo accettabile per jquery.validate
					- val_univoco / val_minlenght / val_maxlenght / val_exactlenght / val_equalTo / val_requiredIF
					*/
					$regola = str_replace('val_', '', $k);

					switch ($regola) {
						case 'univoco':
								$strRegole .= 'remote: {url: "'.URL_AZIONI.'verifica_univocita_campi.php", 
														type: "post", 
														data: {oggetto: "'.$this->classe.'", 
															   id_oggetto: "'.$this->getId().'", 
															   campo: "'.$campo.'", 
															   valore: function() { return $("#'.$campo.'").val(); }
															  }
													   }';
							break;
						case 'minlength':
						case 'maxlength':
						case 'exactlength':
								$strRegole .= $regola.': '.$v;
							break;
						case 'rangelength':
								$strRegole .= $regola.': ['.$v.']';
							break;
						case 'equalTo':
								$strRegole .= $regola.': "#'.$v.'"';
							break;
						case 'requiredIF':
								$strRegole .= $regola.': "'.$v.'"';
							break;
						case 'notCompilableIF':
								$strRegole .= $regola.': "'.$v.'"';
							break;
						case 'accept':
								$strRegole .= 'extension: "'.$v.'"';
							break;
						default:
								$strRegole .= $regola.':'.(((bool)$v)?'true':'false');
					}
				}
			}
		}

		$aNomeCampo = array();
		if (in_array($elencoValori['tipo_campo'], unserialize(aTIPI_DIZIONARIO))) {
			foreach(unserialize(LINGUE_ATTIVE) as $l) {
				if ($l == LINGUA_NAVIGAZIONE || !VALIDAZIONE_CAMPI_DIZIONARIO_OBBLIGATORIA_SOLO_LINGUA_DEFAULT) {
					$aNomeCampo[] = (($elencoValori['tipo_campo'] == TIPO_DIZIONARIO_EDITOR)?'wysiwyg_':'').encodaNomeCampoDizionario($elencoValori['tipo_campo'], $elencoValori['nome_campo'], $l);
				}
			}
		}
		elseif (stripos($elencoValori['tipo_campo'] , 'checkbox') !== FALSE) {
			$aNomeCampo[] = $campo.'[]';
		}
		elseif ((bool)$elencoValori['select_multipla']) {
			$aNomeCampo[] = $campo.'[]';
		}
		else {
			$aNomeCampo[] = $campo;
		}

		foreach($aNomeCampo as $c) {
			if (!empty($strValidazione) && !empty($strRegole)) $strValidazione .= ',';
			if (!empty($strRegole)) $strValidazione .= NL.'"'.$c.'" : {'.$strRegole.'}';
		}
	}

	if (empty($strValidazione)) return '';
	$ret = '$(function() {'.
	                 NL.'$("#'.$idForm.'").validate({ignore: "",
					                                 rules:{'.$strValidazione.NL.'},
													 errorPlacement: function(error, element) {
														if(element.attr("type") == "checkbox") {
															//alert("checkbox");
															error.appendTo( element.parentsUntil("div") );
														} else if(element.attr("type") == "radio") {
															//alert("radio");
															//error.appendTo( element.parentsUntil("div.control-group"));
															error.appendTo( element.parent().parent().parent().parent());
														} else {
															error.appendTo( element.parent("div") );
														}
													 },
                               						 highlight : function(label) {
                               						 							  $(label).closest(".control-group").removeClass("success");
																				  $(label).closest(".control-group").addClass("error");
				                                                                 },
				                                     success : function(label) {
				                                     							label.text("").addClass("valid").closest(".control-group").addClass("success");
																			   },
													 showErrors: function(errorMap, errorList)  {
																									this.defaultShowErrors();
																									$(".jarviswidget").each(function() {
																										var widget = $(this);
																										var contenuto = $(this).find(".inner-spacer");
																										var htmlTxt = contenuto.html();
																										//alert(htmlTxt);
																										if(typeof htmlTxt !== \'undefined\'){
																											//if(htmlTxt.indexOf("<label class=\"error\"") > -1) {
																											if($(contenuto).find("div.error").length != 0) {
																												widget.removeClass("jarviswidget-collapsed");
																												widget.find("div[role=content]").show();
																												widget.find("header div a i").addClass("minus-10").removeClass("plus-10");
																											}
																										}
																										if ($("form#formModificaOfferta input#ha_proprietari").length != 0) {
																											if ($("form#formModificaOfferta input#ha_proprietari").val() != "1") {
																												if ($("form#formModificaOfferta #id_stato_offerta").val() > 2) {
																													var div_padre = $("form#formModificaOfferta input#proprietario").parent("div");
																													var div_nonno = $(div_padre).parent("div");
																													$(div_padre).removeClass("success").addClass("error");
																													$(div_nonno).removeClass("success").addClass("error");
																													$(div_padre).find("label").removeClass("valid").html(FORM_PROPRIETARI_ERRORE);
																												}
																											}
																										}
																									});
																								}
												    });
		                 });';

	return NL.'<script type="text/javascript">'.NL.$ret.NL.'</script>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getForm($form, $tipo, $action = NULL, $classe = 'standard', $stampaBottoni = TRUE, $campiComuni = TRUE, $aCampiHiddenExtra = FALSE, $accodaValidazione = TRUE, $target = NULL, $html = TRUE, $stampaTagForm = TRUE) {
   	// imposto i parametri principali della form
	$nomeForm = $tipo.str_replace(' ', '', ucfirst(strtolower($this->classe)));

	// recupero i parametri dei campi
	$aCampi = $this->getBaseFormConfiguration($tipo, $form, $campiComuni);

	$campoUploadPresente = FALSE;
	foreach ($aCampi as $campo) {
		if ($campo['tipo_campo'] == 'upload') {
			$campoUploadPresente = TRUE;
			break;
		}
	}

	// recupero i parametri dei pulsanti
	$button = array();
	$button[$tipo] = array('type' => 'submit', 'suffix' => $nomeForm);
	$button['Annulla'] = array('type' => 'button', 'suffix' => $nomeForm);

	if (is_null($action)) $action = strtolower(URL_BACKEND.$this->class_action_url.$tipo).'.php';

	$numero_colonne = 1;
	if (isset($this->colonneForm[strtoupper($form)])) $numero_colonne = $this->colonneForm[strtoupper($form)];
	if ($this->classe == 'fase' && stripos($form, 'FASE_') !== FALSE && $form != 'FASE_BLOCCO_MASSIVO') $numero_colonne = 2;

	$spanFieldset = (string)(ceil(12/$numero_colonne));


	//echo '<div class="registrazione">';
	if ($stampaTagForm) {
		echo '<form class="obiettivo_futuro form-horizontal themed '.$classe.'" 
					rel="'.str_replace(' ', '_', strtolower($this->classe)).' '.strtolower(str_replace(' ', '_', $tipo)).'" 
					name="form'.$nomeForm.'" id="form'.$nomeForm.'" 
					method="'.$this->form_method.'" 
					action="'.$action.'"
					'.(($campoUploadPresente == TRUE)?' enctype="multipart/form-data"':'').'
					novalidate
					'.((!is_null($target))?' target="'.$target.'"':'').'>';
	}

	$aHtmlCampi = array();

	foreach ($aCampi as $nome => $attributi) {
		if ((bool)$attributi['stampa'] && (!array_key_exists('mode', $attributi) || strtoupper($attributi['mode']) === strtoupper($tipo) || strtoupper($attributi['mode']) === 'TUTTI') ) {
			
			ob_start();
			$this->stampaCampoForm($attributi, $tipo, $form, $spanFieldset);
			$h = ob_get_contents();
			ob_end_clean();
			$aHtmlCampi[] = array('fieldset_singolo_campo'=>$attributi['fieldset'],'colonne_singolo_campo'=>$attributi['col_span'],'html_singolo_campo'=>$h);
		}
	}

	// stampo la form
	ob_start();
	$primo_giro = TRUE;
	$fieldset_corrente = '';
	$colonne_campi_stampati = 0;
	foreach ($aHtmlCampi as $i=>$aHtmlSingoloCampo) {
		extract($aHtmlSingoloCampo);
		if ($fieldset_singolo_campo != $fieldset_corrente) {
			if (!$primo_giro) {
				if ($colonne_campi_stampati != 0) echo '</div>';
				if ($fieldset_corrente != '') echo '</fieldset>';
			}
			echo '<fieldset'.(($fieldset_singolo_campo == 'HIDDEN')?' class="hidden"':'').'>';
			if ($fieldset_singolo_campo !== 'HIDDEN') {
				if ($this->classe == 'fase') echo '<legend>'.str_replace('SOCIETA','SOCIET&Agrave;',$fieldset_singolo_campo).'</legend>';
				if ($this->classe == 'utente' && $fieldset_singolo_campo == 'DATI_DOMICILIO') echo '<div class="row" id="dati_domicilio">'.$this->oApp->getEtichetta('FIELDSET_UTENTE_DOMICILIO').'</div>';
			}
			$fieldset_corrente = $fieldset_singolo_campo;
			$colonne_campi_stampati = 0;
		}

		if (($colonne_campi_stampati + $colonne_singolo_campo) > $numero_colonne) $colonne_campi_stampati = 0;

		$una_colonna = ($numero_colonne == 1);
		$span_12 = $colonne_singolo_campo == $numero_colonne;

		if ($una_colonna || $span_12 || $colonne_campi_stampati == 0) echo '<div class="row">';
		echo $html_singolo_campo;
		$colonne_campi_stampati += $colonne_singolo_campo;
		if ($una_colonna || $span_12 || $colonne_campi_stampati == $numero_colonne) {
			echo '</div>';
			$colonne_campi_stampati = 0;
		}

		$primo_giro = FALSE;
	}
	if ($colonne_campi_stampati != 0) echo '</div>';
	if ($fieldset_corrente != '') echo '</fieldset>';
	$h = ob_get_contents();
	ob_end_clean();

	echo $h;
	//echo htmlentities($h);
	//die;

	if ($aCampiHiddenExtra !== FALSE) {
		if (is_array($aCampiHiddenExtra)) {
			echo '<fieldset class="hidden">';
			foreach ($aCampiHiddenExtra as $campo=>$valore) {
				echo _form_hidden_field($campo, $valore);
			}
			echo '</fieldset>';
		}
	}


	if ($tipo != 'visualizza') {
		if (method_exists($this, 'getFormExtraFieldset')) {
			$this->getFormExtraFieldset($tipo);
		}
	}

	if ($stampaBottoni) {
        echo '<fieldset class="bottoni">';
            echo '<div class="form-actions">';
            foreach ($this->form_bottoni as $bottone => $dati) {
                extract($dati);
                if (strtolower($mode) == strtolower($tipo) || strtolower($mode) == 'tutti') {
                    if (strtolower($mode) == 'tutti' && $this->classe != 'utente') continue;
                    echo '<button id="button'.ucfirst($nomeForm).str_replace(' ','',ucwords($bottone)).'" class="btn medium '.$classe.'" type="'.$type.'"><i class="'.$icona.'"></i> '.$this->oApp->getEtichettaBottone($etichetta).'</button>';
                }
            }
            echo '</div>';
        echo '</fieldset>';
	}

	if ($stampaTagForm) echo '</form>';
	//echo '</div>';

	$this->gestisciValidazioneJquery($tipo, $form, $accodaValidazione, $aCampi);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function stampaCampoForm(&$attributi, $tipo, $form, $spanFieldset) {
	if (in_array($attributi['tipo_campo'], unserialize(aTIPI_DIZIONARIO))) {
		echo _form_field_dizionario($this, $attributi, $tipo, 'span'.($spanFieldset*$attributi['col_span']));
	} else {
		echo _form_field($this, $attributi, $tipo, $form, FALSE, 'col-xl-'.($spanFieldset*$attributi['col_span']));
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function gestisciValidazioneJquery($tipo, $form, $accodaValidazione, $aCampi = NULL, $campiComuni = TRUE) {
	if (ATTIVA_CONTROLLI_FORM_JAVASCRIPT && $tipo != 'visualizza') {
		if (is_null($aCampi)) $aCampi = $this->getBaseFormConfiguration($tipo, $form, $campiComuni);

		$nomeForm = $tipo.str_replace(' ', '', ucfirst(strtolower($this->classe)));

		$htmlValidate = $this->getValidazioneJquery('form'.$nomeForm, $tipo, $aCampi);
		if ($accodaValidazione) {
			$htmlJscript  = $this->oApp->get('htmlJscript');
			$this->oApp->set('htmlJscript', $htmlJscript.$htmlValidate);
		} else {
			echo $htmlValidate;
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSingoloCampoForm($form, $campo) {
	$aCampi = $this->getBaseFormConfiguration('tutti', $form, FALSE);

	foreach ($aCampi as $nome => $attributi) {
		if (strtoupper($campo) == strtoupper($nome)) {
			if ((bool)$attributi['stampa'] && (!array_key_exists('mode', $attributi) || strtoupper($attributi['mode']) === strtoupper('tutti') || strtoupper($attributi['mode']) === 'TUTTI') ) {
				if (in_array($attributi['tipo_campo'], unserialize(aTIPI_DIZIONARIO))) {
					echo _form_field_dizionario($this, $attributi, 'tutti');
				} else {
					echo _form_field($this, $attributi, 'tutti', $form);
				}
			}
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getTotaleCampiVisibiliForm($tipo, $form) {
	$sql = 'SELECT count(*) 
	          FROM form 
	         WHERE nome_form = '.stripcslashesandquote(strtoupper($form)).' 
	           AND mode IN ('.stripcslashesandquote(strtolower($tipo)).',"tutti")
			   AND tipo_campo != "hidden"';
	return (int)$this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getBaseFormConfiguration($tipo, $nome = FALSE, $campiComuni = TRUE, $tutti_campi_oggetto_non_filtrati = FALSE) {
	if ($nome === FALSE) $nome = $this->classe;

 	$aCampi = array();

 	$clausolaUtenti = 'utenti_abilitati IS NULL';
 	if ($this->oUtente !== FALSE) $clausolaUtenti .= ' OR utenti_abilitati LIKE "%'.$this->oUtente->get('id_utente_tipo').'%"';

	//$sql = 'SELECT id_form,nome_form,fieldset,nome_campo,utenti_abilitati,ordine,etichetta,etichetta_testo_esplicativo,stampa,tipo_campo,numero_colonne,mode,campo_controllo,valore_default,valori_select,select_multipla,select_collegata,campo_collegato,funzioni_formattazione,enabled,style,icona,val_required,val_univoco,val_email,val_codiceFiscale,val_partitaIva,val_partitaIvaOrCodiceFiscale,val_dateITA,val_dateTimeITA,val_dateTimeISO,val_integer,val_url,val_minlength,val_maxlength,val_exactlength,val_equalTo,val_requiredIF,val_notCompilableIF,val_digits,val_decimale,col_span,val_alphanumeric,val_nowhitespace
	$sql = 'SELECT *
			  FROM form 
	         WHERE nome_form IN('.stripcslashesandquote(strtoupper($nome)).',\''.(($campiComuni)?'__CAMPI_COMUNI':'').'\') 
	           AND stampa = 1
			   AND mode IN ('.stripcslashesandquote(strtolower($tipo)).',"tutti")
	           AND ('.$clausolaUtenti.') ';
	$sql .= ' ORDER BY nome_form,fieldset_ordine,ordine';

	$rows = $this->oDb->eseguiselect($sql);
	foreach ($rows as $c) {
        if ($tutti_campi_oggetto_non_filtrati) {
            $aCampi[$c['nome_campo']] = $c;
        }  else {
            if ($this->isCampoFormDaAggiungere($c, $nome, $tipo)) $aCampi[$c['nome_campo']] = $c;
        }
	}

	return $aCampi;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function isCampoFormDaAggiungere(&$aCampo, $nome_form, $mode) {
	// DI BASE TUTTI I CAMPI VANNO AGGIUNTI.
	// ESTENDENDO QUESTO METODO ALLE SINGOLE CLASSI SI POSSONO CREARE ECCEZIONI.
	return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function checkValiditaCampo(&$post, $tipo, $campo) {
   return $this->isFormValido($post, $tipo, $form = FALSE, $campiComuni = TRUE, $campo);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getDizionario($id_dizionario, $tabella, $lingua) {
	verificaParametro((in_array($tabella, unserialize(aTIPI_DIZIONARIO))), __METHOD__.' tabella sbagliata');
	verificaParametro((in_array($lingua, unserialize(LINGUE_ATTIVE))), __METHOD__.' lingua sbagliata');

	$sql = 'SELECT '.$lingua.' FROM '.$tabella.' WHERE id_dizionario='.num2str($id_dizionario);
	return $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoRuoli () {

	$id_utente_tipo_loggato = $this->oApp->getIdUtenteTipoLoggato();

	$sql = 'SELECT id_utente_tipo AS id, ruolo AS descrizione FROM utenti_tipi WHERE id_status = '.STATUS_ATTIVO;

	if (empty($id_utente_tipo_loggato)){
		//restituisco elenco vuoto
		$sql .= ' AND id_utente_tipo < 0';
	}else{
	    /*
		//if (property_exists($this->classe, 'id_utente_tipo') && $this->id_utente_tipo == UTENTE_TIPO_ID_TITOLARE) {
		if ($id_utente_tipo_loggato == UTENTE_TIPO_ID_SEGRETERIA) {
			// sono un TITOLARE: posso creare solo ujtenti di tipo funzionario e visualizzazione
			$sql .= ' AND id_utente_tipo IN ('.UTENTE_TIPO_ID_UTENTE.')';
		}

		//if (property_exists($this->classe, 'id_utente_tipo') && $this->id_utente_tipo == UTENTE_TIPO_ID_SEGRETERIA) {
		if ($id_utente_tipo_loggato == UTENTE_TIPO_ID_ADMIN) {
			// sono un SEGRETERIA: posso creare qualsiasi tipo di utente tranne un super admin e un segreteria
			//$sql .= ' AND id_utente_tipo NOT IN ('.UTENTE_TIPO_ID_SUPERADMIN.','.UTENTE_TIPO_ID_SEGRETERIA.')';
			$sql .= ' AND id_utente_tipo NOT IN ('.UTENTE_TIPO_ID_SUPERADMIN.')';
		}

		//if (property_exists($this->classe, 'id_utente_tipo') && $this->id_utente_tipo == UTENTE_TIPO_ID_SUPERADMIN) {
		if ($id_utente_tipo_loggato == UTENTE_TIPO_ID_SUPERADMIN) {
		    // sono un SUPER ADMIN: posso creare qualsiasi tipo di utente tranne SUPER
            $sql .= ' AND id_utente_tipo NOT IN ('.UTENTE_TIPO_ID_SUPERADMIN.')';
		}
	    */
        $sql .= ' AND id_utente_tipo >= ' . num2Str($this->oApp->getIdUtenteTipoLoggato());
    }
	//echo $sql;
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoRuoliById($id) {
	$sql = 'SELECT id_utente_tipo AS id, ruolo AS descrizione FROM utenti_tipi WHERE id_utente_tipo = '.num2str($id);
	return $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArraySesso() {
	return unserialize(aSESSO);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayTipiNumeroPratica() {
	return unserialize(aTIPO_NUMERO_PRATICA);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayContratto() {
	return unserialize(aCONTRATTO);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayPC() {
	return unserialize(aPC);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayTipoCliente() {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM clienti_tipo ORDER BY ordine');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoGeneri($id = NULL) {
	$sql = 'SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM spettacolo_generi';
	if (!is_null($id)) {
		if (is_numeric($id)) $sql .= ' WHERE id = '.num2Str($id);
		if (is_array($id)) $sql .= ' WHERE id IN ('.implode(',',$id).')';
	}
	$sql .= ' ORDER BY ordine';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoSupervisori() {
    $a = array();
    $oE = new elencosupervisore($this->oApp, TRUE);
    if (!$oE->isEmpty()) {
        foreach ($oE->getElenco() as $oS) {
            $a[] = array('id'=>$oS->getId(),'descrizione'=>$oS->getDenominazione());
        }
    }
    return $a;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoSupervisoriAttivi() {
    $a = array();
    $oE = new elencosupervisore($this->oApp);
    $oE->caricaSoloAttivi();
    if (!$oE->isEmpty()) {
        foreach ($oE->getElenco() as $oS) {
            $a[] = array('id'=>$oS->getId(),'descrizione'=>$oS->getDenominazione());
        }
    }
    return $a;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoSupervisoriAttiviNonSpeciali() {
    $a = array();
    $oE = new elencosupervisore($this->oApp);
    $oE->caricaSoloAttiviENonSpeciali();
    if (!$oE->isEmpty()) {
        foreach ($oE->getElenco() as $oS) {
            $a[] = array('id'=>$oS->getId(),'descrizione'=>$oS->getDenominazione());
        }
    }
    return $a;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoTipoDispositivo() {
    return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM supervisore_tipo_dispositivo ORDER BY ordine');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoDispositiviByIdSupervisore($id_supervisore, $tipo = false) {
    $a = array();
	$oE = new elencodispositivo($this->oApp, FALSE);

	if($tipo) { $oE->type = $tipo; }
	$oE->carica(true);

    if (!$oE->isEmpty()) {
        foreach ($oE->getElenco() as $oO) {
            if ($oO->get('id_supervisore') == $id_supervisore) $a[] = array('id'=>$oO->getId(),'descrizione'=>$oO->get('codice_dispositivo').' - '.$oO->get('descrizione'));
        }
    }
    return $a;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoSottoTipoDispositiviByIdTipoDispositivo($id_tipo_dispositivo) {
    $a = array();
	$oE = new elencosottotipodispositivo($this->oApp, TRUE);

    if (!$oE->isEmpty()) {
		foreach ($oE->getElenco() as $oO) {
			//echo ("[" . $oO->get('id_tipo_dispositivo') . "] [" . $id_tipo_dispositivo . "]\n");
            if ($oO->get('id_tipo_dispositivo') == $id_tipo_dispositivo) $a[] = array('id'=>$oO->getId(),'sotto_tipo_dispositivo'=>$oO->get('sotto_tipo_dispositivo'),'descrizione'=>$oO->get('sotto_tipo_dispositivo'));
        }
    }
    return $a;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoProvenienzaUtente() {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM utenti_provenienza ORDER BY ordine');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoProvenienzaUtenteById($id) {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM utenti_provenienza WHERE id='.num2Str($id).' ORDER BY ordine', CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoNazioni () {
	return $this->oDb->eseguiselect('SELECT id_nazione AS id, 
	                                        '.$_SESSION['LINGUA_NAVIGAZIONE'].' as descrizione 
	                                   FROM nazioni ORDER BY '.$_SESSION['LINGUA_NAVIGAZIONE']);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoNazioniById($id) {
	return $this->oDb->eseguiselect('SELECT '.$_SESSION['LINGUA_NAVIGAZIONE'].' as descrizione 
	                                   FROM nazioni WHERE id_nazione='.num2Str($id).' ORDER BY '.$_SESSION['LINGUA_NAVIGAZIONE'], CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayServiziSegnalanti() {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM casi_servizi_segnalanti ORDER BY ordine');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayIndiceOfferte() {
	return unserialize(aINDICE_OFFERTE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayVistaAgenda() {
	return unserialize(aVISTA_AGENDA);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayStatus() {
	return $this->oDb->eseguiselect('SELECT a.id_status AS id, descrizione 
	                                         FROM status AS a INNER JOIN status_oggetti_tipi AS b ON a.id_status = b.id_status 
	                                        WHERE b.id_oggetto_tipo = ' . num2Str($this->getIdTipoOggetto()));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayElencoEsiti() {
	$esiti = array();
	if (($this->classe == 'fase' && $this->tipologia != 'SELEZIONE') || $this->classe == 'candidatura') {
		$esiti[] = array('id'=>'nessuna','descrizione'=>'nessuna');
		$esiti[] = array('id'=>'non interessante','descrizione'=>'non interessante');
	}
	$esiti[] = array('id'=>'poco interessante','descrizione'=>'poco interessante');
	$esiti[] = array('id'=>'interessante','descrizione'=>'interessante');
	$esiti[] = array('id'=>'molto interessante','descrizione'=>'molto interessante');

	return $esiti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayElencoRisultati() {
	$esiti = array();
	$esiti[] = array('id'=>'positivo','descrizione'=>'positivo');
	$esiti[] = array('id'=>'negativo','descrizione'=>'negativo');

	return $esiti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayElencoApprovazione() {
	$esiti = array();
	$esiti[] = array('id'=>'approvato','descrizione'=>'approvato');
	$esiti[] = array('id'=>'respinto','descrizione'=>'respinto');

	return $esiti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getDataCreazione() {
	return ((empty($this->data_creazione))?date('Y-m-d H:i:s'):$this->data_creazione);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getDataCreazioneIta() {
	$d = new DateTime($this->data_creazione);
	return $d->format('d-m-Y H:i');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getDataUltimaModifica() {
	return date('Y-m-d H:i:s');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getDataUltimaModificaDb() {
	return $this->data_ultima_modifica;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getDataUltimaModificaIta() {
	$d = new DateTime($this->data_ultima_modifica);
	return $d->format('d-m-Y H:i');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getIdUtenteCreatore() {
	return ((empty($this->id_utente_creatore) && $this->oUtente !== FALSE)?$this->oUtente->getId():$this->id_utente_creatore);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getIdUtenteUltimaModifica() {
	return (($this->oUtente !== FALSE)?$this->oUtente->getId():0);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getOUtenteUltimaModifica() {
	return new utente($this->oApp, $this->id_utente_ultima_modifica);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getIdUtenteProprietario() {
	return ((empty($this->id_utente_proprietario))?(($this->oUtente !== FALSE)?$this->oUtente->getId():0):$this->id_utente_proprietario);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function getIdTipoOggetto() {
	if (empty($this->id_oggetto_tipo)) {
		$this->id_oggetto_tipo = $this->oDb->eseguiselect('SELECT id_oggetto_tipo FROM oggetti_tipi WHERE descrizione = '.stripcslashesandquote($this->classe), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
	}
	return $this->id_oggetto_tipo;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getNomeAttributoId() {
	if ($this->nome_attributo_id === FALSE) {
		$attributo = 'id_' . $this->classe;
		foreach ($this as $att => $valore) {
			if (substr($att, 0, 3) == 'id_') {
				$att_mom = str_replace('id_', '', $att);
				$att_mom = str_replace('_', '', $att_mom);
				$att_mom = 'id_' . $att_mom;
				if ($att_mom == $attributo) {
					$this->nome_attributo_id = $att;
					break;
				}
			}
		}
	}
	return $this->nome_attributo_id;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function clona($oggetto_sorgente){
	if ($this->classe === get_class($oggetto_sorgente)) {
		foreach($this as $name => $value){
			//try {
			$this->set($name, $oggetto_sorgente->get($name));
			//} catch (Exception $e) {
			//	die($name. ' '.$e);
			//}
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function getSqlCampiBase() {
	return 'data_creazione,data_ultima_modifica,id_utente_creatore,id_utente_ultima_modifica,id_status,id_utente_proprietario';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function getValoriCampiBase() {
	return stripcslashesandquote($this->data_creazione).','.
	       stripcslashesandquote($this->data_ultima_modifica).','.
	       num2Str($this->id_utente_creatore).','.
	       num2Str($this->id_utente_ultima_modifica).','.
	       num2Str($this->id_status).','.
	       num2Str((($this->oUtente !== FALSE)?$this->oUtente->getId():0));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function getUpdateCampiBase($elimina=FALSE) {
	if($elimina){
		return ' data_ultima_modifica = SYSDATE(),
				 id_utente_ultima_modifica = '.$this->oApp->getIdUtenteloggato();
	}
	else{
		$id = $this->oApp->getIdUtenteloggato();
		if (empty($id)) $id = $this->id_utente_creatore;

		return 'id_status = '.stripcslashesandquote($this->id_status).',
				data_ultima_modifica = SYSDATE(),
				id_utente_ultima_modifica = '.stripcslashesandquote($id).',
				id_utente_proprietario = '.stripcslashesandquote($id);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final protected function getInsertCampiBase() {
	 return 'id_status = '.stripcslashesandquote($this->id_status).',
			 data_creazione = '.stripcslashesandquote($this->data_creazione).',
			 id_utente_creatore = '.stripcslashesandquote($this->id_utente_creatore).',
             data_ultima_modifica = '.stripcslashesandquote($this->data_ultima_modifica).',
             id_utente_ultima_modifica = '.stripcslashesandquote((($this->oUtente !== FALSE)?$this->oUtente->getId():((empty($this->id_utente_ultima_modifica))?$this->id_utente_creatore:$this->id_utente_ultima_modifica))).',
             id_utente_proprietario = '.stripcslashesandquote((($this->oUtente !== FALSE)?$this->oUtente->getId():$this->id_utente_proprietario));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isValoreCampoPresenteDb($campo, $valore) {
	$sql = 'SELECT count(*) FROM '.$this->nome_tabella.' WHERE '.$this->getNomeAttributoId().'!='.$this->getId().' AND '.$campo.' = '.stripcslashesandquote($valore);

	//SE OGGETTO == OFFERTA, IL NR PRATICA DEVE ESSERE UNIVOCO ALL'INTERNO DELL'AGENZIA
	if ($this->classe == 'offerta' && $campo == 'numero_pratica') {
		$sql .= ' AND id_agenzia='.$this->oApp->getIdAgenziaUtenteloggato();
	}
	//SE OGGETTO == RICHIESTA, IL NR PRATICA DEVE ESSERE UNIVOCO ALL'INTERNO DELL'AGENZIA
	if ($this->classe == 'richiesta' && $campo == 'numero_pratica') {
		$sql .= ' AND id_agenzia='.$this->oApp->getIdAgenziaUtenteloggato();
	}
	return (bool)$this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoProvince () {
	return $this->oDb->eseguiselect('SELECT id_provincia AS id, 
	                                        desc_provincia as descrizione 
	                                   FROM province order by ordine, desc_provincia');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoProvinceById($id) {
	return $this->oDb->eseguiselect('SELECT desc_provincia as descrizione 
	                                   FROM province WHERE id_provincia='.num2Str($id), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoProvinceVisibili() {
	return $this->oDb->eseguiselect('SELECT id_provincia AS id, 
	                                        desc_provincia as descrizione 
	                                   FROM province WHERE visibile = 1 order by ordine, desc_provincia');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayComuniByIdProvincia($id_provincia) {
	return $this->oDb->eseguiselect('SELECT id_comune AS id, 
	                                        desc_comune as descrizione 
	                                   FROM comuni WHERE id_provincia = '.$id_provincia.' order by desc_comune');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayComuni() {
	return $this->oDb->eseguiselect('SELECT id_comune AS id, 
	                                        desc_comune as descrizione 
	                                   FROM comuni ORDER BY desc_comune');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayComuniById($id) {
	return $this->oDb->eseguiselect('SELECT desc_comune as descrizione 
	                                   FROM comuni WHERE id_comune='.num2Str($id), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayZoneByIdComune($id_comune) {
	return $this->oDb->eseguiselect('SELECT id_zona AS id, 
	                                        desc_zona as descrizione 
	                                   FROM zone WHERE id_comune = '.$id_comune.' order by desc_zona');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getComuneById($id_comune) {
	return $this->oDb->eseguiselect('SELECT desc_comune FROM comuni WHERE id_comune = '.$id_comune.' ORDER BY desc_comune', CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getProvinciaById($id_provincia) {
	return $this->oDb->eseguiselect('SELECT desc_provincia FROM province WHERE id_provincia = '.$id_provincia.' ORDER BY desc_provincia', CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoAgenzie() {

	$id_utente_tipo_loggato = $this->oApp->getIdUtenteTipoLoggato();
	if ($id_utente_tipo_loggato!=UTENTE_TIPO_ID_SEGRETERIA && $id_utente_tipo_loggato !=UTENTE_TIPO_ID_SUPERADMIN ){
		//$condizione = ' AND id_status = '.STATUS_ATTIVO.' AND id_agenzia='.num2str($this->oApp->getIdAgenziaUtenteLoggato());
		$condizione = ' AND id_status = '.STATUS_ATTIVO.' ';
	}
	else{
		$condizione = '';
	}
	$sql  = 'SELECT id_agenzia AS id, CONCAT(UCASE(ragione_sociale)," - ",descrizione) AS descrizione 
	           FROM agenzie 
			  WHERE id_status != '.STATUS_ELIMINATO.$condizione.' 
		   ORDER BY CONCAT(UCASE(ragione_sociale)," - ",descrizione)';

	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoAgenzieMezze() {

	$sql  = 'SELECT id_agenzia AS id, CONCAT(UCASE(ragione_sociale)," - ",descrizione) AS descrizione FROM agenzie WHERE id_status = '.STATUS_ATTIVO.' ORDER BY CONCAT(UCASE(ragione_sociale)," - ",descrizione)';

	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayGiorniVisite() {
	return unserialize(aGIORNI_VISITE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayOrariVisite() {
	return unserialize(aORARI_VISITE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getElencoUtentiByAgenzia() {
	$sql  = 'SELECT id_utente AS id, CONCAT(nome," ",cognome) AS descrizione 
	           FROM utenti 
			  WHERE id_status = '.STATUS_ATTIVO.' 
			    AND id_agenzia = '.num2str($this->oApp->getIdAgenziaUtenteLoggato()).'
           ORDER BY CONCAT(nome," ",cognome)';

    //echo $sql;
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getElencoUtentiOperatoriByAgenzia() {
	$sql  = 'SELECT id_utente AS id, CONCAT(nome," ",cognome) AS descrizione 
	           FROM utenti 
			  WHERE id_status = '.STATUS_ATTIVO.' 
			    AND id_agenzia = '.num2str($this->oApp->getIdAgenziaUtenteLoggato()).'
                AND id_utente_tipo IN ('.UTENTE_TIPO_ID_TITOLARE.','.UTENTE_TIPO_ID_FUNZIONARIO.')'.'
		   ORDER BY CONCAT(nome," ",cognome)';

    //echo $sql;
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getArrayElencoRegioni () {
	return $this->oDb->eseguiselect('SELECT id_regione AS id, 
	                                        desc_regione as descrizione 
	                                   FROM regioni ORDER BY desc_regione');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getCheckbox() {
	return '<input type="checkbox" name="oggetti_selezionati[]" class="seleziona_'.$this->classe.'" oggetto="'.$this->classe.'" id_oggetto_get_encoded="'.writeGetParam($this->getId()).'" id_oggetto_post_encoded="'.writePostParam($this->getId()).'">';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getRadio() {
	return '<input type="radio" name="oggetto_selezionato" class="seleziona_'.$this->classe.'" oggetto="'.$this->classe.'" id_oggetto_get_encoded="'.writeGetParam($this->getId()).'" id_oggetto_post_encoded="'.writePostParam($this->getId()).'">';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getElencoFormatiGiornale() {
	$sql  = 'SELECT id_formato AS id, formato AS descrizione FROM gi_formato ORDER BY formato';

	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function  getURLModifica() {
	$url = URL_BACKEND.$this->get('class_url');
	$classe = $this->get('classe');
	$id = $this->getId();

	return $url.'modifica.php?oggetto='.$classe.'&id_oggetto='.writeGetParam($id);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getLinkModifica() {
	return '<a href="'.$this->getURLModifica().'"><i class="cus-doc-page"></i></a>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function  getTestoLingua($lingua, $oOggettoDizionario) {
    verificaParametro(!(in_array($lingua, unserialize(LINGUE_ATTIVE))), __METHOD__.' la lingua sbagliata');
	verificaParametro( ( !is_object($oOggettoDizionario) || !is_subclass_of($oOggettoDizionario, 'dizionario') ), __METHOD__.' l\'oggetto è sbagliato');

	return $oOggettoDizionario->getValore($lingua);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getNominativoUtenteProprietario() {
	$oUtenteProprietario = new utente($this->oApp, $this->id_utente_proprietario);
	return $oUtenteProprietario->get('nome').' '.$oUtenteProprietario->get('cognome');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getUtenteProprietario() {
	return $this->getNominativoUtenteProprietario();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getOProprietario() {
	return new utente($this->oApp, $this->id_utente_proprietario);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isUtenteProprietarioOggetto() {
	if ($this->oUtente->isSuperAdmin() || $this->oUtente->isAdminCarrefour()) {
		return TRUE;
	} else {
		if (property_exists($this, 'id_utente_proprietario')) {
			return ($this->id_utente_proprietario == $this->oApp->getIdUtenteLoggato());
		} else {
			verificaParametro(FALSE, __METHOD__.' errore');
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isStessaAgenziaUtenteProprietario() {
	if ($this->oUtente->isSuperAdmin() || $this->oUtente->isAdminCarrefour()) {
		return TRUE;
	} else {
		if (property_exists($this, 'id_agenzia')) {
			return ($this->id_agenzia == $this->oApp->getIdAgenziaUtenteLoggato());
		} else {
			verificaParametro(FALSE, __METHOD__.' errore');
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function isLoad() {
	$id_oggetto = $this->getId();
	if (is_numeric($id_oggetto) && $id_oggetto > 0) {
		return TRUE;
	}
	else{
		return FALSE;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getNominativoUtenteCreatore() {
	$oUtenteCreazione = new utente($this->oApp, $this->id_utente_creatore);
	return $oUtenteCreazione->get('nome').' '.$oUtenteCreazione->get('cognome');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getNominativoUtenteUltimaModifica() {
	$oUtenteUltimaModifica = new utente($this->oApp, $this->id_utente_ultima_modifica);
	return $oUtenteUltimaModifica->get('nome').' '.$oUtenteUltimaModifica->get('cognome');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getImmobiliCategoria() {
	$sql = 'SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' as descrizione FROM immobili_categorie';
	if (!$this->oUtente->gestisceResidenziale()) $sql .= ' WHERE id != '.OFFERTE_CATEGORIA_RESIDENZIALE;
	if (!$this->oUtente->gestisceCommerciale()) $sql .= ' WHERE id != '.OFFERTE_CATEGORIA_COMMERCIALE;
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getImmobiliContratto() {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' as descrizione FROM immobili_contratto');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getImmobiliConsegna() {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' as descrizione FROM immobili_consegna');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getImmobiliClasseEnergetica() {
	return $this->oDb->eseguiselect('SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM immobili_classi_energetiche');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayMisuraEnergetica() {
	return unserialize(aMISURAENERGETICA);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayDurata() {
	return unserialize(aDURATA);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayVetrine() {
	return unserialize(aVETRINE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayIngressi() {
	return unserialize(aINGRESSI);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getZoneAgenzia() {
	$sql = 'SELECT a.id_zona AS id, 
	               desc_zona AS descrizione 
	          FROM agenzie_zone AS a 
	    INNER JOIN zone AS b ON a.id_zona = b.id_zona
	         WHERE a.id_agenzia = '.num2str($this->id_agenzia).'
			   AND a.id_status='.STATUS_ATTIVO;

	if ($this->classe == 'offerta' || $this->classe == 'annunciospeciale') {
		$sql .= ' AND principale = 1';
	}

	$sql .= ' ORDER BY desc_zona';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getComuniAgenzia() {
	$sql = 'SELECT DISTINCT c.id_comune AS id, 
	               desc_comune AS descrizione 
	          FROM agenzie_zone AS a 
	    INNER JOIN zone AS b ON a.id_zona = b.id_zona
	    INNER JOIN comuni AS c ON b.id_comune = c.id_comune
	         WHERE a.id_agenzia = '.num2str($this->id_agenzia);

	if ($this->classe == 'offerta' || $this->classe == 'annunciospeciale') {
		$sql .= ' AND principale = 1';
	}

	$sql .= ' ORDER BY desc_comune';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function createXml($profonditaAttuale, $profonditaMassima) {
	verificaParametro((empty($this->path_risorse_private_xml)), __METHOD__.' l\'oggetto deve avere un path per salvare gli xml');

	$stringaXml = '';
	$this->toXml($stringaXml, $profonditaAttuale, $profonditaMassima);

	if (!is_dir($this->path_risorse_private_xml)) creaCartella($this->path_risorse_private_xml);
	file_put_contents($this->path_risorse_private_xml.date('Y-m-d-H-i-s').'.xml', $stringaXml);
	//file_put_contents(DIR_WEB.'_eliminare/test.xml', $stringaXml);

}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haNote() {
	if ($this->oElencoNote == FALSE) $this->estraiNote();
	return (!$this->oElencoNote->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoNote() {
	if ($this->oElencoNote == FALSE) $this->estraiNote();
	return $this->oElencoNote;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiNote() {
	$this->oElencoNote = new elenconota($this->oApp, FALSE, ' ORDER BY data_creazione DESC');
	$this->oElencoNote->caricaPerOggetto($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eliminaNote() {
	if ($this->haNote()){
		$ret = $this->oElencoNote->eseguimetodo('elimina');
	}else{
		$ret = TRUE;
	}
   return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haDocumenti() {
	if ($this->oElencoDocumenti == FALSE) $this->estraiDocumenti();
	return (!$this->oElencoDocumenti->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoDocumenti() {
	if ($this->oElencoDocumenti == FALSE) $this->estraiDocumenti();
	return $this->oElencoDocumenti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiDocumenti() {
	$this->oElencoDocumenti = new elencodocumento($this->oApp, FALSE, ' ORDER BY data_creazione DESC');
	$this->oElencoDocumenti->caricaPerOggetto($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haAppuntamenti() {
	if ($this->oElencoAppuntamenti == FALSE) $this->estraiAppuntamenti();
	return (!$this->oElencoAppuntamenti->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoAppuntamenti() {
	if ($this->oElencoAppuntamenti == FALSE) $this->estraiAppuntamenti();
	return $this->oElencoAppuntamenti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiAppuntamenti() {
	$this->oElencoAppuntamenti = new elencoappuntamento($this->oApp, FALSE, ' ORDER BY data_creazione DESC');
	$this->oElencoAppuntamenti->caricaPerOggetto($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haEsperienzeLavorative() {
	if ($this->oElencoEsperienzeLavorative == FALSE) $this->estraiEsperienzeLavorative();
	return (!$this->oElencoEsperienzeLavorative->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoEsperienzeLavorative() {
	if ($this->oElencoEsperienzeLavorative == FALSE) $this->estraiEsperienzeLavorative();
	return $this->oElencoEsperienzeLavorative;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiEsperienzeLavorative() {
	$this->oElencoEsperienzeLavorative = new elencoesperienzalavorativa($this->oApp, FALSE, ' ORDER BY data_mese_dal DESC');
	$this->oElencoEsperienzeLavorative->caricaPerOggetto($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function haImmagini($tipo_immagini='') {
	if ($this->oElencoImmagini == FALSE) $this->estraiImmagini($tipo_immagini);
	return (!$this->oElencoImmagini->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final public function getElencoImmagini($tipo_immagini='', $orderBy = FALSE) {
	$this->estraiImmagini($tipo_immagini, $orderBy);
	return $this->oElencoImmagini;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final private function estraiImmagini($tipo_immagini='', $orderBy = FALSE) {
	$this->oElencoImmagini = new elencoimmagine($this->oApp, FALSE, $orderBy);
    switch ($tipo_immagini) {
		case 'private':
			$this->oElencoImmagini->caricaPerOggettoPrivate($this);
		break;

		case 'pubbliche':
			$this->oElencoImmagini->caricaPerOggettoPubbliche($this);
		break;

        case 'principale':
			$this->oElencoImmagini->caricaPerOggettoPrincipale($this);
		break;

		default:
			$this->oElencoImmagini->caricaPerOggetto($this);
		break;

	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haPianificazione() {
	if ($this->oElencoPianificazione == FALSE) $this->estraiPianificazione();
	return (!$this->oElencoPianificazione->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoPianificazione() {
	if ($this->oElencoPianificazione == FALSE) $this->estraiPianificazione();
	return $this->oElencoPianificazione;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiPianificazione() {
	$this->oElencoPianificazione = new elencopianificazione($this->oApp, FALSE, 'ORDER BY data_creazione DESC');
	$this->oElencoPianificazione->caricaPerOggetto($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haFeedback() {
	if ($this->oElencoFeedback == FALSE) $this->estraiFeedback();
	return (!$this->oElencoFeedback->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoFeedback() {
	if ($this->oElencoFeedback == FALSE) $this->estraiFeedback();
	return $this->oElencoFeedback;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiFeedback() {
	$this->oElencoFeedback = new elencofeedback($this->oApp, FALSE, 'ORDER BY data_creazione DESC');
	$this->oElencoFeedback->caricaPerOggetto($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOOggetto() {
	if (property_exists($this, 'oggetto')) {
		if (!empty($this->oggetto)) {
			return new $this->oggetto($this->oApp, $this->id_oggetto);
		}
		return FALSE;
	} else {
		die(__CLASS__.'->'.__METHOD__.': non pu?sere usato');
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
final function getArraySiNo() {
	return array(array('id'=>1,'descrizione'=>'si'),array('id'=>0,'descrizione'=>'no'));
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTipologiaFase() {
	if (property_exists($this, 'oggetto') && $this->oggetto == 'fase') {
		if ($this->oApp->is(UTENTE_TIPO_ID_UTENTE)) {
			return $this->getOOggetto()->get('tipologia__candidato');
		} else {
			return $this->getOOggetto()->get('tipologia_utente_interno');
		}
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function sendSignal($metodo) {
    $this->oDb->eseguiinsert('INSERT INTO sendsignal SET istruzione='.stripcslashesandquote($metodo));
    //exec();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function serverRicaricaRegole() {
	$cmd = DIR_WEB.'runasroot '.DIR_WEB.'scripts/yassReloadRelayRules.sh';
    shell_exec($cmd);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function serverRiavvia() {
	
	$cmd = DIR_WEB.'runasroot '.DIR_WEB.'scripts/yassRestartservice.sh';
    shell_exec($cmd);
	if (file_exists(FILE_DASHBOARD_CACHE)) unlink(FILE_DASHBOARD_CACHE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function clientRiavvia() {
	$_SESSION['strColonnaDx'] = '';
	$_SESSION['strColonnaSx'] = '';
	$_SESSION['strJavascript'] = '';
	
    shell_exec(DIR_WEB.'runasroot reboot');
    if (file_exists(FILE_DASHBOARD_CACHE)) unlink(FILE_DASHBOARD_CACHE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayDow() {
	$dowArray = array();

	switch($_SESSION['LINGUA_NAVIGAZIONE'])
	{
		case "en_UK":
			array_push($dowArray, array("id"=>"*", "descrizione" => "Everyday"));
			array_push($dowArray, array("id"=>"1", "descrizione" => "Monday"));
			array_push($dowArray, array("id"=>"2", "descrizione" => "Tuesday"));
			array_push($dowArray, array("id"=>"3", "descrizione" => "Wednesday"));
			array_push($dowArray, array("id"=>"4", "descrizione" => "Thursday"));
			array_push($dowArray, array("id"=>"5", "descrizione" => "Friday"));
			array_push($dowArray, array("id"=>"6", "descrizione" => "Saturday"));
			array_push($dowArray, array("id"=>"7", "descrizione" => "Sunday"));
			break;
		
		default:
		case "it_IT":
			array_push($dowArray, array("id"=>"*", "descrizione" => "Tutti i giorni"));
			array_push($dowArray, array("id"=>"1", "descrizione" => "Luned&igrave;"));
			array_push($dowArray, array("id"=>"2", "descrizione" => "Marted&igrave;"));
			array_push($dowArray, array("id"=>"3", "descrizione" => "Mercoled&igrave;"));
			array_push($dowArray, array("id"=>"4", "descrizione" => "Gioved&igrave;"));
			array_push($dowArray, array("id"=>"5", "descrizione" => "Venerd&igrave;"));
			array_push($dowArray, array("id"=>"6", "descrizione" => "Sabato"));
			array_push($dowArray, array("id"=>"7", "descrizione" => "Domenica"));
			break;

	}

	return $dowArray;
}

/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayDom() {
	$domArray = array();


	switch($_SESSION['LINGUA_NAVIGAZIONE'])
	{
		case "en_UK":
			array_push($domArray, array("id"=>"**", "descrizione" => "Everyday"));
			break;
			
		default:
		case "it_IT":
			array_push($domArray, array("id"=>"**", "descrizione" => "Tutti i giorni"));
			break;
	}

	for ($i = 0; $i < 31; $i++) {
		array_push($domArray, array("id"=> str_pad($i+1, 2, '0', STR_PAD_LEFT), "descrizione" => str_pad($i+1, 2, '0', STR_PAD_LEFT)));
	}

	return $domArray;
}

/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayMonth() {
	$monthArray = array();

	switch($_SESSION['LINGUA_NAVIGAZIONE'])
	{
		case "en_UK":
			array_push($monthArray, array("id"=>"**", "descrizione" => "Every month"));
			array_push($monthArray, array("id"=>"01", "descrizione" => "January"));
			array_push($monthArray, array("id"=>"02", "descrizione" => "February"));
			array_push($monthArray, array("id"=>"03", "descrizione" => "March"));
			array_push($monthArray, array("id"=>"04", "descrizione" => "April"));
			array_push($monthArray, array("id"=>"05", "descrizione" => "May"));
			array_push($monthArray, array("id"=>"06", "descrizione" => "June"));
			array_push($monthArray, array("id"=>"07", "descrizione" => "July"));
			array_push($monthArray, array("id"=>"08", "descrizione" => "August"));
			array_push($monthArray, array("id"=>"09", "descrizione" => "September"));
			array_push($monthArray, array("id"=>"10", "descrizione" => "October"));
			array_push($monthArray, array("id"=>"11", "descrizione" => "November"));
			array_push($monthArray, array("id"=>"12", "descrizione" => "December"));
			break;
		
		default:
		case "it_IT":
			array_push($monthArray, array("id"=>"**", "descrizione" => "Tutti i mesi"));
			array_push($monthArray, array("id"=>"01", "descrizione" => "Gennaio"));
			array_push($monthArray, array("id"=>"02", "descrizione" => "Febbraio"));
			array_push($monthArray, array("id"=>"03", "descrizione" => "Marzo"));
			array_push($monthArray, array("id"=>"04", "descrizione" => "Aprile"));
			array_push($monthArray, array("id"=>"05", "descrizione" => "Maggio"));
			array_push($monthArray, array("id"=>"06", "descrizione" => "Giugno"));
			array_push($monthArray, array("id"=>"07", "descrizione" => "Luglio"));
			array_push($monthArray, array("id"=>"08", "descrizione" => "Agosto"));
			array_push($monthArray, array("id"=>"09", "descrizione" => "Settembre"));
			array_push($monthArray, array("id"=>"10", "descrizione" => "Ottobre"));
			array_push($monthArray, array("id"=>"11", "descrizione" => "Novembre"));
			array_push($monthArray, array("id"=>"12", "descrizione" => "Dicembre"));
			break;

	}

	return $monthArray;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>