<?php

class recordsobj {

	private $dataset = false;
	private $subsetDataset = false;
	private $subset = false;
	private $curSubset = false;
	private $idx = 0;
	private $cycleCount = 0;

	public function __construct($dataset, $subset = false) {
		$this->cycleCount = 0;
		$this->first();
		if($subset && is_array($subset)) {
			$this->subset = true;

			foreach($dataset as $row) {
				$subsetStr = "";
				foreach($subset as $subsetField) {
					$subsetStr .= "[" . $row[$subsetField] . "]";
				}
				$this->subsetDataset[$subsetStr][] = $row;
			}
		} else {
			$this->dataset = $dataset;
		}
	}

	public function getDataset() {
		return ($this->dataset);
	}

	public function rowcount() {
		return count($this->dataset);
	}

	public function setSub($subset) {
		$this->curSubset = "";
		foreach($subset as $subsetField) {
			$this->curSubset .= "[" . $subsetField . "]";
		}
		$this->dataset = @$this->subsetDataset[$this->curSubset];
	}

	public function get($field) {
		return @$this->dataset[$this->idx][$field];
	}

	public function is($filters, $idx = false) {
		
		$matches = 0;
		if($idx === false) $idx = $this->idx;

		foreach($filters as $filter) {
			$field = $filter[0];
			$value = $filter[1];
			$mode = @$filter[2] ? $filter[2] : 'et';

			$curValue = @$this->dataset[$idx][$field] ? $this->dataset[$idx][$field] : false;
			if(!$curValue) return false;
			if(!$value) return false;
	
			switch ($mode) {
				case 'et':
					if($curValue == $value) { $matches ++; } ; break;
				case 'cnt':
					if(strpos($curValue, $value) !== false) { $matches ++; } ; break;
				case 'sw':
					if(strpos($curValue, $value) === 0) { $matches ++; } ; break;
				case 'ew':
					if(strpos($curValue, $value) === strlen($curValue) - strlen($value)) { $matches ++; } ; break; 
			}
		}

		return $matches == count($filters);

	}

	public function has($filters) {
		if(is_array($this->dataset)) {
			foreach($this->dataset as $idx => $row) {
				$this->cycleCount ++;
				if($this->is($filters, $idx)) {
					return true;
				}
			}
		}
		return false;
	}

	public function count($filters) {
		$result = 0;
		foreach(@$this->dataset as $idx => $row) {
			$this->cycleCount ++;
			if($this->is($filters, $idx)) {
				$result ++;
			}
		}
		return $result;
	}

	public function __get($key) {
		$this->get($key);
	}

	public function first() {
		$this->idx = 0;
		return true;
	}

	public function getIdx() {
		return $this->idx;
	}

	public function next() {
		$this->cycleCount ++;
		$this->idx ++;

		if ($this->idx >= count($this->dataset)) {
			$this->idx = count($this->dataset) - 1;
			return false;
		}
		return true;
	}

	public function getCycles() {
		return $this->cycleCount;
	}
}

?>