<?php
class relay extends oggetto {

	protected $id_relay;
    protected $id_supervisore_origine;
    protected $id_dispositivo_origine;
    protected $id_sotto_tipo_dispositivo_origine;
    protected $id_supervisore_destinazione;
    protected $id_dispositivo_destinazione;
    protected $id_sotto_tipo_dispositivo_destinazione;
    protected $ip_supervisore_origine;
    protected $ip_supervisore_destinazione;
    protected $codice_dispositivo_origine;
    protected $codice_dispositivo_destinazione;
    protected $evento_origine;
    protected $comando_destinazione;

    protected $oSupervisoreOrigine;                 // oggetto di tipo SUPERVISORE
    protected $oDispositivoOrigine;                 // oggetto di tipo DISPOSITIVO
    protected $oSottoTipoDispositivoOrigine;        // oggetto di tipo SOTTOTIPODISPOSITIVO
    protected $oSupervisoreDestinazione;            // oggetto di tipo SUPERVISORE
    protected $oDispositivoDestinazione;                 // oggetto di tipo DISPOSITIVO
    protected $oSottoTipoDispositivoDestinazione;   // oggetto di tipo SOTTOTIPODISPOSITIVO

    protected $time_from;
    protected $time_to;
    protected $time_dow;
    protected $time_dom;
    protected $time_month;
    protected $time_mode;

	protected $class_action_url = 'relay/azioni/';
	protected $class_url = 'relay/';
	protected $nome_tabella = 'relay';
	protected $classe = 'relay';

    protected $colonneForm = array('RELAY_ABBINAMENTO'=>2);

/*********************************************************************************************************/
/*********************************************************************************************************/
public function initByRecord($rec) {
    parent::initByRecord($rec);

    if (!empty($this->id_supervisore_origine)) $this->oSupervisoreOrigine = new supervisore($this->oApp, $this->id_supervisore_origine);
    if (!empty($this->id_dispositivo_origine)) $this->oDispositivoOrigine = new dispositivo($this->oApp, $this->id_dispositivo_origine);
    if (!empty($this->id_sotto_tipo_dispositivo_origine)) $this->oSottoTipoDispositivoOrigine = new sottotipodispositivo($this->oApp, $this->id_sotto_tipo_dispositivo_origine);

    if (!empty($this->id_supervisore_destinazione)) $this->oSupervisoreDestinazione = new supervisore($this->oApp, $this->id_supervisore_destinazione);
    if (!empty($this->id_dispositivo_destinazione)) $this->oDispositivoDestinazione = new dispositivo($this->oApp, $this->id_dispositivo_destinazione);
    if (!empty($this->id_sotto_tipo_dispositivo_destinazione)) $this->oSottoTipoDispositivoDestinazione = new sottotipodispositivo($this->oApp, $this->id_sotto_tipo_dispositivo_destinazione);
}
/*********************************************************************************************************/
public function inserisci() {
	$this->oDb->disattivaAutocommit();
	$this->oDb->iniziaTransazione();

	$this->id_status = STATUS_ATTIVO;

	$sql = 'INSERT INTO relay SET '.$this->getCampiQuery('inserisci').$this->getInsertCampiBase(TRUE);
	$ret = $this->oDb->eseguiinsert($sql);
	if ($ret) {
		$this->id_relay = $this->oDb->dammiultimoidinserito();

		//$this->sendSignal(__METHOD__);
        $this->serverRicaricaRegole();
		$this->oDb->confermaTransazione();
        $this->oDb->attivaAutocommit();
        
		return TRUE;
	}
	$this->oDb->annullaTransazione();
	$this->oDb->attivaAutocommit();
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
	$this->oDb->disattivaAutocommit();
	$this->oDb->iniziaTransazione();

	$sql = 'UPDATE relay SET '.$this->getCampiQuery('modifica').$this->getUpdateCampiBase().' WHERE id_relay = ' . num2Str($this->getId());
	$ret = $this->oDb->eseguiupdate($sql);
	if ($ret) {
        //$this->sendSignal(__METHOD__);
        $this->serverRicaricaRegole();
        $this->oDb->confermaTransazione();
        
		return TRUE;
	}
	$this->oDb->annullaTransazione();
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function elimina() {
    $r = parent::elimina();
    if ($r == TRUE) {
        
    } $this->serverRicaricaRegole();
    return $r;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function getCampiQuery($mode) {
	$aV = array();
	 
	$aV[] = 'id_supervisore_origine= '.num2str($this->id_supervisore_origine);
	$aV[] = 'id_supervisore_destinazione= '.num2str($this->id_supervisore_destinazione);
	$aV[] = 'id_dispositivo_origine= '.num2str($this->id_dispositivo_origine);
	$aV[] = 'id_dispositivo_destinazione= '.num2str($this->id_dispositivo_destinazione);
    $aV[] = 'id_sotto_tipo_dispositivo_origine= '.num2str($this->id_sotto_tipo_dispositivo_origine);
    $aV[] = 'id_sotto_tipo_dispositivo_destinazione= '.num2str($this->id_sotto_tipo_dispositivo_destinazione);
	$aV[] = 'ip_supervisore_origine= '.stripcslashesandquote($this->getOSupervisoreOrigine()->get('ip'));
	$aV[] = 'ip_supervisore_destinazione= '.stripcslashesandquote($this->getOSupervisoreDestinazione()->get('ip'));
	$aV[] = 'codice_dispositivo_origine= '.stripcslashesandquote($this->getODispositivoOrigine()->get('codice_dispositivo'));
	$aV[] = 'codice_dispositivo_destinazione= '.stripcslashesandquote($this->getODispositivoDestinazione()->get('codice_dispositivo'));
    $aV[] = 'codice_sotto_tipo_origine= '.stripcslashesandquote($this->getOSottoTipoDispositivoOrigine()->get('codice_sotto_tipo_dispositivo'));
    $aV[] = 'codice_sotto_tipo_destinazione= '.stripcslashesandquote($this->getOSottoTipoDispositivoDestinazione()->get('codice_sotto_tipo_dispositivo'));
	$aV[] = 'evento_origine= '.stripcslashesandquote($this->evento_origine);
	$aV[] = 'comando_destinazione= '.stripcslashesandquote($this->comando_destinazione);
    if (strlen($this->time_from) == 5) {
        $hh = substr($this->time_from, 0, 2);
        $mm = substr($this->time_from, 3);
        $sec = intval($hh) * 3600 + intval($mm) * 60;
        $aV[] = 'time_from= '.num2str($sec);
    } else {
        $aV[] = 'time_from= '.num2str(-1);
    }
    if (strlen($this->time_to) == 5) {
        $hh = substr($this->time_to, 0, 2);
        $mm = substr($this->time_to, 3);
        if($this->time_to == "23:59")
        {
            $sec = 86399;
        }
        else
        {
            $sec = intval($hh) * 3600 + intval($mm) * 60;
        }
        $aV[] = 'time_to= '.num2str($sec);
    } else {
        $aV[] = 'time_to= '.num2str(-1);
    }
    $aV[] = 'time_mode= '.stripcslashesandquote('DoW<' . $this->time_dow . '> MON<' . $this->time_month . '> DoM<' . $this->time_dom . '>');

	return implode(',', $aV).',';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElimina($visualizza_etichetta=TRUE) {
	if (!$this->checkElementiCollegati()){
		return 	parent::getElimina($visualizza_etichetta);
	} else {
		return $this->oApp->getMsgInfo('OPERAZIONE_NON_CONSENTITA');
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function checkElementiCollegati() {
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOSupervisoreOrigine() {
    return $this->oSupervisoreOrigine;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getODispositivoOrigine() {
    return $this->oDispositivoOrigine;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOSottoTipoDispositivoOrigine() {
    return $this->oSottoTipoDispositivoOrigine;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOSupervisoreDestinazione() {
    return $this->oSupervisoreDestinazione;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getODispositivoDestinazione() {
    return $this->oDispositivoDestinazione;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOSottoTipoDispositivoDestinazione() {
    return $this->oSottoTipoDispositivoDestinazione;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function encodaEventoOrigineBySottoTipoDispositivo($oSottoTipoDispositivo) {
    switch ($oSottoTipoDispositivo->get('tipo_messaggio')) {
        case 'analogico':
            $s = $oSottoTipoDispositivo->get('slider_origine');
            $s = str_replace(' ','', $s);
            break;
        case 'digitale':
            $s = $oSottoTipoDispositivo->get('digitale_origine');
            break;
        case 'discreto':
            $s = $oSottoTipoDispositivo->get('valore_discreto_origine');
            break;
    }
    return $s;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function encodaComandoDestinazioneBySottoTipoDispositivo($oSottoTipoDispositivo) {
    switch ($oSottoTipoDispositivo->get('tipo_messaggio')) {
        case 'analogico':
            $s = $oSottoTipoDispositivo->get('slider_destinazione');
            $s = str_replace(' ','', $s);
            $negazione = $oSottoTipoDispositivo->get('negazione_destinazione');
            if (!empty($negazione)) $s = '!'.$s;
            break;
        case 'digitale':
            $s = $oSottoTipoDispositivo->get('digitale_destinazione');
            break;
        case 'discreto':
            $s = $oSottoTipoDispositivo->get('valore_discreto_destinazione');
            break;
    }
    return $s;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function decodaEventoOrigineInSottoTipoDispositivo(&$oSottoTipoDispositivo) {
    switch ($oSottoTipoDispositivo->get('tipo_messaggio')) {
        case 'analogico':
            $a = explode('-',$this->evento_origine);
            $oSottoTipoDispositivo->set('min_impostato_origine', $a[0]);
            $oSottoTipoDispositivo->set('max_impostato_origine', $a[1]);
            break;
        case 'digitale':
            $oSottoTipoDispositivo->set('digitale_origine', $this->evento_origine);
            break;
        case 'discreto':
            $oSottoTipoDispositivo->set('valore_discreto_origine', $this->evento_origine);
            break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function decodaComandoDestinazioneInSottoTipoDispositivo(&$oSottoTipoDispositivo) {
    switch ($oSottoTipoDispositivo->get('tipo_messaggio')) {
        case 'analogico':
            $a = explode('-',str_replace('!','',$this->comando_destinazione));
            $oSottoTipoDispositivo->set('min_impostato_destinazione', $a[0]);
            $oSottoTipoDispositivo->set('max_impostato_destinazione', $a[1]);
            if (stripos($this->comando_destinazione, '!') !== FALSE)  $oSottoTipoDispositivo->set('negazione_destinazione', 1);
            break;
        case 'digitale':
            $oSottoTipoDispositivo->set('digitale_destinazione', $this->comando_destinazione);
            break;
        case 'discreto':
            $oSottoTipoDispositivo->set('valore_discreto_destinazione', $this->comando_destinazione);
            break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAzioni($esploso = FALSE) {
    return $this->getModifica().BR.$this->getAttivaSospendi().BR.$this->getElimina();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAttivaSospendi() {
    if ($this->id_status == STATUS_ATTIVO) {
        $id = 'BOTTONE_'.$this->classe.'_SOSPENDI';
        return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
    }
    if ($this->id_status == STATUS_SOSPESO) {
        $id = 'BOTTONE_'.$this->classe.'_ATTIVA';
        return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function attiva() {
    $this->id_status = STATUS_ATTIVO;
    return $this->modifica();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function sospendi() {
    $this->id_status = STATUS_SOSPESO;
    return $this->modifica();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormAbbinamento() {
    $this->getForm('RELAY_ABBINAMENTO', 'Inserisci', URL_BACKEND.$this->class_action_url.'abbinamento.php', 'standard');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>