<?php
class sottotipodispositivo extends oggetto {

    protected $id_sotto_tipo_dispositivo;
    protected $id_tipo_dispositivo;
    protected $ordine;
    protected $sotto_tipo_dispositivo;
    protected $codice_sotto_tipo_dispositivo;
    protected $tipo_messaggio;
    protected $is_allarme;
    protected $accetta_origine;
    protected $accetta_destinazione;
    protected $min;
    protected $max;
    protected $step;
    protected $asterisco;
    protected $negazione;
    protected $posizione_dato; //mi dice se è in origine o in destinazione

    // campi per inserimento/modifica relay
    protected $slider_origine;
    protected $slider_destinazione;
    protected $valore_discreto_origine;
    protected $valore_discreto_destinazione;
    protected $digitale_origine;
    protected $digitale_destinazione;
    protected $negazione_destinazione;
    protected $min_impostato_origine;
    protected $max_impostato_origine;
    protected $min_impostato_destinazione;
    protected $max_impostato_destinazione;

    protected $class_action_url = '---';
	protected $class_url = '---';
	protected $nome_tabella = 'dispositivo_sotto_tipo_dispositivo';
	protected $classe = 'dispositivo_sotto_tipo_dispositivo';

/*********************************************************************************************************/
public function inserisci() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
    TO_NOT_IMPLEMENT(__METHOD__);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDenominazioneTabella() {
    return $this->sotto_tipo_dispositivo.BR.'<small>('.$this->tipo_messaggio.')</small>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormSottoTipoDispositivoOrigine() {
    if ($this->accetta_origine && $this->posizione_dato == 'origine') {
        $this->getForm('SOTTO_TIPO_DISPOSITIVO_ORIGINE', 'Inserisci', NULL, 'standard', FALSE, FALSE, FALSE, TRUE, NULL, FALSE, FALSE);
    } else {
        echo '<span class="badge badge-warning">'.$this->oApp->getEtichetta('SOTTO_TIPO_NON_ACCETTA_ORIGINE').'</span>';
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormSottoTipoDispositivoDestinazione() {
    if ($this->accetta_destinazione && $this->posizione_dato == 'destinazione') {
        $this->getForm('SOTTO_TIPO_DISPOSITIVO_DESTINAZIONE', 'Inserisci', NULL, 'standard', FALSE, FALSE, FALSE, TRUE, NULL, FALSE, FALSE);
    } else {
        echo '<span class="badge badge-warning">'.$this->oApp->getEtichetta('SOTTO_TIPO_NON_ACCETTA_DESTINAZIONE').'</span>';
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function isCampoFormDaAggiungere(&$aCampo, $nome_form, $mode) {
    $nome_campo = $aCampo['nome_campo'];

    if ($nome_campo == 'asterisco' && !$this->asterisco) return false;
    if (stripos($nome_campo, 'negazione') !== FALSE && (!$this->negazione || $this->posizione_dato == 'origine' || $this->tipo_messaggio=='digitale')) return false;

    switch ($this->tipo_messaggio) {
        case 'analogico':
            if (stripos($nome_campo, 'digitale') !== FALSE) return false;
            if (stripos($nome_campo, 'valore_discreto') !== FALSE) return false;
            break;

        case 'digitale':
            if (stripos($nome_campo, 'slider') !== FALSE) return false;
            if (stripos($nome_campo, 'valore_discreto') !== FALSE) return false;
            break;

        case 'discreto':
            if (stripos($nome_campo, 'slider') !== FALSE) return false;
            if (stripos($nome_campo, 'digitale') !== FALSE) return false;
            break;
    }

    return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayValoriDiscretiByIdSottoTipoDispositivo() {
    $sql = 'SELECT id, '.$_SESSION['LINGUA_NAVIGAZIONE'].' AS descrizione FROM dispositivo_valori_discreti WHERE id_sotto_tipo_dispositivo = '.num2Str($this->id_sotto_tipo_dispositivo);
    return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getArrayAccesoSpento() {
    $esiti = array();
    if ($this->asterisco) $esiti[] = array('id'=>'*','descrizione'=>$this->oApp->getEtichetta('SELECT_VALORE_ASTERISCO'));
    $esiti[] = array('id'=>'1','descrizione'=>$this->oApp->getEtichetta('SELECT_VALORE_ACCESO'));
    $esiti[] = array('id'=>'0','descrizione'=>$this->oApp->getEtichetta('SELECT_VALORE_SPENTO'));
    if ($this->tipo_messaggio == 'digitale' && $this->negazione && $this->posizione_dato == 'destinazione') $esiti[] = array('id'=>'!','descrizione'=>$this->oApp->getEtichetta('SELECT_VALORE_NEGAZIONE'));
    return $esiti;

}
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>