<?php
DEFINE('TIPI_STAMPA', serialize(array('elenco',
                                      'tabella',
                                      'checkbox',
                                      'radio',
                                      'select',
                                      'select_id',
									  'select_id_no_fieldset',
									  'checkbox_no_fieldset',
									  'autocomplete',
									  'menu',
									  'JSON',
									  'checkbox_no_fieldset_2_colonne',
									  'PDF',
									  'checkbox_no_fieldset_inline',
									  'checkbox_text_no_fieldset',
									  'galleria_immagini_backend',
                                      'box_abbinamento_reparti'
)));

class stampaelenco {
	private $tipo;
  	private $elenco;
	
	private $style;
	private $oApp;
  
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __construct($oApp, $tipo, $elencoOggetti) {
	instance_of($oApp, 'app');

	if (!in_array($tipo, unserialize(TIPI_STAMPA))) {
		echo 'Attenzione: hai scelto un tipo di stampa non previsto.<br />I tipi disponibili sono:<br />';
		foreach (unserialize(TIPI_STAMPA) as $tipo) {
			echo $tipo .'<br />';
		}
		die;
		
	}
	
	$this->tipo   = $tipo;
	$this->elenco = $elencoOggetti;
	$this->oApp = $oApp;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function stampa($array_confronto) {
    $this->apriElenco();
	
	if (method_exists($this->elenco,'getElenco')) {
	  	$cI = $this->elenco->getCampiInteresse();
	  	$nomeElenco = $this->elenco->getNomeElenco();
	  	
		$elenco = $this->elenco->getElenco();
		  
	  	if (!empty($elenco)) {
			$primoOggetto = TRUE;
		  	foreach ($elenco as $i => $e) {
	        	$sO = new stampaoggetto($this->tipo, $e);
				$sO->setStyle($this->style);				
				$sO->setNomeElencoPadre($nomeElenco);
		    	$sO->stampa($cI, $array_confronto, $primoOggetto, $i);
				$primoOggetto = FALSE;
		  	}
	  	} else {
	  		// TODO: cambiare il messaggio di feedback
	  		if (!$this->tipo == 'autocomplete') {
	  			echo 'NESSUN ELEMENTO DISPONIBILE';
	  		}
	  	}
	}
    $this->chiudiElenco();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function stampaPDF() {
	$aImpostazioni = $this->elenco->getImpostazioniPDF();
	
	verificaParametro(!(array_key_exists('orientamento', $aImpostazioni) && ($aImpostazioni['orientamento'] == 'L' || $aImpostazioni['orientamento'] == 'P')), __METHOD__.' l\'array delle impostazioni deve contenere il valore ORIENTAMENTO');
	verificaParametro(!(array_key_exists('formato', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore FORMATO');
	verificaParametro(!(array_key_exists('margini_laterali', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore MARGINI_LATERALI');
	verificaParametro(!(array_key_exists('margini_sottosopra', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore MARGINI_SOTTOSOPRA');
	verificaParametro(!(array_key_exists('altezza_header', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore ALTEZZA_HEADER');
	verificaParametro(!(array_key_exists('altezza_footer', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore ALTEZZA_FOOTER');
	verificaParametro(!(array_key_exists('colonne', $aImpostazioni) && is_array($aImpostazioni['colonne']) ), __METHOD__.' l\'array delle impostazioni deve contenere il valore COLONNE');
	verificaParametro(!(array_key_exists('template', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore TEMPLATE');
	verificaParametro(!(method_exists('templatepdf', $aImpostazioni['template'])), __METHOD__.' il template selezionato [<em>'.$aImpostazioni['template'].	'</	em>] non esiste');
	verificaParametro(!(array_key_exists('agenzia', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore AGENZIA');
	verificaParametro(!(array_key_exists('stampa_elenco', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore STAMPA ELENCO');
	verificaParametro(!(array_key_exists('nome_file', $aImpostazioni)), __METHOD__.' l\'array delle impostazioni deve contenere il valore NOME FILE');
	
	foreach($aImpostazioni AS $k=>$v) {
		if (is_array($v)) $v = serialize($v); 
		define(strtoupper('PDF_'.$k), $v);
	}
	
	// A5 => 148mm x 210mm
	// A4 => 210mm x 297mm
	// A3 => 297mm x 420mm 	
	$oFpdf = new tFPDf(PDF_ORIENTAMENTO, 'mm', PDF_FORMATO);
	$oFpdf->Open();
	$oFpdf->SetAutoPageBreak(true, PDF_MARGINI_SOTTOSOPRA+PDF_ALTEZZA_FOOTER);
	$oFpdf->AliasNbPages();
	$oFpdf->SetMargins(PDF_MARGINI_LATERALI, PDF_MARGINI_SOTTOSOPRA, PDF_MARGINI_LATERALI);
	
	$oFpdf->AddFont('arial',   '',     'arial.ttf',       true);
	$oFpdf->AddFont('arial',   'B',    'arialbd.ttf',  true);
	$oFpdf->AddFont('arial',   'I',   'arialbi.ttf', true);
	$oFpdf->AddFont('arial',   'BI',   'ariali.ttf', true);
	
	// controllo che la somma delle colonne sia minore o uguale della dimensione del foglio meno i due margini laterali.
	verificaParametro(( (array_sum(unserialize(PDF_COLONNE))+2*PDF_MARGINI_LATERALI) > $oFpdf->w), __METHOD__.' la somma delle COLONNE è più grande dello spazio a disposizione');
	
	if (!$this->elenco->isEmpty()) {

		if($aImpostazioni['stampa_elenco'] === TRUE){
			
			$oElenco = $this->elenco;
			
			$oFpdf->AddPage();
			
			new templatepdf($oFpdf, $oElenco, PDF_TEMPLATE);
			
		}else{
		
			foreach ($this->elenco->getElenco() as $oOggetto) {
				
					$oFpdf->AddPage();
		
					new templatepdf($oFpdf, $oOggetto, PDF_TEMPLATE);
			}
			
		}
	}
	
	$oFpdf->Output($aImpostazioni['nome_file'], 'I');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function apriElenco() {
	 switch ($this->tipo) {
		case 'JSON':
				echo '[';
			break;
	  	case 'elenco':
	  	case 'menu':
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<div class="descrizione_elenco">'.$desc.'</div>';
	    	echo '<ul>';
	    	break;
		
	  	case 'tabella':
	  		$nomeElenco = $this->elenco->getNomeElenco();
	  		$elenchi_checkbox_all = array('elenco_offerte' , 'elenco_richieste');
			$cI = $this->elenco->getCampiInteresse();
			if ($this->style == STYLE_TABLE_STRIPED) {
	  			echo '<table cellpadding="0" cellspacing="0" id="'.$nomeElenco.'" class="'.((!empty($this->style))?' '.$this->style:'').((in_array('checkbox', $cI) || in_array('radio', $cI))?' checked-in has-checkbox':'').'">';
			} else {
	  			echo '<table cellpadding="0" cellspacing="0" id="'.$nomeElenco.'" class="table table-striped responsive table-hover'.((!empty($this->style))?' '.$this->style:'').((in_array('checkbox', $cI) || in_array('radio', $cI))?' checked-in has-checkbox':'').'">';
			}
//	  		echo '<table id="tabella_'.$this->elenco->getNomeElenco().'" class="table table-striped table-bordered responsive dataTable" aria-describedby="dtable_info">';
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<caption class="descrizione_elenco">'.$desc.'</caption>';
		    echo '<thead>';
		    echo '<tr>';
			
	        foreach($cI as $c) {
				if (!in_array($c, unserialize(DATATABLE_CAMPI_CENTRALI))) {		
					echo '<th class="' . $c .'">';
					echo $this->oApp->getEtichettaTabella($c);
					echo '</th>';
				} else {
					echo '<th class="' . $c .' no_sortable">';
						if($c == 'checkbox' && (in_array($nomeElenco, $elenchi_checkbox_all)) ){
							echo '<input type="checkbox" id="selezionatutti" name="selezionatutti" />';
						}
						else{
							echo '&nbsp;';
						}
					echo '</th>';
				}
			}
		    echo '</tr>';
			if (!empty($this->style) && $this->style == STYLE_DATATABLE_FILTRO_COLONNE) {
				echo '<tr class="second">';
				foreach($cI as $c) {
					echo '<td class="' . $c .'">';
					if (!in_array($c, unserialize(DATATABLE_CAMPI_CENTRALI))) {
						echo '<input type="text" name="search_'.ucwords(str_replace('_', ' ', $c)).'" placeholder="Cerca per '.strip_tags($this->oApp->getEtichettaTabella($c)).'" value="" class="search_init span12">';
					} else {
						echo '&nbsp;';
					}
					echo '</td>';
				}
				echo '</tr>';
			}
		    echo '</thead>';
		    echo '<tbody>';
		    break;
		    
	  	case 'checkbox':
	        echo '<fieldset id="fieldset_' .$this->elenco->getNomeElenco() . '"'.((!empty($this->style))?' class="'.$style.'"':'').'>';
			echo '<legend>'.ucwords(str_replace('_',' ',$this->elenco->getNomeElenco())).'</legend>';
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<div class="descrizione_elenco">'.$desc.'</div>';
			break;

	  	case 'radio':
	        echo '<fieldset id="fieldset_' .$this->elenco->getNomeElenco() . '"'.((!empty($this->style))?' class="'.$style.'"':'').'>';
			echo '<legend>'.ucwords(str_replace('_',' ',$this->elenco->getNomeElenco())).'</legend>';
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<div class="descrizione_elenco">'.$desc.'</div>';
			break;
		
		case 'select':
		case 'select_id':
			echo '<fieldset id="fieldset_' .$this->elenco->getNomeElenco() . '"'.((!empty($this->style))?' class="'.$style.'"':'').'>';
			echo '<legend>'.ucwords(str_replace('_',' ',$this->elenco->getNomeElenco())).'</legend>';
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<div class="descrizione_elenco">'.$desc.'</div>';
			echo '<label>';
	        echo '<select name="select_' .$this->elenco->getNomeElenco() . '" id="select_' .$this->elenco->getNomeElenco() . '">';
		    echo '<option class="select" value="">-- seleziona --</option>';
	        break;

		case 'select_id_no_fieldset':
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<div class="descrizione_elenco">'.$desc.'</div>';
			echo '<label>';
	        echo '<select name="select_' .$this->elenco->getNomeElenco() . '" id="select_' .$this->elenco->getNomeElenco() . '">';
		    echo '<option class="select" value="">-- seleziona --</option>';
	        break;
		case 'checkbox_no_fieldset':
		case 'checkbox_text_no_fieldset':
		case 'checkbox_no_fieldset_2_colonne':
	  		$desc = $this->elenco->getDescrizioneElenco();
	  		if (!empty($desc)) echo '<div class="descrizione_elenco">'.$desc.'</div>';
	  		break;
		case 'checkbox_no_fieldset_inline':
	  		$desc = $this->elenco->getDescrizioneElenco();
			echo '<div class="control-group" id="'.$this->elenco->getNomeElenco().'">
					<label class="control-label">'.$desc.'</label>
						<div class="controls">
							<div class="row-fluid">';
	  		break;
		
		case 'galleria_immagini_backend':
			echo '<div class="row-fluid">';
			break;

		case 'box_abbinamento_reparti':
			//echo '<div class="col-xl-12">';
			break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function chiudiElenco() {
    switch ($this->tipo) {
		case 'JSON':
				echo ']';
			break;
	  	case 'elenco':
	  	case 'menu':
	  		echo '</ul>';
		    break;
	  	case 'tabella':
		    echo '</tbody>';
		    echo '</table>';
		    break;
	  	case 'checkbox':
	        echo '</fieldset>';
			break;
	  	case 'radio':
	        echo '</fieldset>';
			break;
		case 'select':
		case 'select_id':
			echo '</select>';
			echo str_replace('_',' ',$this->elenco->getNomeElenco());
	        echo '</label>';
			echo '</fieldset>';
			break;
		case 'select_id_no_fieldset':
			echo '</select>';
			echo str_replace('_',' ',$this->elenco->getNomeElenco());
	        echo '</label>';
			break;
		case 'checkbox_no_fieldset_inline':
	  		$desc = $this->elenco->getDescrizioneElenco();
			echo '</div></div></div>';
	  		break;
		case 'galleria_immagini_backend':
			echo '</div>';
			break;
        case 'box_abbinamento_reparti':
            //echo '</div>';
            break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function setStyle($style) {
	$this->style = $style;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>