<?php
class supervisore extends oggetto {

	protected $id_supervisore;
	protected $ip;
	protected $ip_remoto;
    protected $descrizione;
	public $id_tipo_dispositivo;
	protected $tipo_dispositivo;
	protected $id_tipo_visualizzazione;
	protected $tipo_visualizzazione;
    protected $totale_mappe_da_campo;
    protected $totale_dispositivi_da_campo;
    protected $totale_mappe_da_db;
    protected $totale_dispositivi_fisici_da_db;
    protected $totale_dispositivi_virtuali_da_db;
    protected $stato_connessione;
    protected $ordine;

    protected $totale_supervisori;

	protected $oElencoMappe = FALSE;
	protected $oElencoDispositivi = FALSE;

	protected $class_action_url = 'supervisore/azioni/';
	protected $class_url = 'supervisore/';
	protected $nome_tabella = 'supervisore';
	protected $classe = 'supervisore';

/*********************************************************************************************************/
public function inserisci() {

    $this->ip_remoto = $this->ip;
    if(($this->id_tipo_dispositivo + 0) == -1) {
        $this->ip = "127.0.0.1";
        $this->checkDirs();
        file_put_contents("/usr/local/ave_rsa_pkg/data/fire_alarm_supervisor_ip.txt", $this->ip_remoto);

        $cmd = DIR_WEB . 'runasroot "killall yass3-launcher.sh"';
        shell_exec($cmd);
        $cmd = DIR_WEB . 'runasroot "killall mono"';
        shell_exec($cmd);
        
    }

	$this->oDb->disattivaAutocommit();
	$this->oDb->iniziaTransazione();

	$this->id_status = 1; //STATUS_IN_AGGIORNAMENTO;

	$this->ordine = $this->oDb->eseguiselect('SELECT IF (MAX(ordine)+1 = NULL, 1, MAX(ordine)+1) FROM supervisore WHERE id_status = '.STATUS_ATTIVO, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
    $this->ordine = max($this->ordine, 1);
    
    $sql = 'INSERT INTO supervisore SET '.$this->getCampiQuery('inserisci').$this->getInsertCampiBase(TRUE);
    
    // print_r(get_object_vars($this->id_tipo_dispositivo)); die;
    
	$ret = $this->oDb->eseguiinsert($sql);
	if ($ret) {
		$this->id_supervisore = $this->oDb->dammiultimoidinserito();

        //$this->sendSignal(__METHOD__);
        $this->serverRiavvia();

		$this->oDb->confermaTransazione();
		$this->oDb->attivaAutocommit();
		return TRUE;
	}
	$this->oDb->annullaTransazione();
	$this->oDb->attivaAutocommit();
	return FALSE;
}

private function checkDirs() {
    if(!file_exists("/usr/local/ave_rsa_pkg/data")) {
        mkdir("/usr/local/ave_rsa_pkg/data", 0777);
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
    
    $this->ip_remoto = $this->ip;
    if(($this->id_tipo_dispositivo + 0) == -1) {
        $this->ip = "127.0.0.1";
        $this->checkDirs();
        file_put_contents("/usr/local/ave_rsa_pkg/data/fire_alarm_supervisor_ip.txt", $this->ip_remoto);

        $cmd = DIR_WEB . 'runasroot "killall yass3-launcher.sh"';
        shell_exec($cmd);
        $cmd = DIR_WEB . 'runasroot "killall mono"';
        shell_exec($cmd);
        
    }

	$this->oDb->disattivaAutocommit();
	$this->oDb->iniziaTransazione();

	$sql = 'UPDATE supervisore SET '.$this->getCampiQuery('modifica').$this->getUpdateCampiBase().' WHERE id_supervisore = ' . num2Str($this->getId());
    
    $ret = $this->oDb->eseguiupdate($sql);
	if ($ret) {
        //$this->sendSignal(__METHOD__);
        $this->serverRiavvia();

        $this->oDb->confermaTransazione();
		return TRUE;
	}
	$this->oDb->annullaTransazione();
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function elimina() {
    $sql = 'UPDATE supervisore SET ip='.stripcslashesandquote($this->ip.'-'.date('Y-m-d-H-i-s').'-'.getmicrotime()  ).', ordine = -1, id_status = '.STATUS_ELIMINATO.' , '.$this->getUpdateCampiBase(TRUE).' WHERE '.$this->getNomeAttributoId().' = '.num2Str($this->getId());
    $ret = $this->oDb->eseguiupdate($sql);
    if ($ret) {
        $sql = 'UPDATE supervisore SET ordine = ordine-1 WHERE ordine > '.num2Str($this->ordine);
        $this->oDb->eseguiupdate($sql);
        if ($this->classe == 'supervisore' || $this->classe == 'relay') $this->sendSignal(__METHOD__);
    }
    if ($ret == TRUE) $this->serverRiavvia();
    return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function getCampiQuery($mode) {
	$aV = array();
	 
	if ($mode == 'modifica') $aV[] = 'id_supervisore='.num2str($this->id_supervisore);
	$aV[] = 'ip='.stripcslashesandquote($this->ip);
	$aV[] = 'ip_remoto='.stripcslashesandquote($this->ip_remoto);
	$aV[] = 'descrizione='.stripcslashesandquote($this->descrizione);
    if ($mode == 'inserisci') $aV[] = 'ordine='.stripcslashesandquote($this->ordine);
	$aV[] = 'id_tipo_dispositivo='.num2str($this->id_tipo_dispositivo);
	$aV[] = 'id_tipo_visualizzazione='.num2str($this->id_tipo_visualizzazione);

	return implode(',', $aV).',';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElimina($visualizza_etichetta=TRUE) {
	if (!$this->checkElementiCollegati()){
		return 	parent::getElimina($visualizza_etichetta);
	} else {
		return $this->oApp->getMsgInfo('OPERAZIONE_NON_CONSENTITA');
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function checkElementiCollegati() {
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDenominazione() {
    return $this->ip.' - '.$this->descrizione;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDenominazioneTabella() {
    return $this->descrizione.BR.'<small>('.$this->ip.')</small>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getTipoDispositivoImg() {
    return '<div class="row"><div class="col-6">'.$this->tipo_dispositivo.'</div><div class="col-3"><img width="50" src="'.URL_IMG.(($this->id_tipo_dispositivo == TIPO_DISPOSITIVO_ID_WS)?'ws.png':'ts01.png').'"></div></div>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haDispositivi() {
    if ($this->oElencoDispositivi == FALSE) $this->estraiDispositivi();
    return (!$this->oElencoDispositivi->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoDispositivi() {
    if ($this->oElencoDispositivi == FALSE) $this->estraiDispositivi();
    return $this->oElencoDispositivi;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiDispositivi() {
    $this->oElencoDispositivi = new elencodispositivo($this->oApp, FALSE, ' ORDER BY id_dispositivo DESC');
    $this->oElencoDispositivi->caricaPerSupervisore($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haMappe() {
    if ($this->oElencoMappe == FALSE) $this->estraiMappe();
    return (!$this->oElencoMappe->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoMappe() {
    if ($this->oElencoMappe == FALSE) $this->estraiMappe();
    return $this->oElencoMappe;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiMappe() {
    $this->oElencoMappe = new elencomappa($this->oApp, FALSE, ' ORDER BY ordine DESC');
    $this->oElencoMappe->caricaPerSupervisore($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIpPerJs() {
    return str_replace('.','-',$this->ip);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getDispositivoVirtualeTuttiAllarmi($tipo) {
    if($tipo == 'origine'){
        $id = $this->id_supervisore*10000+3;
        return new dispositivo($this->oApp, $id);
    } else if($tipo == 'destinazione'){
        $id = $this->id_supervisore*10000+14;
        return new dispositivo($this->oApp, $id);
    }

}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAzioni($esploso = FALSE) {
    return $this->getModifica().BR.$this->getElimina();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getOrdineSelect() {
    $retVal = '<select class="supervisori_cambia_ordine" id_supervisore="'.writePostParam($this->id_supervisore).'">';
    for ($i = 1; $i <= $this->totale_supervisori; ++$i) {
        $retVal .=  '<option value="'.$i.'"'.(($i == $this->ordine)?' selected="selected"':'').'>'.$i.'</option>';
    }
    $retVal .=  	'</select>';
    return $retVal;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function cambiaOrdine($nuovoOrdine) {
    $this->oDb->disattivaAutocommit();
    $this->oDb->iniziaTransazione();

    if ($this->ordine > $nuovoOrdine) {
        // quelli compresi tra il nuovo e il vecchio li aumento di uno
        $sql = 'UPDATE supervisore
               SET ordine = (ordine + 1) 
             WHERE ordine >= '.num2Str($nuovoOrdine).' 
               AND ordine <= '.num2Str($this->ordine);
    }

    if ($this->ordine < $nuovoOrdine) {
        // quelli compresi tra il nuovo e il vecchio li diminuisco di uno
        $sql = 'UPDATE supervisore 
               SET ordine = (ordine - 1) 
             WHERE ordine >= '.num2Str($this->ordine).'
               AND ordine <= '.num2Str($nuovoOrdine);
    }
    $ret = $this->oDb->eseguiupdate($sql);
    if ($ret === TRUE) {
        $sql = 'UPDATE supervisore 
               SET ordine = '.num2str($nuovoOrdine).'
         WHERE id_supervisore = '.num2Str($this->id_supervisore);
        $ret = $this->oDb->eseguiupdate($sql);
        if ($ret == TRUE) {
            $this->oDb->confermaTransazione();
            $this->oDb->attivaAutocommit();
            return TRUE;
        }
    }
    $this->oDb->annullaTransazione();
    $this->oDb->attivaAutocommit();
    return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>