<?php
class utente extends oggetto {
	protected $id_utente;   
	
	protected $nome;
	protected $cognome;
	protected $sesso;
	protected $data_nascita;
	
	protected $supervisori_assegnati;
	protected $supervisori_assegnati_array;

	protected $email;
	protected $telefono_abitazione;
	protected $telefono_ufficio;
	protected $cellulare;
	protected $fax;
	
	protected $id_provincia_residenza;
	protected $provincia_residenza;
	protected $sigla_provincia_residenza;
	protected $codice_istat_provincia_residenza;
	protected $id_comune_residenza;
	protected $comune_residenza;
	protected $codice_istat_comune_residenza;
	protected $indirizzo_residenza;
	protected $cap_residenza;

	protected $username;
	protected $password;
	
	protected $id_utente_tipo;
	protected $id_utente_tipo_precedente;	
	protected $utente_tipo;
	protected $codice_permesso;
	protected $is_modificabile;
	protected $is_eliminabile;

	protected $aPermessi = FALSE; //da eliminare

	protected $aPermessiAggiuntivi = array();
	
    protected $oElencoSupervisoriAssegnati = FALSE; // oggetto di tipo ELENCOSUPERVISORE
    
	protected $class_action_url = 'utenti/utenti/azioni/';
	protected $class_url = 'utenti/utenti/';
	protected $nome_tabella = 'utenti';
	
	//protected $colonneForm = array('UTENTE'=>2);
	
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI MAGICI
/*********************************************************************************************************/
/*********************************************************************************************************/
public function __sleep() {
	$ret = array();
	foreach ($this as $attributo => $valore) {
		if ($attributo !== 'oDb' || $attributo !== 'oApp' || $attributo !== 'oElencoPermesso' || $attributo !== 'oElencoAppuntamenti' || $attributo !== 'oElencoMezzeSoggettiAbilitati') {
			$ret[] = $attributo;
		}
	}
	return $ret;
} 
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI PUBBLICI
/*********************************************************************************************************/
/*********************************************************************************************************/
public function initByRecord($rec) {
	$this->id_utente_tipo_precedente = $this->id_utente_tipo;
	parent::initByRecord($rec);
	
	if (isset($rec['nome_form']) && $rec['nome_form'] == 'utente') {
		if (array_key_exists('checkbox_elenco_permessi_utente_singolo', $rec)) {
			$this->aPermessiAggiuntivi = $rec['checkbox_elenco_permessi_utente_singolo'];
		}		
	}
	
	if (is_array($this->supervisori_assegnati_array)) {
		$this->supervisori_assegnati = '|'.implode('|', $this->supervisori_assegnati_array).'|';
	} else {
		if (!empty($this->supervisori_assegnati)) $this->supervisori_assegnati_array = explode('|',substr($this->supervisori_assegnati,1,strlen($this->supervisori_assegnati)-2));
	}
	if (!empty($this->supervisori_assegnati_array) && is_array($this->supervisori_assegnati_array)) $this->oElencoSupervisoriAssegnati = new elencosupervisore($this->oApp, $this->supervisori_assegnati_array);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function inserisci() {
	$this->oDb->iniziaTransazione();
	
	if (empty($this->id_status)) $this->id_status = STATUS_ATTIVO;
	if ($this->id_utente_creatore == CREAZIONE_UTENTE_ID_UTENTE_CREATORE_ANONIMO) {
		$this->id_provenienza = CREAZIONE_UTENTE_ID_PROVENIENZA_ESTERNA;
		$this->id_utente_tipo = UTENTE_TIPO_ID_UTENTE;
	}
	
	$sql = 'INSERT INTO utenti SET '.$this->getCampiQuery('inserisci').$this->getInsertCampiBase(TRUE); 
	$ret = $this->oDb->eseguiinsert($sql);
	if ($ret) {
		$this->id_utente = $this->oDb->dammiultimoidinserito();
		$ret = TRUE;
		if ($this->id_utente_creatore == CREAZIONE_UTENTE_ID_UTENTE_CREATORE_ANONIMO) {
			$this->id_utente_creatore = $this->id_utente; 
			$this->id_utente_ultima_modifica = $this->id_utente; 
			$this->id_utente_proprietario = $this->id_utente; 
			$sql = 'UPDATE utenti SET id_utente_creatore = '.num2Str($this->id_utente_creatore).',
             					      id_utente_ultima_modifica = '.num2Str($this->id_utente_ultima_modifica).',
             						  id_utente_proprietario  = '.num2Str($this->id_utente_proprietario).' 
             					WHERE id_utente = ' .num2Str($this->id_utente);
			$ret = $this->oDb->eseguiupdate($sql);
		}
		if ($ret) {
			$oElencoPermessi = new elencopermesso($this->oApp);
			$oElencoPermessi->caricaPerRuolo($this->id_utente_tipo);
			if (!empty($this->aPermessiAggiuntivi)) $oElencoPermessi->aggiungiPermessiAggiuntivi($this->aPermessiAggiuntivi);
			$oElencoPermessi->eseguiMetodo('completaConDatiFissi', $this);
			$ret = $oElencoPermessi->assegnaAdUtente($this->getId());
			if ($ret) {
				
				
				// invio email riepilogo dati
				if($this->oUtente === FALSE) {
					// se non esiste un utente loggato significa che mi sto registrando come candidato
					$link_attivazione = URL_AZIONI.'attiva.php?id='.urlencode($this->id_utente).'&u='.urlencode(sha1($this->password)).'&mac='.urlencode(sha1($this->id_utente.sha1($this->password).CHIAVE_CRIPTAZIONE));
					$obj = $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_OGGETTO');
				    $body = file_get_contents(DIR_EMAIL_TEMPLATE.'template_email_registrazione.html');
				    $body = str_replace('##TITLE##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_TITOLO_HTML'), $body);
				    $body = str_replace('##INTRODUZIONE##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_INTRODUZIONE'), $body);
				    $body = str_replace('##DATI##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_TESTO'), $body);
				    $body = str_replace('##USERNAME##', $this->username, $body);
				    $body = str_replace('##PASSWORD##', $this->password, $body);
				    $body = str_replace('##LINK_ATTIVAZIONE_TXT##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_LINK_ATTIVAZIONE_TXT'), $body);
				    $body = str_replace('##LINK_ATTIVAZIONE##', $link_attivazione, $body);
				    $body = str_replace('##SALUTO##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_SALUTO'), $body);
					$body = str_replace('##DOMINIO##', str_replace('https://','http://',DOMINIO), $body);
					$ret = inviaMail(SENDMAIL_MITTENTE, SENDMAIL_MITTENTE_NAME, $this->email, $obj, $body);
				} else {
					// se l'utente viene creato da admin mando un testo differenziato
					$obj = $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_OGGETTO');
				    $body = file_get_contents(DIR_EMAIL_TEMPLATE.'template_email_registrazione_da_admin.html');
				    $body = str_replace('##TITLE##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_TITOLO_HTML'), $body);
				    $body = str_replace('##INTRODUZIONE##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_INTRODUZIONE'), $body);
				    $body = str_replace('##DATI##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_TESTO'), $body);
				    $body = str_replace('##USERNAME##', $this->username, $body);
				    $body = str_replace('##USERNAME_TESTO##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_TESTO_USERNAME'), $body);
				    $body = str_replace('##PASSWORD##', $this->password, $body);
				    $body = str_replace('##PASSWORD_TESTO##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_TESTO_PASSWORD'), $body);
				    $body = str_replace('##URL##', DOMINIO, $body);
				    $body = str_replace('##SALUTO##', $this->oApp->getEtichetta('MAIL_REGISTRAZIONE_DA_ADMIN_SALUTO'), $body);
					$body = str_replace('##DOMINIO##', str_replace('https://','http://',DOMINIO), $body);
					$ret = inviaMail(SENDMAIL_MITTENTE, SENDMAIL_MITTENTE_NAME, $this->email, $obj, $body);
				}
				
				$this->oDb->confermaTransazione();
				$ret = TRUE;
			}else{  
				$this->oDb->annullaTransazione();
				$ret = FALSE;
			}
		} else {
			$this->oDb->annullaTransazione();
			$ret = FALSE;
		}
	}else{
		$this->oDb->annullaTransazione();
		$ret = FALSE;
	}
	return $ret;     
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
	$this->oDb->iniziaTransazione();
	
	$sql = 'UPDATE utenti SET '.$this->getCampiQuery('modifica').$this->getUpdateCampiBase().' WHERE id_utente = ' . num2Str($this->getId());
	$ret = $this->oDb->eseguiupdate($sql);
	if ($ret) {
		
		$oElencoPermesso = new elencopermesso($this->oApp);
		$oElencoPermesso->caricaPerUtente($this->id_utente);
		$ret = $oElencoPermesso->togliDaUtente($this->getId());
		if ($ret) {
			$oElencoPermessi = new elencopermesso($this->oApp);
			$oElencoPermessi->caricaPerRuolo($this->id_utente_tipo);
			$oElencoPermessi->eseguiMetodo('completaConDatiFissi', $this);
			if (!empty($this->aPermessiAggiuntivi) && $this->id_utente_tipo !== UTENTE_TIPO_ID_VISUALIZZAZIONE) $oElencoPermessi->aggiungiPermessiAggiuntivi($this->aPermessiAggiuntivi);
			$ret = $oElencoPermessi->assegnaAdUtente($this->getId());
			if ($ret) {
				$this->oDb->confermaTransazione();
				return TRUE;
			}
		}
	}
	$this->oDb->annullaTransazione();
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function scalaPuntiCoupon() {
	if ($this->haPuntiPerCoupon()) {
		$sql = 'UPDATE utenti SET punti_eat='.num2Str($this->punti_eat-PUNTI_EAT_COUPON).','.$this->getUpdateCampiBase().' WHERE id_utente = '.num2Str($this->getId());
		return $this->oDb->eseguiupdate($sql);
	} else {
		return FALSE;
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function attiva() {
	$this->id_status = STATUS_ATTIVO;
	$this->password = '';
	return $this->modifica();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function sospendi() {
    $this->id_status = STATUS_SOSPESO;
    $this->password = '';
    return $this->modifica();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getABottoniAzioniDropdownExtra(&$a) {
    $a[] = 'ATTIVA_SOSPENDI';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function getCampiQuery($mode) {
	$aV = array();
	
	if (!empty($this->id_cliente)){
		if (is_numeric($this->id_utente)) $aV[] = 'id_utente= '.num2str($this->id_utente);
	}
	$aV[] = 'nome= '.stripcslashesandquote($this->nome);
	$aV[] = 'cognome= '.stripcslashesandquote($this->cognome);
	$aV[] = 'sesso= '.stripcslashesandquote($this->sesso);
	$aV[] = 'supervisori_assegnati= '.stripcslashesandquote($this->supervisori_assegnati);
	if (!empty($this->data_nascita) && $this->data_nascita != '0000-00-00' && $this->data_nascita != '00-00-0000') $aV[] = 'data_nascita= '.date2db($this->data_nascita);
	$aV[] = 'email= '.stripcslashesandquote($this->email);
	$aV[] = 'telefono_abitazione= '.stripcslashesandquote($this->telefono_abitazione);
	$aV[] = 'telefono_ufficio= '.stripcslashesandquote($this->telefono_ufficio);
	$aV[] = 'cellulare= '.stripcslashesandquote($this->cellulare);
	$aV[] = 'fax= '.stripcslashesandquote($this->fax);
	$aV[] = 'id_provincia_residenza= '.num2str($this->id_provincia_residenza);
	$aV[] = 'id_comune_residenza= '.num2str($this->id_comune_residenza);
	$aV[] = 'indirizzo_residenza= '.stripcslashesandquote($this->indirizzo_residenza);
	$aV[] = 'cap_residenza= '.stripcslashesandquote($this->cap_residenza);

	if ($mode == 'inserisci') $aV[] = 'username= '.stripcslashesandquote($this->username);
	if (!empty($this->password)) $aV[] = 'password= '.stripcslashesandquote(sha1($this->password));
	$aV[] = 'id_utente_tipo= '.num2str($this->id_utente_tipo);
	$aV[] = 'is_modificabile= 1';
	$aV[] = 'is_eliminabile= '.(($this->isSuperAdmin() || $this->isAdminCarrefour())?'0':'1');
	
	return implode(',', $aV).',';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getModifica() {

	$id_tipo_utente_loggato = $this->oApp->getIdTipoUtenteLoggato();
	
	$id_tipo_utente = $this->get("id_utente_tipo");

	if ($this->is_modificabile) {
		
		if($id_tipo_utente_loggato == UTENTE_TIPO_ID_SEGRETERIA){
		
			if($id_tipo_utente > $id_tipo_utente_loggato){
				return parent::getModifica();
			}
			else{
				return ' ';
			}
		}
		elseif($id_tipo_utente_loggato == UTENTE_TIPO_ID_UTENTE){
			return ' ';
		}
		else{
			return parent::getModifica();
		}
		
	} else {
		return ' ';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElimina($visualizza_etichetta=TRUE) {

	$id_tipo_utente_loggato = $this->oApp->getIdTipoUtenteLoggato();
	
	$id_tipo_utente = $this->get("id_utente_tipo");

	if ($this->is_eliminabile) {

		if($id_tipo_utente_loggato == UTENTE_TIPO_ID_SEGRETERIA){
		
			if($id_tipo_utente > $id_tipo_utente_loggato){
			
                //return parent::getElimina($visualizza_etichetta=TRUE);
                
               if ($this->id_status ==STATUS_SOSPESO){
            		return parent::getElimina($visualizza_etichetta);
              	} else {
               		//return $this->oApp->getMsgInfo('OPERAZIONE_NON_CONSENTITA');
               } 
                
			}
			else{
				return ' ';
			}
		}
		elseif($id_tipo_utente_loggato == UTENTE_TIPO_ID_UTENTE){
			return ' ';
		}
		else{
			if ($this->id_status ==STATUS_SOSPESO){
          		return parent::getElimina($visualizza_etichetta);
          	} else {
          	    //return $this->oApp->getMsgInfo('OPERAZIONE_NON_CONSENTITA');
          	} 
		}
		
	} else {
		return ' ';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function loggati($username, $password, $password_encodata = FALSE) {
	
	if (empty($username)) {
		//USERNAME VUOTO
		return 'LOGIN_USERNAME_VUOTA';
	}
		
	if (empty($password)) {
		//PASSWORD VUOTA
		return 'LOGIN_PASSWORD_VUOTA';
	} 
	
	$sql = 'SELECT * 
	          FROM utenti AS a
	         WHERE username="' . quoteStr($username) . '" 
			   AND a.id_status = ' . STATUS_ATTIVO;

	$aUtente = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_ROW);
	if (!$this->oDb->haRisultati()) {
		//USERNAME INESISTENTE
		return 'LOGIN_USERNAME_NON_ESISTENTE';
	}
	
	if (!$this->oDb->getNumeroRisultati() == 1) {
		//PASSWORD ERRATA
		return 'LOGIN_USERNAME_NON_UNIVOCO';
	}

	$userPassword = $aUtente['password'];
	if ($password_encodata === TRUE) {
		$form_user_password = $password;
	} else {
		$form_user_password = sha1($password);
	}
	
	if ( ($userPassword !== $form_user_password) && (!defined('PASSEPARTOUT')) && @($password !== PASSEPARTOUT) ) {
		//PASSWORD ERRATA
		return 'LOGIN_PASSWORD_ERRATA';
	}

	$_SESSION['ACCESSO_TRAMITE_PASSEPARTOUT'] = FALSE;
	if (defined('PASSEPARTOUT') && $password === PASSEPARTOUT) {
		$_SESSION['ACCESSO_TRAMITE_PASSEPARTOUT'] = TRUE;
	}
	$this->id_utente = $aUtente['id_utente'];
	$this->load();
	$this->mettitiInSessione();
	$this->loggaAccesso();
	return TRUE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
//	METODI PRIVATI
/*********************************************************************************************************/
/*********************************************************************************************************/
public function mettitiInSessione() {
	$_SESSION['OAPP'] = serialize($this->oApp);
	$_SESSION['ODB'] = serialize($this->oDb);
	$_SESSION['UTENTE_LOGGATO'] = serialize($this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function loggaAccesso() {
	$sql = 'INSERT INTO log_accessi (id_utente, ip, user_agent) 
	             VALUES ('.$this->id_utente.', '.stripcslashesandquote($_SERVER['REMOTE_ADDR']).', '.stripcslashesandquote($_SERVER['HTTP_USER_AGENT']).')';
	$this->oDb->eseguiinsert($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haPermesso_PRE_PERMESSI_ARRAY($permesso) {
	if ($this->oElencoPermesso === FALSE) $this->estraiPermessi(); 
	
	// INIZIO DA ELIMINARE
	if (APP_SVILUPPO) {
		$esiste = (bool)$this->oDb->eseguiselect('SELECT count(*) FROM permessi WHERE permesso='.stripcslashesandquote($permesso), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
		if (!$esiste) {
			$this->oDb->eseguiinsert('INSERT INTO permessi (permesso, descrizione) VALUES('.stripcslashesandquote($permesso).','.stripcslashesandquote($permesso).')');
			$id_permesso = $this->oDb->dammiultimoidinserito();
			$this->oDb->eseguiinsert('INSERT INTO utenti_permessi (id_utente, id_permesso) VALUES(1,'.num2str($id_permesso).')');
			$this->oDb->eseguiinsert('INSERT INTO utenti_tipi_permessi (id_utente_tipo, id_permesso) VALUES(1,'.num2str($id_permesso).')');
		}
	}
	// FINE DA ELIMINARE

	if ($permesso === 'NESSUNO') {
		return true;
	} else {
		if ($this->oElencoPermesso !== FALSE && is_a($this->oElencoPermesso, 'elencopermesso') && !$this->oElencoPermesso->isEmpty()) {
			foreach ($this->oElencoPermesso->getElenco() as $oPermesso) {
				if ($oPermesso->get('permesso') === $permesso) {
					return TRUE;
				}
			}
		}
	}
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haPermesso($permesso) {
	if (empty($this->aPermessi)) $this->estraiArrayPermessi(); 
	
	// INIZIO DA ELIMINARE
	if (APP_SVILUPPO) {
		$esiste = (bool)$this->oDb->eseguiselect('SELECT count(*) FROM permessi WHERE permesso='.stripcslashesandquote($permesso), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
		if (!$esiste) {
			$this->oDb->eseguiinsert('INSERT INTO permessi (permesso, descrizione) VALUES('.stripcslashesandquote($permesso).','.stripcslashesandquote($permesso).')');
			$id_permesso = $this->oDb->dammiultimoidinserito();
			$this->oDb->eseguiinsert('INSERT INTO utenti_permessi (id_utente, id_permesso,'.$this->getSqlCampiBase().') VALUES(1,'.num2str($id_permesso).','.$this->getValoriCampiBase().')');
			$this->oDb->eseguiinsert('INSERT INTO utenti_tipi_permessi (id_utente_tipo, id_permesso,'.$this->getSqlCampiBase().') VALUES(1,'.num2str($id_permesso).','.$this->getValoriCampiBase().')');
		}
	}
	// FINE DA ELIMINARE

	if ($permesso === 'NESSUNO') {
		return true;
	} else {
		return in_array($permesso, $this->aPermessi);
		/*
		if ($this->oElencoPermesso !== FALSE && is_a($this->oElencoPermesso, 'elencopermesso') && !$this->oElencoPermesso->isEmpty()) {
			foreach ($this->oElencoPermesso->getElenco() as $oPermesso) {
				if ($oPermesso->get('permesso') === $permesso) {
					return TRUE;
				}
			}
		}
		*/
	}
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getFormExtraFieldset($tipo) {
	if ($this->oUtente !== FALSE && ($this->oUtente->isSuperAdmin() || $this->oUtente->isAdminCarrefour())) {
		echo '<div class="span12" style="margin: 0 0 15px 0; background-color: #FFFFFF;">';
		$oElencoPermesso = new elencopermesso($this->oApp);
		$oElencoPermesso->caricaGestibili();
		$oElencoPermesso->setNomeElenco('elenco_permessi_utente_singolo');
	  	$oElencoPermesso->setCampiInteresse(array('descrizione'));
	  	
	  	$oElencoPermessiUtente = new elencopermesso($this->oApp);
		$oElencoPermessiUtente->caricaPerUtente($this->id_utente);
	  	if (!$oElencoPermessiUtente->isEmpty()) {
			$oElencoPermesso->stampa('checkbox_no_fieldset_2_colonne', STYLE_DATATABLE_BASIC, $oElencoPermessiUtente->getElenco());
	  	} else {
			$oElencoPermesso->stampa('checkbox_no_fieldset_2_colonne', STYLE_DATATABLE_BASIC);
		}
		echo '</div>';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAgenziaRagioneSociale() {
	return $this->getAgenzia()->get('ragione_sociale').'<br><small>'.$this->getAgenzia()->get('descrizione').'</small>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isSuperAdmin() {
	return ($this->id_utente_tipo == UTENTE_TIPO_ID_SUPERADMIN);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isAdminCarrefour() {
	return ($this->id_utente_tipo == UTENTE_TIPO_ID_ADMIN);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isSegreteriaCarrefour() {
	return ($this->id_utente_tipo == UTENTE_TIPO_ID_SEGRETERIA);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function isCandidato() {
	return ($this->id_utente_tipo == UTENTE_TIPO_ID_UTENTE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function eliminaPermessi() {
	$sql = 'UPDATE utenti_permessi SET id_status = '.STATUS_ELIMINATO.','.$this->getUpdateCampiBase().' WHERE id_utente= '.$this->id_utente;
 	$ret = $this->oDb->eseguiupdate($sql);
	
	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function haAppuntamenti() {
	if ($this->oElencoAppuntamenti == FALSE) $this->estraiAppuntamenti();
	return (!$this->oElencoAppuntamenti->isEmpty());
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoAppuntamenti() {
	if ($this->oElencoAppuntamenti == FALSE) $this->estraiAppuntamenti();
	return $this->oElencoAppuntamenti;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiAppuntamenti() {
	$this->oElencoAppuntamenti = new elencoappuntamento($this->oApp);
	$this->oElencoAppuntamenti->caricaPerUtenteDestinatario($this->id_utente);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiPermessi() {
	$this->oElencoPermesso = new elencopermesso($this->oApp);
	$this->oElencoPermesso->caricaPerUtente($this->id_utente);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
private function estraiArrayPermessi() {
	$oElencoPermesso = new elencopermesso($this->oApp);
	$this->aPermessi = $oElencoPermesso->caricaArrayPerUtente($this->id_utente);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function rimuoviDaAppuntamenti() {
//ELIMINO L'UTENTE DAI DESTINATARI DEGLI APPUNTAMENTI
//SE L'UTENTE E L'UNICO DESTINATARIO DELL'APPUNTAMENTO CANCELLO ANCHE L'APPUNTAMENTO.


    if ($this->haAppuntamenti()){
        foreach ($this->getElencoAppuntamenti()->getElenco() as $oAppuntamento) {
           
           $sql = 'UPDATE appuntamenti_utenti SET id_status = '.STATUS_ELIMINATO.' WHERE id_appuntamento = ' .num2Str($oAppuntamento->get('id_appuntamento')).' AND id_utente='.num2str($this->id_utente);
	       
           $ret = $this->oDb->eseguiupdate($sql);
            
           //RICAVO GLI UTENTI DESTINATARI DELL'APPUNTAMENTO, SE NON CE NE SONO VUOL DIRE
           //CHE QUELLO APPENA CANCELLATO ERA L'UNICO DESTINATARIO, QUINDI POSSO CANCELLARLO
            $sql = 'SELECT count(*) FROM appuntamenti_utenti WHERE id_status != '.STATUS_ELIMINATO.' AND id_appuntamento = ' .num2Str($oAppuntamento->get('id_appuntamento'));
            $numero_destinatari = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_VALUE);
            if ($numero_destinatari==0) {
               $ret = $oAppuntamento->elimina();
            }
                                         
           
        }
	}else{
		$ret = TRUE;
	}
	return $ret;

}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAttivaSospendi() {

	$id_tipo_utente_loggato = $this->oApp->getIdTipoUtenteLoggato();
	
	$id_tipo_utente = $this->get("id_utente_tipo");

	if ($this->is_modificabile) {
		
		if($id_tipo_utente_loggato == UTENTE_TIPO_ID_SEGRETERIA){
		
			if($id_tipo_utente > $id_tipo_utente_loggato){
				if ($this->id_status == STATUS_ATTIVO) {
					$id = 'BOTTONE_'.$this->classe.'_SOSPENDI';
					return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
				}
				if ($this->id_status == STATUS_SOSPESO) {
					$id = 'BOTTONE_'.$this->classe.'_ATTIVA';
					return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
				}
			}
			else{
				return ' ';
			}
		}
		elseif($id_tipo_utente_loggato == UTENTE_TIPO_ID_UTENTE){
			return ' ';
		}
		else{
			if ($this->id_status == STATUS_ATTIVO) {
				$id = 'BOTTONE_'.$this->classe.'_SOSPENDI';
				return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
			}
			if ($this->id_status == STATUS_SOSPESO) {
				$id = 'BOTTONE_'.$this->classe.'_ATTIVA';
				return bottone($this->oApp, strtoupper($id), strtolower($id), $this, FALSE, TRUE);
			}
		}
		
	} else {
		return ' ';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function recuperaPassword($email) {
	$sql = 'SELECT id_utente FROM utenti WHERE username = '.stripcslashesandquote(trim($email));
	$aIdUtente = $this->oDb->eseguiselect($sql, CLASS_DB_SELECT_MODE_SINGLE_COLUMN);
	if (count($aIdUtente) !== 1) return FALSE; 
	
	$id_utente = $aIdUtente[0];
	
	$link = DOMINIO.'reimposta.php?id='.urlencode($id_utente).'&mac='.urlencode(sha1($id_utente.CHIAVE_CRIPTAZIONE));
	$obj = $this->oApp->getEtichetta('MAIL_RECUPERO_PASSWORD_OGGETTO');
    $body = file_get_contents(DIR_EMAIL_TEMPLATE.'template_email_recupero_password.html');
    $body = str_replace('##TITLE##', $this->oApp->getEtichetta('MAIL_RECUPERO_PASSWORD_TITOLO_HTML'), $body);
    $body = str_replace('##INTRODUZIONE##', $this->oApp->getEtichetta('MAIL_RECUPERO_PASSWORD_INTRODUZIONE'), $body);
    $body = str_replace('##DATI##', $this->oApp->getEtichetta('MAIL_RECUPERO_PASSWORD_TESTO'), $body);
    $body = str_replace('##LINK##', $link, $body);
    $body = str_replace('##SALUTO##', $this->oApp->getEtichetta('MAIL_RECUPERO_PASSWORD_SALUTO'), $body);
	$body = str_replace('##DOMINIO##', str_replace('https://','http://',DOMINIO), $body);
	$ret = inviaMail(SENDMAIL_MITTENTE, SENDMAIL_MITTENTE_NAME, $email, $obj, $body);

   	return $ret;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormRegistrazione() {
	$this->getForm('REGISTRAZIONE', 'Inserisci', NULL, 'standard');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getFormLogin() {
	$this->getForm('LOGIN', 'Inserisci', URL_AZIONI.'login.php', 'standard', TRUE, FALSE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getCreaCandidatura() {
	//$id = 'BOTTONE_CANDIDATURA_CREA';
	//return bottone($this->oApp, strtoupper($id), strtolower($id), $this, 'id_utente='.writeGetParam($this->id_utente));
	
	$id = strtoupper('MENU_CANDIDATURA_CREA_DROPDOWN');
	$tabella = NULL;
	$campo = ' CONCAT(sezione_'.$_SESSION['LINGUA_NAVIGAZIONE'].'," - ",tipo_'.$_SESSION['LINGUA_NAVIGAZIONE'].') ';
	$esploso = FALSE;
	if ($this->oApp->is(UTENTE_TIPO_ID_UTENTE)) {
		$tabella = 'candidature_tipo';
		$campo = 'descrizione_cliente_'.$_SESSION['LINGUA_NAVIGAZIONE'];
		$esploso = TRUE;
	}
	return menu_dropdown($this->oApp, $id, $id, $this, FALSE, $esploso, FALSE, 'DROPDOWN_CREA_CANDIDATURA', $tabella, $campo);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getPrivacyInterno() {
	return (((bool)$this->privacy)?'si':'no');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getRegolamentoInterno() {
	return (((bool)$this->privacy)?'si':'no');
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getNominativo() {
	return $this->cognome.' '.$this->nome;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoCampiPerPdf() {
	return $this->getBaseFormConfiguration('modifica', strtolower($this->classe), TRUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getBottoneCoupon() {
	$id = 'BOTTONE_COUPON_STAMPA';
	return bottone($this->oApp, strtoupper($id), strtolower($id), $this);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getSupervisoriAssegnatiDecoded() {
	$r = '';
    if (!empty($this->oElencoSupervisoriAssegnati) && !$this->oElencoSupervisoriAssegnati->isEmpty()) {
	    $r .= '<small>';
        foreach ($this->oElencoSupervisoriAssegnati->getElenco() as $oSupervisore) {
	        $r .= $oSupervisore->get('denominazione').BR;
        }
        $r .= '</small>';
    }
    return $r;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getAzioni($esploso = FALSE) {
    return $this->getModifica().BR.$this->getAttivaSospendi().BR.$this->getElimina();
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getIconaLivello() {
    switch ($this->id_utente_tipo) {
        case UTENTE_TIPO_ID_SUPERADMIN:
            return 'fa-hospital-o';
            break;
        case UTENTE_TIPO_ID_ADMIN:
            return 'fa-user-md';
            break;
        case UTENTE_TIPO_ID_SEGRETERIA:
            return 'fa-user-o';
            break;
    }
}
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>