<?php
class utentetipo extends oggetto {
	protected $id_utente_tipo;
	protected $ruolo;
	
	protected $id_status;
	
	protected $class_action_url = 'utenti/ruoli/azioni/';
	protected $class_url = 'utenti/ruoli/';
	protected $nome_tabella = 'utenti_tipi';
	protected $classe = 'utentetipo';		
	
	protected $oElencoPermesso = FALSE; // oggetto di tipo ELENCOPERMESSO
		
/*********************************************************************************************************/
/*********************************************************************************************************/
public function initByRecord($rec) {
	parent::initByRecord($rec);
	
	if (array_key_exists('checkbox_elenco_permessi_ruolo_utente_tipo', $rec)) {
		$this->oElencoPermesso = new elencopermesso($this->oApp, $rec['checkbox_elenco_permessi_ruolo_utente_tipo']);
		$this->oElencoPermesso->completaConDatiFissi($this);
	} else {
		$this->oElencoPermesso = new elencopermesso($this->oApp);
		$this->oElencoPermesso->caricaPerRuolo($this->id_utente_tipo);
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function inserisci() {
	$this->oDb->iniziaTransazione();
	
	$sql = 'INSERT INTO utenti_tipi (ruolo, '.$this->getSqlCampiBase().') VALUES ('.stripcslashesandquote($this->ruolo).', '.$this->getValoriCampiBase().')';
	$ret = $this->oDb->eseguiinsert($sql);
	
	if ($ret) {
		$this->id_utente_tipo = $this->oDb->dammiultimoidinserito();
		$ret = $this->oElencoPermesso->assegnaARuoloEUtenti($this->getId());
		if ($ret) {
			$this->oDb->confermaTransazione();
			return TRUE;
		}
	}
	$this->oDb->annullaTransazione();
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function modifica() {
	$this->oDb->iniziaTransazione();
	
	//$sql = 'UPDATE utenti_tipi SET ruolo = '.stripcslashesandquote($this->ruolo).', '.$this->getUpdateCampiBase().' WHERE id_utente_tipo = ' .num2Str($this->getId());
	$sql = 'UPDATE utenti_tipi SET ruolo = '.stripcslashesandquote($this->ruolo).' WHERE id_utente_tipo = ' .num2Str($this->getId());
	$ret = $this->oDb->eseguiupdate($sql);
	if ($ret) {
		$this->oElencoPermesso->eseguiMetodo('completaConDatiFissi', $this);
		$ret = $this->oElencoPermesso->togliDaRuoloEUtenti($this->getId());
		if ($ret) {
			$ret = $this->oElencoPermesso->assegnaARuoloEUtenti($this->getId());
			if ($ret) {
				$this->oDb->confermaTransazione();
				return TRUE;
			}
		}
	}
	$this->oDb->annullaTransazione();
	return FALSE;
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function elimina() {
	if ($this->getNumeroUtenti() == 0) {
		$this->oDb->iniziaTransazione();
		$sql = 'DELETE FROM utenti_tipi_permessi WHERE id_utente_tipo = ' .num2Str($this->getId());
		$ret = $this->oDb->eseguidelete($sql);
		if ($ret) {
			$sql = 'DELETE FROM utenti_tipi WHERE id_utente_tipo = ' .num2Str($this->getId());
			$ret = $this->oDb->eseguidelete($sql);
			if ($ret) {
				$this->oDb->confermaTransazione();
				return TRUE;
			}
		}
		$this->oDb->annullaTransazione();
		return FALSE;
	} else {
		$this->oDb->annullaTransazione();
		return FALSE;	
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElimina($visualizza_etichetta=TRUE) {
	if ($this->getNumeroUtenti() == 0) {
		return parent::getElimina($visualizza_etichetta);
	} else {
		return ' ';
	}
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getFormExtraFieldset($tipo) {
	echo '<div class="span12" style="margin: 0 0 15px 0; background-color: #FFFFFF;">';
	$oElencoPermesso = new elencopermesso($this->oApp, TRUE, ' ORDER BY SEZIONE, AZIONE, TIPO');
	$oElencoPermesso->setNomeElenco('elenco_permessi_ruolo_utente_tipo');
  	$oElencoPermesso->setCampiInteresse(array('permesso_decoded'));
  	
  	$array_confronto = FALSE;
  	if ($this->oElencoPermesso !== FALSE && !$this->oElencoPermesso->isEmpty()) {
		$oElencoPermesso->stampa('checkbox_no_fieldset_2_colonne', STYLE_DATATABLE_BASIC, $this->oElencoPermesso->getElenco());
  	} else {
		$oElencoPermesso->stampa('checkbox_no_fieldset_2_colonne', STYLE_DATATABLE_BASIC);
	}
	echo '</div>';
}
/*********************************************************************************************************/
/*********************************************************************************************************/
protected function getNumeroUtenti() {
	return $this->oDb->eseguiselect('SELECT count(*) FROM utenti WHERE id_utente_tipo = ' . num2Str($this->getId()), CLASS_DB_SELECT_MODE_SINGLE_VALUE);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
public function getElencoPermessiCompleto() {
	$sql  = 'SELECT id_permesso AS id, permesso AS descrizione FROM permessi ORDER BY permesso';
	return $this->oDb->eseguiselect($sql);
}
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
/*********************************************************************************************************/
}
?>