<?php
require_once(realpath($_SERVER['DOCUMENT_ROOT']).'/include/config.php');
require_once(DIR_CLS . 'class.app.php');

$oApp = new app(TRUE, PERMESSO_NESSUNO);
$oApp->sezione(SEZIONE_FRONTEND);
$oApp->disegna(TEMPLATE_LOGIN);

/*********************************************************************************************************/
function elenco(&$oApp) {
    
    $isLegacy = $_SESSION['MODO_OPERATIVO'] == 'legacy';
    $isYass = $_SESSION['MODO_OPERATIVO'] == 'yass3';
    $loggedAfterModeChange = $_SESSION['MODO_OPERATIVO_LOGGATO'] == 'yes';

    if($isLegacy && isMobile()) {
        header("Location:/hotel/");
    }

    if(($isLegacy || $isYass) && @$_SESSION['UTENTE_LOGGATO']) {
        if($isLegacy) {
            header("Location:/hotel/admin/main.php?incf=rooms-configurator.php");
            die;
        } else {
            header("Location:/dashboard.php");
            die;
        }
    }

    /*
    print($_SESSION['MODO_OPERATIVO_LOGGATO']);
    print($_SESSION['MODO_OPERATIVO_PRIMO_CARICAMENTO_EFFETTUATO']);
    die;
    */
    
    $oApp->distruggisessione(true);	

    if(@$_SESSION['WRONG_LOGIN']) {
        $_SESSION['WRONG_LOGIN'] = false;
    } else {
        if(!$loggedAfterModeChange && !@$_SESSION['MODO_OPERATIVO_PRIMO_CARICAMENTO_EFFETTUATO']) {
            header('location:/backend/sistema/modo.php');
        }
    
        if( !$isLegacy && !$isYass ) {
            header('location:/backend/sistema/modo.php');
        }
    }


    ?>
    <div class="row mt-4">
        <div class="col-lg-3 col-sm-12"></div>
        <div class="col-lg-6 col-sm-12 " style="color: white; text-align: center;">
            <p style="font-size: 20px; "><?php
                switch ($_SESSION['MODO_OPERATIVO']) {
                    case 'yass3':
                        echo utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_YASS3'));
                        break;
                    case 'legacy':
                        echo utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_LEGACY'));
                        break;
                    default:
                        echo utf8_encode($oApp->getEtichetta('TABELLA_MODO_NON_DEFINITO'));
                        break;
                }


            ?></p>
        </div>
        <div class="col-lg-3 col-sm-12"></div>
    </div>
    
    <div class="row">
        <div class="col-lg-3 col-sm-12"></div>
        <div class="col-lg-6 col-sm-12">
            <div style="height: 60px;"></div>
            <div class="row">
                <div class="col-sm-3">
                    <a style="color:white; " href="/backend/sistema/modo.php"><i class="fa fa-arrow-left fa-2x"></i></a>
                </div>
                <div class="col-sm-6" style="text-align:center">
                    <?php

                    if($isLegacy) {
                        ?>
                            <img src="/hotel/images/DominaLogo.png" style="width: 280px;" />
                        <?php
                    } 
                    if($isYass) {
                        ?>
                            <img src="/img/dominaplus.png"  style="width: 200px;" />
                        <?php
                    }
                    ?>

                </div>
                <div class="col-sm-3">
                    <img src="/img/logoAVEnoScritte.jpg" style="width: 50px;" class="pull-right" />
                </div>
            </div>
            <div style="height: 10px;"></div>
            <div class="card card-login mx-auto mt-5">
                <div class="card-header">
                    <?php

                    if($isLegacy) { print $oApp->getEtichetta('LOGIN_HOTEL'); } 
                    if($isYass) { print $oApp->getEtichetta('LOGIN_RSA'); } 
                    ?>
                </div>
                <div class="card-body">
                    <form name="login" action="<?=URL_AZIONI?>login.php" method="post">
                        <div class="form-group">
                            <label for="username"><?=$oApp->getEtichetta('LOGIN_EMAIL')?></label>
                            <input class="form-control" id="username" name="username" aria-describedby="emailHelp" placeholder="<?=$oApp->getEtichetta('LOGIN_EMAIL_TXT')?>">
                        </div>
                        <div class="form-group">
                            <label for="password"><?=$oApp->getEtichetta('LOGIN_PASSWORD')?></label>
                            <input class="form-control" id="password" name="password" type="password" placeholder="<?=$oApp->getEtichetta('LOGIN_PASSWORD_TXT')?>">
                        </div>
                        <button class="btn btn-primary btn-block"><?=$oApp->getEtichetta('LOGIN_BOTTONE')?></button>
                    </form>
                    
                    <div style="text-align: center; margin-top: 24px;">
                        <?php
                            $ver = getVersion();
                            
                            if($ver['summary']) {
                                ?> <b class="text-success">Ver. <?=$ver['summary']?></b> <?php
                            } else {
                                ?> <b class="text-danger">Unknown Version</b> <?php
                            }
                            print "(" . $ver['full'] . ")";
                        ?>
                    </div>


                </div>
            </div>
            <div>
            <br>
                <?php
                    /*
                    if(@$oApp->getIdUtenteTipoLoggato() + 0 > 0) {
                        ?>
                        <div class="row">
                            <div class="col ">
                                <center><button style="width: 100%" id="btnSelectLegacyMode" class="btn btn-secondary "><?=utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_LEGACY'))?></button></center>
                            </div>
                            <div class="col ">
                                <center><button style="width: 100%" id="btnSelectYass3Mode" class="btn btn-secondary "><?=utf8_encode($oApp->getEtichetta('TABELLA_SELEZIONE_MODO_YASS3'))?></button></center>
                            </div>
                        </div>    
                        <script>
                            document.addEventListener("DOMContentLoaded", function() {
                                function selectMode(mode) {
                                    jQuery.post("/azioni/selezione_modo.php", { 
                                        'selectMode': mode
                                    }) .done(function( data ) {
                                        if(data == 'ok') {
                                            window.location.href = "/";
                                        } else {
                                            alert('Error');
                                        }
                                    });
                                }
                                jQuery('#btnSelectLegacyMode').click(function(){
                                    selectMode('legacy');
                                });
                                jQuery('#btnSelectYass3Mode').click(function(){
                                    selectMode('yass3');
                                });
                            });

                        </script>                        
                        
                        <?php
                    } 
                    */
                ?>
            </div>
        </div>

        <div class="col-lg-3 col-sm-12">
        
        </div>
    </div>
    
    
    <?php
    $_SESSION['MODO_OPERATIVO_PRIMO_CARICAMENTO_EFFETTUATO'] = false;
}
?>