
jQuery(function(){

    function drawFireAlarm(srv, data) {
        
        let selector = '.div-dashboard-bottone-supervisore[ip="' + srv.ipaddress.replace(/\./g, "-") + '"]';
        let maps = [];
        
        if(data.parameters[4] != undefined) {
            maps = data.parameters[4].split(",");
            for(i = 0; i < maps.length; i ++){
                maps[i] = maps[i].replace(/[^A-Za-z0-9]+/g,"").toLowerCase();

                console.log("MAP:" + maps[i]);
            }
        }

        let supIp = srv.ipaddress.replace(/\./g, "-");
        

        if(data.parameters[3] == 1) {
            jQuery(selector).attr('fire-alarm', 'failure');
            for(i = 0; i < maps.length; i ++){
                let mapSelector = '#map_id_' + supIp + '_' + maps[i];
                console.log("FAILURE ON " + mapSelector);
                jQuery(mapSelector).addClass("map-status-fa-failure");
            }
        } else if(data.parameters[3] == 2) {
            jQuery(selector).attr('fire-alarm', 'alarm');
            for(i = 0; i < maps.length; i ++){
                let mapSelector = '#map_id_' + supIp + '_' + maps[i];
                console.log("ALARM ON " + mapSelector);
                jQuery(mapSelector).addClass("map-status-fa-alarm");
            }
        } else {
            jQuery(selector).attr('fire-alarm', 'none');
            for(i = 0; i < maps.length; i ++){
                let mapSelector = '#map_id_' + supIp + '_' + maps[i];
                console.log("OK ON " + mapSelector);
                jQuery(mapSelector).removeClass("map-status-fa-failure");
                jQuery(mapSelector).removeClass("map-status-fa-alarm");
            }

            let mapSelector = '.map_id_' + supIp;
            console.log("OK ON " + mapSelector);
            jQuery(mapSelector).removeClass("map-status-fa-failure");
            jQuery(mapSelector).removeClass("map-status-fa-alarm");
        }

        jQuery('#div-dropdown-elenco-fire').html("");
        
        let alarmedSupervisors  = jQuery('*[fire-alarm="alarm"]');
        let failuredSupervisors  = jQuery('*[fire-alarm="failure"]');

        let alarmsCount = alarmedSupervisors.length;
        let failuresCount = failuredSupervisors.length;

        jQuery('.badge-numero-fire .span_numero_allarmi').html(alarmsCount + failuresCount);
        jQuery('.badge-numero-fire').removeClass('badge-danger');
        jQuery('.badge-numero-fire').removeClass('badge-warning');

        let alarmBoxes = "";
        let supCounter = 0;

        for(supCounter = 0; supCounter < alarmsCount; supCounter ++){
            alarmedSupervisor = alarmedSupervisors[supCounter];
            alarmBoxes += `
            <div class="alert-div">
                <a class="dropdown-item" href="javascript:void(0)">
                    <span style="color: red;">
                        ` + jQuery(alarmedSupervisor).find("button").html() + `
                    </span>
                    <span class="small float-left text-muted">Alarm</span>
                    <div class="dropdown-message small">&nbsp;</div>
                </a>
                <div class="dropdown-divider"></div>
            </div>
            `;
        }

        for(supCounter = 0; supCounter < failuresCount; supCounter ++){
            
            failuredSupervisor = failuredSupervisors[supCounter];
            alarmBoxes += `
            <div class="alert-div">
                <a class="dropdown-item" href="javascript:void(0)">
                    <span style="color: orange;">
                        ` + jQuery(failuredSupervisor).find("button").html() + `
                    </span>
                    <span class="small float-left text-muted">Failure</span>
                    <div class="dropdown-message small">&nbsp;</div>
                </a>
                <div class="dropdown-divider"></div>
            </div>
            `;
        }

        jQuery('#div-dropdown-elenco-fire').html(alarmBoxes);

        if(alarmsCount > 0){
            console.log("Has Alarms");
            jQuery('.badge-numero-fire').removeClass('badge-warning');
            jQuery('.badge-numero-fire').addClass('badge-danger');
            jQuery('.block-alert-fire').removeClass('d-none');
            
        } else if(failuresCount > 0){
            console.log("Has Failures");
            jQuery('.badge-numero-fire').removeClass('badge-danger');
            jQuery('.badge-numero-fire').addClass('badge-warning');
            jQuery('.block-alert-fire').removeClass('d-none');
        } else {
            console.log("Is OK");
            jQuery('.badge-numero-fire').removeClass('badge-warning');
            jQuery('.badge-numero-fire').removeClass('badge-danger');
            jQuery('.block-alert-fire').addClass('d-none');
        }

    }


    jQuery.getJSON("/dashboardBuildJSON.php",function(result){

        for(i=0; i<result.supervisorsToConnect.length; i++) {
            supervisorToConnect = result.supervisorsToConnect[i];
            atr.addServer(supervisorToConnect.description, supervisorToConnect.ip_address, supervisorToConnect.id_tipo_dispositivo);
            console.log("ADDING SERVER: [" + supervisorToConnect.description + "] [" + supervisorToConnect.ip_address + "]");
        }

        atr.buildingData = result.buildingData;

        atr.setListener(function(ev, srv, data){

            var me = atr;
        
            if(ev == "msg" && data.command != "ping" && data.command != "pong") {
                
                if(data.command == "upd") {
                    var subDeviceType = "";
                    var subDeviceStatus = "";
                    var deviceId = "";
        
                    if(data.parameters[0] == "WS") {
                        subDeviceType = data.parameters[0] + '-' + data.parameters[1];
                        deviceId = data.parameters[2];
                        subDeviceStatus = data.parameters[3];
                    } else if(data.parameters[0] == "A" || data.parameters[0] == "CS1" || data.parameters[0] == "CS2" || data.parameters[0] == "CS3") {
                        subDeviceType = data.parameters[0];
                        deviceId = data.parameters[1];
                        subDeviceStatus = data.parameters[2];
                    } else {
                        return;
                
                    }
        
                    //console.log("Event: [" + ev + "] [" + server.srvname + " - " + server.ipaddress + "]: Command " + data.command );
                    //console.log(data);
                    var doLoop = true;
                    for(mapCount = 0; mapCount < me.buildingData['supervisors'][srv.ipaddress].length && doLoop; mapCount ++) {
        
                        if(me.buildingData['supervisors'][srv.ipaddress][mapCount]['devices'] != undefined) {
                            for(deviceCount = 0; deviceCount < me.buildingData['supervisors'][srv.ipaddress][mapCount]['devices'].length && doLoop; deviceCount ++) {
        
                                device = me.buildingData['supervisors'][srv.ipaddress][mapCount]['devices'][deviceCount];
        
                                if(device['id'] == deviceId) {
                                    for(subCount = 0; subCount < device['sub'].length && doLoop; subCount ++) {
                                        if(device['sub'][subCount]['id'] == subDeviceType) {
                                            device['sub'][subCount]['status'] = subDeviceStatus;
                                            me.interfaceListener(srv.ipaddress, mapCount, deviceCount, subCount);
                                            doLoop = false;
                                        }
                                    } 
                                }
                                me.buildingData['supervisors'][srv.ipaddress][mapCount]['devices'][deviceCount] = device;
                            }
                        }
                    }
                
        
                } else if(data.command == "lm") {
                    return;
                    /*
                    counter = 0;
                    for(counter = 0; counter < data.records.length; counter ++) {
                        if(me.buildingData['supervisors'] == undefined) me.buildingData['supervisors'] = [];
                        if(me.buildingData['supervisors'][srv.ipaddress] == undefined) me.buildingData['supervisors'][srv.ipaddress] = [];
                        
                        me.buildingData['supervisors'][srv.ipaddress][data.records[counter][0]] = [];
                        me.buildingData['supervisors'][srv.ipaddress][data.records[counter][0]]['name'] = data.records[counter][1];
                        me.buildingData['supervisors'][srv.ipaddress][data.records[counter][0]]['sort'] = data.records[counter][2];
                        
                    }
                    setTimeout(function(){ me.sendWSCommandByName(srv.srvname, "LDI"); }, 500);
                    */
                } else if(data.command == "ldi") {
                    return;
                    /*
                    counter = 0;
                    for(counter = 0; counter < data.records.length; counter ++) {
                        maps = data.records[counter][3].split(";");
        
                        for (mapCounter = 0; mapCounter < maps.length; mapCounter ++) {
                            if(me.buildingData['supervisors'][srv.ipaddress][maps[mapCounter]] ) {
                                if(me.buildingData['supervisors'][srv.ipaddress][maps[mapCounter]]['devices'] == undefined) {
                                    me.buildingData['supervisors'][srv.ipaddress][maps[mapCounter]]['devices'] = [];
                                }
                                me.buildingData['supervisors'][srv.ipaddress][maps[mapCounter]]['devices'].push(data.records[counter]);
        
                            } else {
                                console.log("ID NON VALIDO: " + maps[mapCounter]);
                            }
                        }
                    }
        
                    console.log(me.buildingData);
                    */
                }
                
                //console.log(srv);
                //console.log(data);
        
            }
        
            if(ev == "msg" && data.command == "ping") {
                me.sendWSCommandByName(srv.srvname, "PONG");
            }

            if(data.command == "falp") {
                console.log("ARRIVATO FALP");
                console.log(data);
                drawFireAlarm(srv, data);
            }
        
            if(ev == "opened") {
                //setTimeout(function(){ me.sendWSCommandByName(srv.srvname, "LM"); }, 200);
                //setTimeout(function(){ me.sendWSCommandByName(srv.srvname, "LI2"); }, 700);
                
                setTimeout(function(){ me.sendWSCommandByName(srv.srvname, "SU2"); }, 400);
                setTimeout(function(){ me.sendWSCommandByName(srv.srvname, "SU3"); }, 600);
        
                setTimeout(function(){ 
                    for(counter = 1; counter <= 14; counter ++) {
                        me.sendWSCommandByName(srv.srvname, "WSF", counter); 
                    }
                    
                }, 1000);
        
            }
        
            if(ev == "watchdog") {
                //me.sendWSCommandByName(srv.srvname, "PING");
                
            }
        
        });

        atr.connectServers();
        
        console.log("ACTIVE FIRE ALARMS: " + activeFireAlarms.length);

        for(aac = 0; aac < activeFireAlarms.length; aac++) {
            let srv = {};
            srv.ipaddress = activeFireAlarms[aac]['ip'];
            let data = {};
            data.parameters = [];
            let tipoAllarme = activeFireAlarms[aac]['tipo_allarme'].split("-");
            data.parameters[3] = tipoAllarme[0].trim();
            data.parameters[4] = activeFireAlarms[aac]['comando_destinazione'];
            console.log(data);
            drawFireAlarm(srv, data);
        }
    });
});



setTimeout(function(){
    //atr.sendWSCommandByName("UNO", "LDI", "1,10");
    //atr.sendWSCommandByName("UNO", "EBI", "1,10");
}, 3000);

