<?php

class Dbconn {
	private $conn;
  	private $recordCount;
  

	public function __construct() {
		$this->openConnection();
	}

	public function __destruct() {
		$this->closeConnection();
	}

	public function __wakeup() {
		$this->openConnection();
	}

	public function eseguiinsert($sql){
		return $this->eseguiinsertupdatedelete($sql);
	}

	public function eseguiupdate($sql){
		return $this->eseguiinsertupdatedelete($sql);
	}

	public function eseguidelete($sql){
		return $this->eseguiinsertupdatedelete($sql);
	}

	public function dammiultimoidinserito() {
		return mysqli_insert_id($this->conn);
	}


	public function hasResults() {
		if ($this->recordCount > 0) {
			return true;	
		} else {
			return false;
		}
	}

	public function getRecordCount() {
		return $this->recordCount;
	}

	public function execSelect($sql){

		$rows = array();
		$cursor = $this->runSql($sql);
		if ($cursor !== FALSE) {
			if ($cursor === TRUE) return TRUE;
			
			$this->recordCount = mysqli_num_rows($cursor);
			while ($row = mysqli_fetch_assoc($cursor)) {
				$rows[] = $row;
			}
			
		} else {
			$this->recordCount = 0;
			mysqli_free_result($cursor);
			return FALSE;
		}

		mysqli_free_result($cursor);
		return $rows;
	}

	private function openConnection() {
		$this->conn = mysqli_connect(DB_HOST, DB_USER, DB_PSWD, DB_NAME);
		if (mysqli_connect_errno($this->conn)) {
			die('Errore nella connessione al database: '. mysqli_connect_error());
		}
	}


	private function closeConnection(){
		if (mysqli_ping($this->conn)) {
			mysqli_close($this->conn);
		} 
	}

	public function runSql($sql){
		if (!mysqli_ping($this->conn)) {
			$this->openConnection();
		} 
		if (isset($_GET['sql']) && (bool)$_GET['sql']) echo '<div class="dbg-box">'.$sql.'</div>';

		$ret =  mysqli_query($this->conn, $sql) or die (mysqli_error($this->conn).'<br>'.$sql);
		return $ret;              
	}


	public function startTransaction() {
		$this->runSql('START TRANSACTION;');
	}

	public function commitTransaction() {
		$this->runSql('COMMIT;');
	}

	public function rollbackTransaction() {
		$this->runSql('ROLLBACK;');
	}

	public function disableAutocommit() {
		$this->runSql('SET AUTOCOMMIT=0;');
	}

	public function enableAutocommit() {
		$this->runSql('SET AUTOCOMMIT=1;');
	}
}
?>