<?php

function getVersion() {

    $wellKnownVersions = [
        // WEB-C-DB-LEGACY-SYSTEM
        '4-4-F-10' => '1.0.0', 
        '4-5-F-10' => '1.0.1',
        '5-5-F-10' => '1.0.2',
        '6-5-F-10' => '1.0.3',
        '7-5-F-10' => '1.0.4',
        '8-6-F-10' => '1.0.5',
        '8-7-F-10' => '1.0.6',
        '9-7-F-11' => '1.0.7',
        '9-7-F-12' => '1.0.8',
        '9-7-F-13' => '1.0.9',
        '9-7-F-13-1' => '1.0.10', //SYSTEM_VERSION added first time here! 
        '9-7-F-13-2' => '1.0.11',  
        '9-7-F-13-3' => '1.0.12',  
        '9-7-F-13-4' => '1.0.13',  
        '9-8-F-13-4' => '1.0.14a1',  
        '10-8-F-14-4' => '1.0.14a2',  
        '12-10-F-14-4' => '1.0.15a1',
        '13-10-F-14-4' => '1.0.15a2',
        '14-11-F-14-5' => '1.0.15b1',
        '14-12-F-14-5' => '1.0.15b2',
        '15-13-F-14-6' => '1.0.15b3',
        '16-13-F-14-6' => '1.0.15', //Release fire alarm
        '17-13-F-14-6' => '1.0.16',  
        '18-14-F-14-6' => '1.0.17',  
        '19-15-F-14-7' => '1.0.18',
		'19-15-F-14-8' => '1.0.19',
		'20-16-G-15-8' => '1.0.20'
    ];

    define("SYSTEM_VERSION", 8);

    $rootPath = realpath($_SERVER['DOCUMENT_ROOT']);
    $legacyVer = file_get_contents($rootPath . '/hotel/ver.txt');

    $ver = "".APP_VERSION . "-" . PARAM_SERVER_VERSION . "-" . PARAM_DB_VERSION . "-" . $legacyVer . "-" . SYSTEM_VERSION;

    return [
        'full' => $ver,
        'summary' => @$wellKnownVersions[$ver]
    ];
}

?>
